2025-06-22 : *** Version 2.6.0 ***

2025-06-21 Nicolas Pomarède

        New release 2.6.0, update dates in corresponding files
        [60063edb]

2025-06-21 Nicolas Pomarède

        Remove SCC emulation from todo list (done since Hatari 2.5)
        [e71af322]

2025-06-19 Nicolas Pomarede

        Update release notes
        [029eecf7]

2025-06-19 Nicolas Pomarede

        Fix some typos (found with 'codespell')
        [a9ad639c]

2025-06-19 Nicolas Pomarede

        Update references to EmuTOS to latest version 1.4
        [abb55fac]

2025-06-16 Nicolas Pomarède

        Update WinUAE's CPU core (no change for Hatari) (from WinUAE 6.0.0
        beta32 2025/06/16)
        [f333f6df]

2025-06-13 Eero Tamminen

        Add some missing items to release notes

        These are missing ones for items that I've worked on myself (except 
        for keyboard repeat one). Notes for some of the changes done by
        others are still mising...
        [077c994c]

2025-06-13 Eero Tamminen

        Fix typo from previous commit

        Thanks to Christian for noticing this!
        [c8b3a7b1]

2025-06-13 Nicolas Pomarede

        MegaSTE's cache was incorrectly using 8 bits instead of 10 for the
        Tag value This could create crash in the emulated program when
        accesing some addresses in ROM space
        [1a033234]

2025-06-13 Eero Tamminen

        Fix Main_ErrorExit()

        Memory contents pointed by the string returned from SDL_GetError() 
        appear to be invalidated by SDL_Quit(), so that needs to be called 
        only after error string has been processed.

        Some ways to test this are giving:
        - 1000x size for SDL window creation
        - NULL window for SDL renderer creation

        Reported-By: Andreas Grabher
        [3d04678b]

2025-06-13 Eero Tamminen

        Fix for for Mac/BSD Dfree() issue

        Use f_frsize when it's set.

        Report, test program + investigation by Christian Zietz.

        (Also, use TOS defaults, if there's no total value.)
        [31585695]

2025-06-11 Eero Tamminen

        Add new ST/STE games to EmuTOS compatibility doc
        [b88758c6]

2025-06-10 Eero Tamminen

        Apply Andreas suggestions for Main_ErrorExit() usage

        * Call SDL_Quit() in Main_ErrorExit(), not (inconsistently) in
        callers.
         This way SDL_GetError() call for the details message actually
        works,
         as SDL_Quit() call would have cleared the error
        * Consistently capitalize the error messages
        [854422f3]

2025-06-10 Eero Tamminen

        Take huge host drives into account in GEMDOS HD Dfree()

        Current signed int variables would overflow with >2TB free or total 
        drive space, which is completely plausible nowadays.  Avoid that 
        with uint64_t.
        [cf60fee8]

2025-06-09 Eero Tamminen

        More defensive handling of statvfs() in Dfree()

        Zero struct, and check for negative value, in case given platform
        does not support "b_avail" field, or it is signed and could be
        negative.

        This will hopefully deal with disk free issue on Mac, reported on 
        emutos-devel.
        [710207b6]

2025-06-08 Eero Tamminen

        Update EmuTOS compatibility notes to new v1.4 release
        [ca60a449]

2025-06-07 Thomas Huth

        Use Fedora 41 for the MinGW job to avoid problem with
        mingw64-sdl2-compat

        Fedora 42 replaced the SDL2 library with mingw64-sdl2-compat that
        uses SDL3 as backend. Since we did not really test this yet, let's
        continue to use Fedora 41 for a while 'til we are sure that we can
        switch.
        [7fe8c825]

2025-06-07 Eero Tamminen

        Fix Windows build warning + update message

        Apparently fgetc() gets the key only after Enter/Return.
        [46313426]

2025-06-06 Eero Tamminen

        Minor updates to compatiblity docs
        [fe2f3ffe]

2025-06-06 Eero Tamminen

        Invoke Windows console also for other relevant exit errors

        Skips things that should not matter for Windows i.e. error exits
        that happen in the CLI console, are for small size alloc failures,
        or OSX.
        [89e19954]

2025-06-04 Eero Tamminen

        Open Windows console to show error + wait a key press before exiting
        [3ccb45cd]

2025-06-05 Eero Tamminen

        Update Python script shebang lines to latest recommendation

        "env" usage is deprecated nowadays:
        *
        https://docs.fedoraproject.org/en-US/packaging-guidelines/#_shebang_lines
        *
        https://www.debian.org/doc/packaging-manuals/python-policy/#interpreter-directive-shebang

        (RPM based distro packages for Hatari 2.5 were already removing it.)
        [08ae94c0]

2025-06-03 Nicolas Pomarède

        Small fix to VBL_ClockCounter when changing CPU speed on the fly 
        When CPU speed was changed without a reset, VBL_ClockCounter could
        have a wrong offset of 64/68 cycles during the next VBL
        [2ada4268]

2024-12-30 Eero Tamminen

        Misc documentation updates

        - Clarify what compatibility issue there is
        - Add new demo to EmuTOS compatibility
        - Use English abbreviation
        [46e37089]

2025-06-01 Thomas Huth

        Bump libpng version to 1.6.48

        The old version did not compile with the recent version of CMake
        anymore.
        [25f54997]

2025-06-01 Thomas Huth

        Update the Travis jobs from "focal" to "jammy"

        While we're at it, also update the list of packages that we require 
        for the compilation.
        [a114e6a5]

2025-06-01 Thomas Huth

        Remove the arm64 job from .travis.yml

        According to

        
        https://docs.travis-ci.com/user/billing-overview/#partner-queue-solution

        only ppc64le and s390x builds are still free for OSS builds, arm64 
        has been removed sometime in the course of last year. Thus drop this 
        job now to avoid to consume normal credits by accident here.
        [2b12af5e]

2025-06-01 Eero Tamminen

        tos-tester: test combos of specified bools

        Instead of just testing each separately.
        [d5e5c0bd]

2025-05-31 Eero Tamminen

        Improve documentation for new debugger commands
        [bc3539ae]

2025-05-31 Eero Tamminen

        Support optional <split> parameter for "struct" command

        To be used when output does not fit into single line on console.
        [6eb00d59]

2025-05-31 Eero Tamminen

        tos-tester: need to wait before checking files on disk

        At least with TOS v4 tests, e.g. writes to emulated serial device 
        were not otherwise fully on disk.
        [0279867e]

2025-05-30 Eero Tamminen

        tos-tester: improve bool option test filtering
        [2768c752]

2025-05-30 Eero Tamminen

        Simplify option help prints
        [d78e3dd5]

2025-05-29 Eero Tamminen

        Fix debugger CPU symbols leakage corner-cases

        Leakage happened for TOS symbols on resets, and for GEMDOS programs 
        when changing from one program with symbols to another. Reported by 
        ASAN tool.
        [494d580d]

2025-05-28 Eero Tamminen

        tos-tester: add PyLint make target + update readme
        [c2fe8fe1]

2025-05-28 Eero Tamminen

        tos-tester: improve Hatari bool options support
        [959b2d0d]

2025-05-29 Eero Tamminen

        python-ui: update docs + web links
        [d5a6a269]

2025-05-28 Eero Tamminen

        python-ui: fix some PyLint complaints

        Most of these are just code cleanup, but there was also bug in UI
        corner-case error path.
        [1abf5e37]

2025-05-28 Eero Tamminen

        python-ui: drop duplicates from generated Hatari config type lookup
        [7f10d6c1]

2025-05-28 Nicolas Pomarède

        Fix comment : MegaSTE cache is emulated
        [1e68f953]

2025-05-28 Eero Tamminen

        m68k-linux: update for v6.15

        Note: tested also WIP Atari DRM graphics driver for Linux, but it
        still needs some work until it can replace the legacy "atafb" 
        framebuffer driver.
        [12851bde]

2025-05-27 Eero Tamminen

        Add new Doom & ScummVM versions to compatibility docs

        Checked new Doom ports and latest upstream ScummVM 2.9.1 Atari
        release.

        Sort TT apps/games list entries alphabetically.
        [3ddb6a08]

2025-05-21 Nicolas Pomarède

        Use non-JIT FMOVEM also when JIT is enabled but JIT FPU is disabled
        (not used in Hatari) (from WinUAE 6.0.0 beta28 2025/05/21)
        [ec3108bd]

2025-05-20 Eero Tamminen

        Fix Python UI data cache setting mismatch
        [c13ced47]

2025-05-20 Eero Tamminen

        Fix crashes caused by too early command FIFO usage

        Read commands from socket/fifo only after all initializations are 
        done, because those commands can invoke something that needs to be 
        initialized first.  Before this change, e.g. screenshot request in 
        command-fifo test would crash Hatari if it was done soon enough
        (<0.1s) after Hatari start.

        This means screen being initialized for the first time won't anymore 
        trigger sending of embed-info, as it cannot be enabled at that time. 
        Therefore screen info needed to be send directly when embed-info is 
        enabled.
        [f2c61c51]

2025-05-18 Thomas Huth

        Avoid the "disable" in the name of the key repeat option for fast
        forward mode
        [a8bbb23f]

2025-05-12 Nicolas Pomarede

        Add option --disable-key-repeat-fast-forward to disable keyboard
        auto repeat while in fast forward mode
        [483dbfc0]

2025-05-10 Eero Tamminen

        Add STF47 games to EmuTOS compatibility list
        [cc38020d]

2025-05-11 Nicolas Pomarède

        Update WinUAE's CPU core version
        [77fe0dab]

2025-05-11 Nicolas Pomarède

        Use original extended FP conversion if JIT is enabled (not used in
        Hatari) (from WinUAE 6.0.0 beta26 2025/05/10)
        [8f480bed]

2025-05-11 Nicolas Pomarède

        For JIT, check spcflags first, it might be mode change (not used in
        Hatari) (from WinUAE 6.0.0 beta15 2025/03/17)
        [49b01386]

2025-05-10 Nicolas Pomarède

        Keep CPU in reset when pressing reset keys (not used in Hatari)
        (from WinUAE 6.0.0 beta14+ 2025/03/10)
        [ea8104cd]

2025-05-10 Nicolas Pomarède

        Update WinUAE's CPU core (no change for Hatari) (from WinUAE 6.0.0
        beta13+ 2025/03/10)
        [ecc99025]

2025-04-27 Eero Tamminen

        Add Catalan country code for EmuTOS

        EmuTOS v1.4 release (coming soon) will include support for that.
        [6ded6620]

2025-05-08 Eero Tamminen

        Update screen dialog section in manual
        [3730e95c]

2025-05-07 Nicolas Pomarède

        Fix counter when timer is stopped/restarted while counter is going
        from 1 to 0 In that case the counter will be reloaded with the
        latest timer data register, not with data=0 (=256) Although rarely
        used, this was a long standing bug since 2008/07/12 and is used in
        ST Connexion demos to save/restore MFP state
        [621ffc94]

2025-05-05 Nicolas Pomarède

        Add the 'awk' command to the mingw CI job (required to build capsimg
        library)
        [10bcedf2]

2025-05-04 Nicolas Pomarède

        Remove CYCLES_COUNTER_SOUND and CYCLES_COUNTER_CPU (not used
        anymore)
        [74be2620]

2025-05-04 Nicolas Pomarède

        Add support for accessing Shifter's resolution register at 0xFF8261 
        Unlike writing to 0xFF8260 which will change resolution register in
        both GLUE and Shifter, accessing 0xFF8261 will only change the
        Shifter's register, not the GLUE one. Writing res=3 to 0xFF8261 can
        be used as an alternative to stop the Shifter to create 4 pixel
        hardware scrolling
        [7c3f09ef]

2025-05-03 Nicolas Pomarède

        Remove commented code from GLUE part + update some log messages
        about resolution
        [1dc93ac1]

2025-05-03 Nicolas Pomarède

        When writing to $ff8260, use 2 different functions to handle GLUE
        and Shifter cases (instead of a common function) 4 pixels scrolling
        by stopping the shifter is now handled in Video_WriteToShifterRes()
        [e08d2af7]

2025-05-02 Thomas Huth

        Update the GPL text in the DSP code

        The Free Software Foundation does not reside in the Franklin Street 
        anymore. Update the license text to the latest version from the
        GPLv2.
        [ff7c5a98]

2025-05-02 Thomas Huth

        Update the GPL text in the documentation

        The Free Software Foundation does not reside in the Franklin Street 
        anymore. Update the license text to the latest version from the
        GPLv2.
        [562d0a82]

2025-05-02 Thomas Huth

        Silence some more warnings from Doxygen
        [e0fe0c3b]

2025-04-06 Thomas Huth

        Fix some warnings from Doxygen
        [b50190b0]

2025-04-05 Thomas Huth

        Remove obsolete settings from Doxyfile and disable GENERATE_HTMLHELP

        Latest version of Doxygen complains that some settings are
        deprecated and should be removed, so do that now. Also disable
        GENERATE_HTMLHELP: This also caused some warnings, and we don't need
        these "compiled" big index files for the website.
        [074eb120]

2025-03-31 Eero Tamminen

        Add Williams Defender to compat lists

        Discussed in: https://www.atari-forum.com/viewtopic.php?t=44685 
        Sources coming to: https://github.com/therealsark02/defender
        [86b9f307]

2025-03-29 Eero Tamminen

        m68k-linux: more info on Debian bootstrapping issues
        [bd7cfe2f]

2025-03-28 Eero Tamminen

        m68k-linux: update for v6.14
        [4accfd7c]

2025-03-18 Eero Tamminen

        Add compatibility notes for few new demos

        From the fantasy cracktro + Silly Venture 2024 events.
        [3622e521]

2025-03-30 Thomas Huth

        Update the SDL in the Visual Studio CI job

        The old version did not work with the latest version of CMake
        anymore
        [d8145699]

2025-03-30 Thomas Huth

        Update the FreeBSD CI job to v14.2

        The old version stopped working
        [ca8bd695]

2025-03-16 Thomas Huth

        Improve the emscripten CI build: Add demos, start in STE mode

        Provide the Hatari release demos as an example for the emscripten 
        build of Hatari, and start the emulator in STE mode so that it can 
        run the demos without reconfiguration.
        (Note: Skip the demo from v2.3 since it caused some troubles here)
        [d635e360]

2025-03-15 Thomas Huth

        Fix wrong path in previous commit
        [87c554b7]

2025-03-15 Thomas Huth

        Add a job to build Hatari via emscripten in the Gitlab-CI
        [e66430d0]

2025-03-14 Thomas Huth

        Avoid files from CMake in the doc folder when building the Windows
        package
        [f2bf08ac]

2025-02-16 Thomas Huth

        Build Windows binary artifacts with CAPSimg and PortMidi
        [5eec0d09]

2025-03-09 Thomas Huth

        Add script for compiling capsimg with mingw

        Big thanks to Christer Solskogen for providing the instructions!
        [e89c7b6b]

2025-02-14 Thomas Huth

        Move the Fedora CI job from Cirrus to Gitlab

        While we're at it, make sure that the RPM gets a proper version 
        based on "git describe" now.
        [37a4c01f]

2025-02-09 Thomas Huth

        Remove the github repo sync workflow (it's not required anymore)
        [e2edde38]

2025-02-09 Thomas Huth

        Fix types (found with codespell)
        [a9591d15]

2025-02-09 Thomas Huth

        Update hyperlinks to the new home of Hatari
        [1a48e4dc]

2025-02-05 Eero Tamminen

        m68k-linux: update for v6.13
        [07feb02e]

2025-01-27 Nicolas Pomarede

        If SCC_Get_RTxC_Freq() returns 0 then we consider serial interface
        is OFF
        [aa20640a]

2025-01-26 Nicolas Pomarède

        Add support for using TCCLK as RTxCB clock for the Atari TT's SCC 
        Timer C output from TT MFP can be used as the master clock RTxCB to
        compute the baudrate on the TT SCC when using channel B NOTE : no
        software is known so far to make use of this feature
        [a0b2a9d6]

2025-01-25 Thomas Huth

        Add an index for the documentation files
        [21778c0d]

2025-01-18 Thomas Huth

        Add pages job to deploy the docs to the website
        [e5b9cf0d]

2025-01-12 Thomas Huth

        Avoid shifting of negative values in Subsonic_IIR_HPF_Right, too

        It's undefined behavior according to the C standard, so let's use
        multiplication here instead. Compilers should be smart enough to
        optimize it properly.
        [2ab1b66d]

2025-01-15 Nicolas Pomarede

        Update WinUAE's CPU core version
        [3abc8f49]

2025-01-15 Nicolas Pomarede

        Sync changes for CE memory accesses (no change for Hatari) (from
        WinUAE 6.0.0 beta1 2025/01/04)
        [b34a66a0]

2025-01-12 Eero Tamminen

        Fix: ignore configured types also with MINT+ELF symbols
        [7052d48b]

2025-01-12 Eero Tamminen

        Fix: weak TEXT symbol detection for MINT+ELF binaries

        Weak symbol status is differentiated only with code symbols, not for 
        BSS & DATA ones.  As Hatari symbol handling has no separate defines
        / identifiers for those.
        [eb6f8aa0]

2025-01-12 Eero Tamminen

        Fix: issue with profile post-processor cost assignment

        If profile did not start on a symbol, program's first costs could be 
        assigned for "ST_RAM", instead of its first symbol or
        "PROGRAM_TEXT".
        [1bffbc0b]

2024-12-31 Eero Tamminen

        Add few ST games + STE demos to compatibility docs
        [6adcdeed]

2025-01-12 Thomas Huth

        Avoid shifting of negative values (it's undefined behavior)
        [0f7d471d]

2025-01-12 Nicolas Pomarède

        Fix undefined shifts (from WinUAE 6.0.0 beta4 2025/01/03, reported
        by Andreas Grabher))
        [e8e226c9]

2025-01-11 Thomas Huth

        Limit -fwrapv to the CPU code

        as suggested by Andreas, to keep Hatari in sync with Previous here.
        [2f3aa107]

2025-01-10 Nicolas Pomarede

        Sync changes for internal events system (not used in Hatari) (from
        WinUAE 6.0.0 beta1 2025/01/04)
        [9544baf6]

2025-01-08 Nicolas Pomarede

        Use uae_s8 to save/restore CPU's ipl regs (from WinUAE 6.0.0 beta1
        2025/01/04)
        [5cb3680a]

2025-01-08 Nicolas Pomarede

        Sync cpu changes for DMA/Copper (not used in Hatari) (from WinUAE
        6.0.0 beta1 2025/01/04)
        [d4e12d86]

2025-01-08 Nicolas Pomarede

        Sync debug changes for DMA/Copper (not used in Hatari) (from WinUAE
        6.0.0 beta1 2025/01/04)
        [d69e62ae]

2025-01-08 Nicolas Pomarede

        Sync DMA/Copper changes (not used in Hatari) (from WinUAE 6.0.0
        beta1 2025/01/04)
        [340a2fd2]

2025-01-07 Nicolas Pomarede

        Sync misc changes (no change for HAtari) (from WinUAE 6.0.0 beta1
        2025/01/04)
        [cb95026b]

2025-01-07 Nicolas Pomarede

        Remove unused lines in softfloat (from WinUAE 6.0.0 beta3
        2025/01/07)
        [63f65b15]

2025-01-06 Nicolas Pomarede

        Fix debugger assembler MOVEM (from WinUAE 6.0.0 beta1 2025/01/04)
        [d8bb9df0]

2025-01-06 Thomas Huth

        Add a switch to enable the undefined behavior sanitizer
        [108c56a1]

2025-01-06 Thomas Huth

        Fix a memory leak in the macOS code

        Thanks to Andreas Grabher for the patch!
        [d68bdd7e]

2025-01-04 Thomas Huth

        Use all CPUs in the gitlab-CI jobs
        [5740acfc]

2025-01-04 Thomas Huth

        Make sure that the 'file' utility is installed in the gitlab-CI job
        that needs it
        [7a7ba893]

2025-01-04 Thomas Huth

        Remove obsolete comment about CentOS 5

        CentOS 5 is out of service since a long time, nobody should still 
        use such an old system anymore (and Hatari likely also does not 
        compile there anymore since you need newer versions of SDL2 and 
        CMake to compile it nowadays). So let's remove this old paragraph.
        [458f3dbb]

2025-01-01 Nicolas Pomarède

        Don't use "extra_cycle" in do_cycles_ce(), STF/STE emulation can
        sometimes use an odd number of cycles Unlike Amiga emulation in
        WinUAE, we don't have to round cycles parameter to a multiple of 2
        CPU cycles. This is needed to correctly "resync" the cpu by adding
        wait states when CPU's memory accesses are not done on the expected
        time slot (for cycle accurate 68000 emulation in STF/STE mode)
        [f963af2c]

2024-12-29 Nicolas Pomarède

        For 68000 in cycle exact mode add wait states for all slots when bus
        is not available This is similar to
        wait_cpu_cycle_read/write_megaste_16() and allow the cpu to wait 
        also for 1 or 3 cycles, not just for 2 cycles (until the bus is not
        needed by the shifter anymore) This handles the case where global
        cpu counter can be odd after switching from 68030 to 68000 and the
        cpu needs to be "resync" on a 4n number of cycles (if not all 
        overscan tricks or color changes won't work anymore)
        [9eaff749]

2024-12-29 Nicolas Pomarède

        Fix the case where VBL_ClockCounter can be out of sync by 2 cycles
        after a reset This is caused by calling Video_Reset() from
        Video_InterruptHandler_VBL ; this should be fixed by handling
        shortcut keys from the main cpu loop, not from the VBL handler
        [1322200d]

2024-12-23 Nicolas Pomarède

        Remove remaining uses of CYCLES_COUNTER_VIDEO and use
        Video_GetCyclesSinceVbl() instead
        [6e0f7f3b]

2024-12-23 Nicolas Pomarède

        Preliminary work to remove use of CYCLES_COUNTER_VIDEO and replace
        it with CyclesGlobalClockCounter CYCLES_COUNTER_VIDEO was used to
        get a relative number of cycles since the start of the current VBL
        but it was handled in parallel to CyclesGlobalClockCounter which
        could cause problems in cycle accurate mode when
        CyclesGlobalClockCounter was updated and CYCLES_COUNTER_VIDEO was
        not in sync Instead of handling 2 different counters, the function
        Video_GetCyclesSinceVbl() will use CyclesGlobalClockCounter too
        [da5955dc]

2024-12-29 Eero Tamminen

        Fix typo in doc & STX log output (wd1172->wd1772)

        Reported-By: Christian Zietz <czietz@gmx.net>
        [ea449d00]

2024-12-11 Eero Tamminen

        Compatibility on few recent itch.io & other games

        Great puzzle games from Haplo, for ST:
        * Shift: https://h4plo.itch.io/shift
        * Tenebra-1: https://h4plo.itch.io/tenebra
        * Tenebra-2: https://h4plo.itch.io/tenebra-2
        * Toop: https://h4plo.itch.io/toop

        Other games:
        * Tony demo: https://demozoo.org/productions/362486/
        * Faster (STE only): https://retroracing.itch.io
        * Shotgun (STE enhanced): https://anarcholab.itch.io/shotgun-st
        * Shapes (TT etc): https://atari.joska.no/shapes/
        [d9791673]

2024-12-14 Thomas Huth

        Fix return value of the hmsa tool

        Thanks to Jean-Baptiste Queru for the bug report and analyzis!
        [18b9a293]

2024-12-04 Uwe Seimet

        Improve the mapping of the SCSI Driver interface to the Linux SG
        driver
        [910b4616]

2024-12-12 Eero Tamminen

        Symbol & file name completion for debugger commands missing it
        [19174167]

2024-12-07 Thomas Huth

        Make it possible to load keymaps with fallback to scancode mode
        [2428541e]

2024-12-10 Eero Tamminen

        emutos: all "68k Inside 2024" Atari demos work fine

        Rest of the demos in that party were (mostly) for Amiga...
        [6f8bc2fc]

2024-12-03 Nicolas Pomarede

        Update WinUAE's cpu core version to 5.3.1 (no change since previous
        version)
        [e2b79771]

2024-11-29 Nicolas Pomarede

        Indent with tabs instead of spaces
        [062f62ac]

2024-11-29 Nicolas Pomarede

        When stopping shifter the 4 pixel left hardscroll should start to
        apply on the next line, not the current line
        [7dd1f626]

2024-11-29 Nicolas Pomarede

        Add missing "\n"
        [36b3573c]

2024-11-28 Nicolas Pomarède

        Log SCSI Driver errors reported by the Linux SG driver (by Uwe
        Seimet)
        [3b481adb]

2024-11-24 Eero Tamminen

        Add --scsi-ver command line option

        To override the already existing config file option for SCSI
        version.

        Add a helper function for <drive>=<value> option argument parsing,
        as that was already done in 3 different places, and this adds one
        more.
        [8a09f232]

2024-11-22 Nicolas Pomarède

        Improve support for 4 pixel left hardscroll when stopping shifter
        (thanks to Rati/OVR) Rati/OVR wrote a test program to study the
        effects of stopping the shifter using various delays/positions,
        which was very useful to improve emulation of this effect. Not all
        combinations are emulated yet, but this should give better results
        for common cases
        [9c05eb71]

2024-11-21 Eero Tamminen

        m68k-linux: update for v6.12 + misc doc updates
        [953a0fc0]

2024-10-31 Eero Tamminen

        emutos: fix few doc typos
        [c8379b4b]

2023-12-09 Thomas Huth

        Fix include statements in JIT code
        [9bd38306]

2024-11-17 Thomas Huth

        Silence warning about comparing unsigned with < 0 (from Clang 19)
        [1638433b]

2024-11-16 Thomas Huth

        Fix REQUEST SENSE for newer SCSI versions

        It's normal to request more than 22 bytes with newer SCSI devices, 
        so don't warn in that case. And only return 4 bytes for "0 requests" 
        when emulating a SCSI-1 device - in later versions of the standard, 
        this oddity has been removed. Thanks to Uwe Seimet for the hint!
        [8f22c3f3]

2024-11-10 Thomas Huth

        Add the possibility to configure the SCSI version in the config file
        [78da00f0]

2024-11-12 Eero Tamminen

        Update m68k NetBSD compatibility info
        [9b115c14]

2024-11-09 Nicolas Pomarede

        Revert part of previous cmake change as it mistakenly applied to the
        macOS build
        [c50bbfcf]

2024-11-09 Thomas Huth

        Remove commented %patch line from the spec file

        Seems like the latest version of rpmbuild does not like this 
        commented line anymore, so let's simply remove it.
        [7d215998]

2024-11-09 Nicolas Pomarede

        Fix warnings with cmake >= 3.31 regarding policy CMP0175 and DEPENDS
        option CMP0175 specifies:
        * The ``TARGET`` form does not accept ``DEPENDS``,
        ``DEPENDS_EXPLICIT_ONLY``,
         ``DEPFILE``, ``IMPLICIT_DEPENDS``, ``MAIN_DEPENDENCY``,
        ``JOB_POOL``,
         ``JOB_SERVER_AWARE``, or ``USES_TERMINAL`` keywords.
        [2fe12785]

2024-11-09 Thomas Huth

        Remove ${FRAMEWORKS} from the CMakeLists.txt files

        These lines seem to be unused. While at it, also remove the 
        CMAKE_XCODE_ATTRIBUTE_OTHER_CODE_SIGN_FLAGS line that is commented
        out and not used anymore.

        Thanks to Andreas Grabher for the patch!
        [bc5999d3]

2024-10-28 Andreas Grabher

        Minor fix for file.c

        Unify the format of comments (there are three C++-style comments in 
        the file while all others are C-style) and make File_Open() safe in 
        case someone passes a NULL-pointer to it.
        [1cbc1e0a]

2024-10-15 Eero Tamminen

        Compatibility docs update
        [6c834921]

2024-10-27 Thomas Huth

        Silence VS warning about truncation from double to float
        [22cb60c8]

2024-10-27 Thomas Huth

        Make sure to include vs-fix.h in str.c to silence some more VS
        warnings
        [527ca994]

2024-10-27 Thomas Huth

        Silence Visual Studio compiler warnings about void functions
        returning a value
        [11f290b2]

2024-10-27 Thomas Huth

        Update the macOS XCode job to Sonoma

        Cirrus-CI stopped providing support for older vesrions of macOS and
        only provides a Sonoma container now (see
        https://cirrus-ci.org/guide/macOS/), so update our task description
        accordingly.
        [52d4c195]

2024-10-27 Thomas Huth

        Include direct.h for Visual Studio compilations to silence some
        compiler warnings
        [c6874d90]

2024-10-27 Thomas Huth

        Fix problem with strtok_s on Visual Studio
        [9dd3de15]

2024-10-26 Eero Tamminen

        m68k-linux: update documentation on things that work now

        SCSI boot progresses slightly further after previous fixes, but
        there are more things to fix before SCSI works well enough for
        Linux.

        Add (preliminary) section on debugging user-space issues with
        Hatari.

        Ptrace syscalls work after prefill fix, so move note about the
        prefill issue in earlier Hatari versions to a known issues section.
        [778078f1]

2024-10-25 Uwe Seimet

        Fix: Reject requests for MODE SENSE subpages

        Because subpages are not supported by Hatari.
        [76437c47]

2024-10-25 Uwe Seimet

        Fix: Wrong MODE SENSE data length for page code 0x3f

        The mode data length field when all pages are returned (page code 
        0x3f) is wrong. Instead of 44 it has to be 43. The SPC-5
        specification says: "The mode data length field indicates the number
        of bytes that follow in the mode parameter list". "Follow" is the
        important word here, because usually fields that contain a byte
        count do not count themselves. You also see that something is wrong
        with the current length field when running the SCSI Driver test
        suite.

        Without this patch it says:
        Page 0 (current, not savable)

        	Reading all mode pages with MODE SENSE (10)
        MODE SENSE (10) is not supported by device

        => empty line indicates that something is wrong.

        With the attached patch it says:
        Page 0 (current, not savable)
        0e:00:08:00:00:00:08:00:00:02:00:00:00:00:00
        Reading all mode pages with MODE SENSE (10)
        MODE SENSE (10) is not supported by device

        => 0e:00:08:00:00:00:08:00:00:02:00:00:00:00:00 matches the page 0
          data returned by Hatari.

        Btw. This data is not really correct, because it returns a
        hard-coded sector size of 512 bytes even when a different physical
        sector size is configured. But as long as this page is only there to
        please HDX it does not matter.
        [92eb6929]

2024-10-24 Nicolas Pomarède

        Add more details in traces for Xbios call 131 / 0x83 'Setbuffer'
        [a465f5f7]

2024-10-23 Eero Tamminen

        Fix compatibility table columns for Jam entry
        [6cc8adaa]

2024-10-22 Eero Tamminen

        Fix --benchmark mode speed printing + update option help
        [5439a18a]

2024-10-22 Eero Tamminen

        Update m68k-linux doc + release notes for prefetch fix
        [dfee1660]

2024-10-20 Nicolas Pomarède

        Force a reload of the prefetch words when doing a RTE after bus
        error for 68030+MMI page fault There's a bug in the current
        68030+MMU emulation that restores some wrong values for the 3
        prefetch words when using the content of a "frame b" stack frame 
        used in the case of a bus error for 68030 MMU page fault. This is a
        temporary fix to always reload the prefetch words from RAM instead
        of using the content of the "frame b" stack frame. This fixes
        booting some versions of Linux under TT / Falcon
        [06fc93b0]

2024-10-18 Nicolas Pomarede

        Add some debugging code to check for prefetch error when using
        68030+MMU and print them on stderr Defining
        WINUAE_FOR_HATARI_DEBUG_PREFETCH_030 at compile time will enable a
        different version of 'get_word_030_prefetch()' that compares the
        prefetched cpu words with the real content of the corresponding
        memory, with possible MMU translation. Any reported difference could
        indicate an error in the emulation of the 68030's prefetching code
        [64f88f15]

2021-10-10 Eero Tamminen

        Add defines for (some) of the ST scancode values

        Extracted from a patch by Vincent Barrilliot.
        [d7c7db7d]

2024-10-16 Nicolas Pomarede

        Also support logical address from the debugger using 'd' when the
        68030 MMU is enabled
        [1123928c]

2024-10-13 Nicolas Pomarède

        Support disassembling of logical addresses when 68030 MMU is enabled 
        When MMU is enabled on 68030, we must translate every instruction's
        logical address to its real physical address. If not, disassembly
        could be made from the wrong memory region and will give bad results
        (this can be the case when running Linux under Falcon or TT)
        [3d6a0721]

2024-10-13 Nicolas Pomarède

        Update WinUAE's cpu core version
        [f23939ad]

2024-10-13 Nicolas Pomarède

        Softfloat warning fixes (from WinUAE 5.3.1 beta3 2024/10/12)
        [f03e077a]

2024-10-12 Thomas Huth

        Do not print 'Checking:' for each TOS file that we load
        [4ee6102e]

2024-10-12 Thomas Huth

        Refactor the Keymap_LoadRemapFile function

        Splitting keymap host (PC) & guest (ST) value reads to separate 
        functions both improves function readability and prepares it for 
        further changes in later commits. Switching from strtok() to 
        strtok_r() might also be needed by later commits.

        Other improvements:
        - Declare variables in scope closer to their use
        - File missing issue warrants a warning, not just debug msg
        - Add separate debug log for loading of the keymap file
        - Use ARRAY_SIZE() instead of define as loop limit
        - Warn if rest of mappings have to be skipped
        - Use Str_Trim() on results to skip white space before parsed items
        - Check/warn about PC & ST scancode errors separately (with line
        number)
        - If there are warnings, tell about them in an error dialog too

        This patch is originally written by Eero Tamminen, partly inspired
        by changes in a patch by Vincent Barrilliot, and has later been
        modified by Yves Le Berre and Thomas Huth.
        [a22de575]

2024-10-06 Thomas Huth

        Symbolic mappings for Czech keyboard
        [03fdd795]

2024-10-06 Thomas Huth

        Change the defaul mapping of the SDLK_MINUS key

        It's used for 0x35 in more languages than it is used for 0x0C, so
        use the default for the majority here. That means that we now also
        have to provide a function for US mapping since the default mapping
        now differs for this country. Thanks to Brad Smith for the
        idea/original patch!
        [69034911]

2024-10-06 Thomas Huth

        Change the defaul mapping of the SDLK_HASH key

        It's used for 0x2B in a couple of languages, but only for 0x29 in
        German (and Czech which has not been implemented yet), so use the
        0x2B as a default for the majority here. Thanks to Brad Smith for
        the idea/original patch!
        [b148d18d]

2024-10-05 Thomas Huth

        Add XCODE_ATTRIBUTE_PRODUCT_BUNDLE_IDENTIFIER for compiling with
        XCode

        Add an attribute that is required when building with Xcode. Thanks
        to Andreas Grabher for the patch!
        [01aa0777]

2024-10-05 Thomas Huth

        Remove obsolete environment variable SDL_DISABLE_LOCK_KEYS

        This environment variable no longer exists in SDL2. Thanks to
        Andreas Grabher for the patch!
        [d2eb400f]

2024-10-05 Thomas Huth

        Add some comments about non-obvious mappings to special ST keys

        Thanks to Brad Smith for his original patch
        [58e068b0]

2024-10-05 Thomas Huth

        Use TOS_LANG_* definitions instead of "magic" numbers

        Thanks to Eero for the hint.
        [e1190df3]

2024-10-03 Thomas Huth

        Try to get keyboard layout from NVRAM for multilanguage TOS versions
        [5b20b87d]

2024-10-03 Thomas Huth

        Symbolic mappings for Dutch TOS
        [73491b45]

2024-10-03 Thomas Huth

        Symbolic mappings for Danish TOS
        [8111367d]

2024-10-03 Thomas Huth

        Symbolic mappings for Norwegian TOS
        [59b5cf2c]

2024-10-03 Thomas Huth

        Symbolic mappings for Swiss (French and German variants) TOS

        Thanks to Brad Smith for his original idea/patch
        [04ca9dc3]

2024-10-03 Thomas Huth

        Symbolic mappings for Swedish/Finish TOS

        These two languages seem to use the same mapping.

        Thanks to Brad Smith for his original idea/patch
        [ab95b9a3]

2024-10-03 Thomas Huth

        Symbolic mappings for Italian TOS

        Thanks to Brad Smith for his original idea/patch
        [b7e8ddb9]

2024-09-15 Thomas Huth

        Symbolic mappings for Spanish TOS

        Thanks to Brad Smith for his original idea/patch
        [a7179e01]

2024-09-15 Thomas Huth

        Symbolic mappings for UK TOS

        Thanks to Brad Smith for his original idea/patch
        [a4d37699]

2024-09-15 Thomas Huth

        Symbolic mappings for French TOS

        Thanks to Brad Smith for his original patch.
        [9f68410d]

2024-09-15 Thomas Huth

        Symbolic mappings for German TOS

        Based on a patch/idea from Brad Smith
        [3889d5bf]

2024-09-15 Thomas Huth

        Symbolic keymapping per-country interface

        TOS setup informs keymapping information which country is active. 
        Each country will get an appropriate symbolic map later. Code based
        on a patch/idea by Brad Smith.
        [48b33ebc]

2023-08-27 Brad Smith

        Symbolic map of SDLK_MINUS should use US minus scancode
        [52175091]

2024-10-02 Eero Tamminen

        NatFeats: trace also rest of erronous calls
        [a54a9aae]

2024-10-01 Eero Tamminen

        m68k-linux: update kernel known issues list
        [c7dd36c9]

2024-10-02 Eero Tamminen

        m68k-linux: improve LILO function name + comments
        [bc9c4297]

2024-09-23 Eero Tamminen

        m68k-linux: update files to latest Linux release (v6.11)

        v6.11 includes the fix to TT SCU setup, so patch for that can be 
        dropped.  Also squashed the doc patch to PSG-A setup fix patch, and
        updated patches to pass kernel "checkpatch.pl" tool.
        [74f5d7fb]

2024-09-25 Nicolas Pomarede

        Remove debug code in memory access functions
        [17bec54e]

2024-09-25 Nicolas Pomarede

        Remove unnecessary WinUAE #ifdef in Hatari's specific part
        [737862f5]

2024-09-21 Nicolas Pomarede

        Correctly set default values for DCD and RTS when RS232 emulation is
        not enabled
        [0dd31b66]

2024-09-21 Nicolas Pomarede

        Add a more accurate display rendering when MMU config at $FF8001
        doesn't match the physical RAM Fix intro part in demo 'Ika I
        Compofylla' by Newline when running in MegaST mode with 4MB RAM :
         hatari --machine megast -s 4 ikaifill.tos In case MMU config does
        not match real RAMi size, we must translate the video address on
        every word used by the shifter to display the screen. This requires
        a slower version of memcpy that does an address translation on every
        word. This mode is very rarely used, emulation performance should
        not be impacted in normal cases
        [aced198b]

2024-09-21 Nicolas Pomarede

        RS232 port on MFP now supports DCD and RTS signals
        [5f91fb32]

2024-09-20 Nicolas Pomarede

        Add missing include, ioctl() was not called to get DCD/CTS status
        for RS232
        [1541a63b]

2024-09-20 Nicolas Pomarede

        RS232 bits at $FFFA01 for DCD,CTS and RI are inverted (0=ON)
        [b923a323]

2024-09-18 Nicolas Pomarede

        When using MFP's RS232 port, set the value of DCD/CTS signals in bit
        2 and 3 at $FFFA01 If the underlying OS file used to emulate the
        RS232 port is a TTY, we use ioctl() to get the values of DCD and CTS
        [77d7abdb]

2024-09-18 Nicolas Pomarede

        Group variables in a common structure + store the result of
        fileno()/isatty()
        [008ba111]

2024-09-05 Eero Tamminen

        Add couple of new games to compatibility docs + fix typos
        [bdceb22d]

2024-09-16 Eero Tamminen

        GEMDOS HD: skip SNext() trace output when it's part of SFirst()

        Using SNext() as SFirst() implementation helper is not an OS call.
        [6515e166]

2024-09-16 Eero Tamminen

        GEMDOS HD: fix successive FsNext() calls with different attribs

        Fixes previous commit, by using the internally stored attribute 
        value, instead of DTA modified for the return value.
        [cabea55f]

2024-09-08 Eero Tamminen

        GEMDOS HD: fixes for file attribute handling corner-cases

        Instead of using in Fsnext() a (global) attribute value set by 
        previous Fsfirst() call, store it to internal DTA entry.  This fixes 
        case where program first Fgetdata()s multiple DTAs with _different_ 
        attributes from Fsfirst() calls, and then does Fsnext() calls while 
        switching between those earlier acquired DTAs with Fsetdta().

        Support volume labels also in case when archive and/or read-only 
        attributes are specified, with the new IS_VOLUME_LABEL() macro.

        Use correct attribute value also for volume labels returned from
        Fsfirst().

        Improve related code comments & warning messages and update docs.
        [8e0e3880]

2024-09-05 Nicolas Pomarede

        Change comment
        [8dc3dd9a]

2024-09-04 Eero Tamminen

        Fix: regression for exiting fileselector using keyboard

        Fixes: bd8a07aef850

        Which caused exit keys NOT to work with fileselector
        (almost always i.e. randomly from users point of view).

        Disable that corner-case fix when event function exits already on 
        first keydown, like file selector does, so that user can still exit 
        such dialogs using keyboard.
        [e1ed88b3]

2024-09-04 Nicolas Pomarede

        Add hit/miss counters for the profiler when using MegaSTE's cache
        [fc3376a2]

2024-09-04 Nicolas Pomarede

        Also call M68000_Flush_All_Caches() from STMemory_SafeClear() + fix
        call in STMemory_SafeCopy
        [3925bafd]

2024-09-03 Nicolas Pomarede

        Update release notes with the MegaSTE's 16 KB cache support
        [ccb45122]

2024-09-03 Nicolas Pomarede

        Add a call to M68000_Flush_All_Caches() in STMemory_SafeCopy() Since
        we modify the RAM content directly from the emulator, we must ensure 
        all cached data are flushed (for MegaSTE cache or for >=68020 CPU) 
        If not, the emulated programs might crash sooner or later
        [4c803f1b]

2024-09-01 Nicolas Pomarède

        In M68000_Flush_All_Caches() also flush the MegaSTE's cache
        [2d916d9f]

2024-09-01 Nicolas Pomarède

        In case of "byte read" access update the MegaSTE's cache with the
        corresponding word When a byte is read from RAM/ROM, the bus will
        carry the whole 16 bits at this address and the CPU will keep only
        the upper or lower byte. Thus, we can update the cache entry with a
        word, not just a byte.
        [1f59add1]

2024-08-30 Nicolas Pomarède

        Update version number to 2.6.0-devel
        [37903537]

2024-08-30 Nicolas Pomarède

        Add MegaSTE's cache to the memory snapshot
        [dc653a60]

2024-08-29 Nicolas Pomarède

        Flush the MegaSTE's cache when DMA is used for FDC and HDC transfers 
        Thanks to Christian Zietz for the informations on this behaviour
        [16eb381b]

2024-08-28 Nicolas Pomarède

        Flush the MegaSTE's cache when a bus error occurs or when blitter
        requests the bus Thanks to Christian Zietz for the informations on
        this behaviour
        [e0d5ce01]

2024-08-28 Nicolas Pomarède

        Add some debugging code to check the MegaSTE's cache consistancy 
        Defining MEGA_STE_CACHE_DEBUG_CHECK_ENTRIES at compile time will
        compare all the entries in the cache with the real content of the
        RAM, reporting any difference
        [517b94dd]

2024-08-28 Nicolas Pomarède

        In MegaSTE_Cache_Update() check that Addr is cacheable
        [4136a4cc]

2024-08-28 Nicolas Pomarède

        Fix the conversion Address -> Line / Tag in
        MegaSTE_Cache_Addr_Convert()
        [8b2f7c1d]

2024-08-27 Nicolas Pomarède

        Add cycle accurate cache emulation for the MegaSTE running at 16 MHz 
        The MegaSTE has a 16 KB external cache that can store the results of
        read and write accesses. The cache can be enabled when the CPU runs
        at 16 MHz. The inner work of the cache was deduced by running some
        custom test programs on a real MegaSTE, as well as using
        documentation by Christian Zietz
        [ae49f557]

2024-08-22 Nicolas Pomarède

        For MegaSTE, cycle accurate accesses to RAM when CPU is set to 16
        MHz instead of 8 MHz When the CPU is set to 16 MHz the GSTMCU will
        still work as if the CPU was at 8 MHz. This means that even if the
        CPU is faster it will be slown down by the "slow" RAM whose accesses
        are shared between the CPU and the shifter. In the end, at 16 MHz
        without cache the results are roughly the same than at 8 MHz Before
        this change Hatari was working as if RAM was twice faster when CPU
        was at 16 MHz, which is not the case
        [38799cc5]

2024-08-22 Nicolas Pomarède

        In IoMem_UnInit add the machine's type to uninit
        [4aeaf11b]

2024-09-02 Eero Tamminen

        2 trivial doc fixes

        Verified that Jam-player does not have issue any more.

        Fixes: 2ad6602201c
        [cba389e8]

2024-09-01 Thomas Huth

        Removed the --disable-small-mem configure option

        The small mem mode is stable now, uses less memory and even still
        seems to be at least as fast as the other mode, so it is the one and
        only default mode now
        [1b9f11c3]

2024-09-01 Thomas Huth

        Update docs with Falcon mono mode fix
        [2ad66022]

2024-08-25 Thomas Huth

        Fix Falcon monitor frequency calculation

        We were using 50 Hz for monochrom monitor here, which is of course 
        completely wrong and was causing issues e.g. in the JAM music
        player. Fine-tune the frequency calculation with more videl
        registers fixes the issue.
        [649939df]

2024-08-31 Uwe Seimet

        Fix for NF SCSI Driver

        This patch fixes a SCSI Driver issue with recent Linux SG driver 
        implementations. The SG driver's error handling has changed, and it
        is required to (also) check the sense data when ioctl reports no
        issue.
        [e4636b94]

2024-08-20 Eero Tamminen

        docs: minor updates
        [9ff4b192]

2024-08-12 Eero Tamminen

        docs: add Jam player to compatibility docs

        Tested also that MIDI plugin for Jam works:
        * https://github.com/agranlund/atarisound/tree/main/bin/jamplugins
        * https://www.atari-forum.com/viewtopic.php?p=467604

        Music timings issue in Falcon monochrome mode is common for all 
        plugins (even MIDI one):
        * https://www.atari-forum.com/viewtopic.php?p=467927#p467927

        According to Anders, it does not happen on real HW, only in Hatari.
        [9c2ef313]

2024-08-17 Thomas Huth

        Improve the 10x16 font (fix some broken characters, make checkboxes
        nicer, etc.)

        Big thanks to Andreas Grabher and the NeXT community for the update!
        [25142f25]

2024-08-11 Eero Tamminen

        GEMDOS HD: include Chdir() & Frename() calls to "os_base" traces

        They are relevant calls which do not generated much trace "noise".

        (Dir & file create + rm are already traced, and those cannot be 
        understood unless one knows the dir in which those happen.)
        [f86d067a]

2024-08-12 Eero Tamminen

        docs: add compatibility on rest of "Sommarhack 2024" demos

        All work fine both with Hatari and EmuTOS.  As they're ST demos
        (except for SpaSTiba), they're added only to EmuTOS doc.
        [7e002897]

2024-08-04 Thomas Huth

        Drop unused parameter hscrolloffset in hicolor modes
        [bc9504de]

2024-08-06 Eero Tamminen

        docs: compatibility on (some) "Sommarhack 2024" party entries
        [48fbfac2]

2024-08-05 Eero Tamminen

        m68k-linux: update support to Linux v6.10 (latest)

        And correct information about CPU data cache.  Disabling that is 
        enough to fix issues only for 040 & 060 emulation, to fix issues
        with 030(+MMU) emulation, cycle-exact & prefetch emulation need also
        to be disabled.

        Fix also few doc typos.
        [e1a14cce]

2024-08-05 Eero Tamminen

        debugger: drop implemented features from TODO
        [a3d7c439]

2024-08-05 Eero Tamminen

        debugger: change 'a' (ASCII) options to to 'c' (character) options

        To indicate they support now all Atari characters, not just ASCII
        ones.

        Except for "struct" command, 'a' options were added in this same 
        patch series, and "struct" command is present only in Git version, 
        so impact of the change should be minimal.
        [9c743c2c]

2024-08-05 Eero Tamminen

        debugger: add "find" command for CPU memory

        Share query helper for quitting command listing with symbols code.
        [224d3ddf]

2024-08-05 Eero Tamminen

        debugger: add helper for querying user whether to quit listings

        To be used in next commit.
        [0668e987]

2024-06-05 Eero Tamminen

        debugger: support ASCII value args for memwrite command

        To make sure characters are interpreted correctly, expose str.c 
        functions for host->atari encoding conversions, and use those.
        [bda7fb77]

2024-08-04 Eero Tamminen

        strings: return false if encoding functions could not map (all)
        chars

        E.g. if string was empty. This is in preparation for later
        commit(s).

        (All encoding functions are updated for consistency.)
        [68dde268]

2024-08-04 Eero Tamminen

        strings: move HD option checks from encoding to file functions

        In preparation for using encoding also with other strings, not just
        with filenames.

        Function names were changed for consistency.
        [7cf2fcd9]

2024-08-02 Thomas Huth

        Scale mouse movements when the window is resized
        [e626a8ee]

2024-08-02 Thomas Huth

        Move mouse pointer when leaving/re-entering the window to keep it in
        sync
        [ccf32fbd]

2024-07-27 Eero Tamminen

        GEMDOS HD: handle additional '*' chars at end of file mask

        Fixes UVK directory search: 
        https://www.atarimania.com/utility-atari-st-ultimate-virus-killer_35365.html

        Fsfirst() test program by: Roger Burrows

        Reported by: Christian Zietz
        [ff65d14c]

2024-07-26 Eero Tamminen

        m68k-instructions.py: fix relevant pylint items

        And change prompt to singular form as it accepts only single 
        instruction name.
        [5de7e46a]

2024-07-25 Thomas Huth

        Add wrapper function for setting mouse visibility in GUI

        This avoids risky mixing of types (SDL_ShowCursor() takes and
        returns an int but is used with bools), and it will make it easier
        to port to SDL3 later because only one central function in main.c
        needs to be ported.

        Thanks to Andreas Grabher for the patch!
        [946054f4]

2024-07-20 Thomas Huth

        Ignore SDL_KEYMAPCHANGED events in the SDL GUI

        On some systems there seem to occur continuous SDL_KEYMAPCHANGED
        events. To prevent them from messing up GUI handling we should
        actively ignore them.

        Thanks to Andreas Grabher for the patch.
        [99e31f41]

2024-07-20 Thomas Huth

        Don't mix scancodes and symbolic keys

        Even if they are likely to match for the keys in this case, mixing
        them introduces an unnecessary possible source of bugs in case the
        mapping might differ.

        Thanks to Andreas Grabher for the patch.
        [9b38b193]

2024-07-20 Thomas Huth

        Silence compiler warnings when compiling without tracing
        [27c8d64d]

2024-07-20 Thomas Huth

        Reset natfeat SCSI subsystem when doing a soft-reset from the Atari
        side

        When you reset the Atari within the emulation (by calling os_start
        in SYSHDR) SCSI Driver handles in nf_scsidrv.c may still be open.
        With a real Atari there is no need to close a handle before a reset,
        because the HW reset implicitly clears the handles. With Hatari it's
        different, because the external handle in nf_scsidrv.c remains open
        after a reset triggered by an application. As a result you run out
        of external handles. This happens, for instance, when you partition 
        a native Linux device with HDDRUTIL and then let HDDRUTIL execute a
        reset.

        To fix the issue, call the nf_scsidrv_reset() when the CPU executes 
        the RESET instruction which should happen everytime when the code
        jumps back to the beginning of the TOS ROM.

        Thanks to Uwe Seimet for this patch!
        [596b8de7]

2024-07-12 Nicolas Pomarède

        Only call SDL_SetPaletteColors if pBgSurface is not NULL (patch by
        Andreas Grabher)
        [5288383b]

2024-07-05 Eero Tamminen

        Prevent invalid joystick mapping causing invalid array access

        Reported-by: Cyclohexane

        Reviewed-by: Thomas Huth <th.huth@posteo.de>

        Link: https://www.atari-forum.com/viewtopic.php?t=43967
        [f28646d3]

2024-07-06 Thomas Huth

        Ignore first key-up event in sdl gui in case the key had been
        pressed before

        Otherwise we could exit the dialog immediately though the key was
        not meant for controlling the dialog, but rather for the emulation
        side.
        [bd8a07ae]

2024-07-03 Nicolas Pomarede

        MegaSTE cache control at $FF8E21 bit 0 can only be set if CPU speed
        is 16 MHz When CPU speed is 8 MHz, bit 0 will be forced to 0 (no
        cache)
        [2680af99]

2024-06-28 Eero Tamminen

        Update docs to latest changes
        [5d8d528c]

2024-06-28 Nicolas Pomarede

        Fix memory snapshot reloading when MMU is enabled (TT0/TT1 context
        was not correct) Although MMU's TT0 and TT1 were saved and restored,
        some internal states in mmu030.transparent.ttX were not updated,
        which could prevent some logical addresses from being translated to
        their physical equivalent, making the 68030 crashes sooner or later
        [539ed87c]

2024-06-24 Laurent Sallafranque

        DSP fix: JMP can form a long interrupt instruction

        Motorola documentation explains that JSR forms a long interrupt 
        instruction, but JMP works also.

        Extract from Motorola doc A long interrupt is formed if one of the
        interrupt instructions fetched is a JSR instruction. The PC is
        immediately released, the SR and the PC are saved in the stack, and
        the jump instruction controls where the next instruction is fetched
        from. While either an unconditional jump or conditional jump can be
        used to form a long interrupt, they do not store the PC on the
        stack; therefore, there is no return path.

        This fix allows VOXXX.PRG to work
        [fc50bc35]

2024-06-21 Nicolas Pomarede

        Remove SCU_SetEnabled() and check MachineType in SCU_IsEnabled() 
        This prevents problem at cold boot when Reset() is called before
        IoMem_Init() and SCU was seen as not enabled during reset, even if
        machine was MegaSTE or TT
        [2c6804e3]

2024-06-14 Eero Tamminen

        m68k-linux: add WA for Linux bug on TT + minor doc updates
        [2636e7f7]

2024-06-19 Eero Tamminen

        Update Python tools to recent changes
        [39989b8a]

2024-06-18 Nicolas Pomarede

        Init SCU for MegaSTE / TT in our fakeTos (needed when running "make
        test")
        [ca525650]

2024-06-18 Nicolas Pomarede

        Fix comment
        [2ce29d30]

2024-06-16 Nicolas Pomarede

        Use a define for handling IO mem region instead of 0xFF8000
        [a7603ea2]

2024-06-16 Nicolas Pomarede

        Use IoMem_Intercept() to set read/write handlers for DSP IO
        registers
        [8a3347da]

2024-06-16 Nicolas Pomarede

        Typo in comment FF80001 -> FF8001
        [63281341]

2024-06-16 Nicolas Pomarede

        Use a common function IoMem_Intercept() to set read/write handles
        for IO registers
        [4af3106a]

2024-06-15 Nicolas Pomarede

        Rename vme.c to scu_vme.c for readability as most of the code is
        related to the SCU chip, not VME bus
        [9329ec3a]

2024-06-15 Nicolas Pomarede

        Replace log type TRACE_VME with TRACE_SCU to better match the TT doc 
        According to TT doc, regs $FF8E01-$FF8E0F are part of the SCU chip,
        not VME VME traces can be added later when Hatari supports external
        board using the VME bus
        [1cd543a9]

2024-06-15 Nicolas Pomarede

        Remove "--vme" option from documentation
        [ddfbb83c]

2024-06-15 Nicolas Pomarede

        Remove unused "--vme" option (=none or dummy) now that SCU is always
        emulated for MegaSTE / TT
        [d403e19a]

2024-06-15 Nicolas Pomarede

        Always enable SCU when using MegaSTE or TT machines
        [f4a3588e]

2024-06-14 Nicolas Pomarede

        In M68000_SetIRQ() / M68000_ClearIRQ() call SCU_SetIRQ_CPU() /
        SCU_ClearIRQ_CPU() when using MegaSTE / TT This enables SCU support
        for MegaSTE and TT. All interrupts will be sent to the SCU which
        uses 2 masks to apply or not the interrupt to the CPU's
        pendingInterrupts
        [916129df]

2024-06-14 Nicolas Pomarede

        Don't change 'pendingInterrupts' directly, use M68000_SetIRQ /
        M68000_ClearIRQ instead
        [24292be1]

2024-06-14 Nicolas Pomarede

        SCU : read/write for all registers, update CPU's pendingInterrupts
        based on SCU's mask and status for system and vme
        [ba51a1e2]

2024-06-12 Nicolas Pomarede

        Add bCold parameter to SCU_Reset, clear GPR1 and GPR2 only on cold
        boot GPR1 is used by the TOS : if some extra VME memory is detected
        at 0x01000000 then TOS will set bit 0 in GPR1 at $FF8E09 to skip the
        memory test on the next reboot
        [049b3a2c]

2024-06-01 Nicolas Pomarede

        Add Level 1 CPU interrupt (SCU soft interrupt on MegaSTE/TT)
        [ac044bdd]

2024-05-31 Nicolas Pomarede

        Add an SCU objet to group all registers + save/restore SCU in memory
        snapshots
        [aaa0197d]

2024-06-16 Thomas Staudinger

        cmake: Use FindPython instead of deprecated FindPythonInterp

        Bumps required cmake version to 3.12

        Signed-off-by: Thomas Staudinger <Staudi.Kaos@gmail.com>
        [10932c0b]

2024-06-09 Laurent Sallafranque

        DSP AGU code polishing. Added comments for MOVEM instructions,
        rewrite some variable types for better readibility and data typing.
        [cce48194]

2024-06-05 Laurent Sallafranque

        DSP_fix : remove a compiler warning Replace 65535 by -1 for modulo
        register testing
        [bd157dbe]

2024-06-04 Yves Le Berre

        python-ui: add missing closing parenthesis to checkbox texts
        [5cd7b10e]

2024-06-03 Eero Tamminen

        Fix manpage --ttram option description
        [9b316a68]

2024-05-14 Eero Tamminen

        m68k-linux: Debian 12 has working (user-space) qemu-m68k
        [322c2750]

2024-05-14 Eero Tamminen

        m68k-linux: update Debian installer docs / status (bad)
        [57ed7b15]

2024-05-14 Eero Tamminen

        m68k-linux: update to v6.9 + misc doc updates
        [4b92d736]

2024-06-03 Nicolas Pomarede

        Enable option in WinUAE's disassembly to show resulting address for
        relative Bcc/JMP/... Instead of displaying
         00FC0000 602E   bra.b #$2E We now display
         00fc0000 602e   bra.b #$2e == $00fc0030 (T)
        [f97c9516]

2024-06-03 Nicolas Pomarede

        Update WinUAE's cpu core version to 5.3.0
        [685cfd7a]

2024-06-03 Nicolas Pomarede

        Add PC value in nvram's traces
        [befcd2ce]

2024-06-03 Laurent Sallafranque

        DSP add AGU pipeline and Rx, Nx, Mx restrictions.

        Add emulation of the DSP AGU pipeline for parallel moves
        instruction. Rx, Nx and Mx registers suffers a 1 instruction delay
        when they're used to generate an indirect move instruction.

        This fix the rendering of the tridi scene in the underscore demo.
        (The demo still crashs later).
        [7d79a49d]

2024-06-03 Laurent Sallafranque

        Fix previous patch: up to 12 slots are needed, not 10, when tracing
        the RESET instruction.
        [6c49b753]

2024-06-03 Laurent Sallafranque

        DSP_DEBUG fix dsp trace of instruction RESET Reset instruction set
        to initial values 12 registers. It's the only case when 12 memory
        addresses can be changed at once. In this special case, the 2 slots
        were not enough, and writing the modified memory changed
        informations corrupted the PC register.
        [e368c259]

2024-06-03 Laurent Sallafranque

        DSP add some defines for SCI registers
        [061685e4]

2024-06-03 Laurent Sallafranque

        DSP_DEBUGGER fix : add stack pointer mask This allow to always
        display the correct stack position in the debugger, also when the
        stack underflow or stack overflow bits are set is SP register.
        [baad2592]

2024-05-15 Nicolas Pomarede

        Fix path to unzip in Cirrus-CI macos12_task
        [3bbaa031]

2024-05-15 Nicolas Pomarede

        In Cirrus-CI macos12_task, use a self signed version of capsimage
        framework If framework is not signed, final codesign for Hatari.app
        will fail
        [2028fa1f]

2024-05-14 Nicolas Pomarede

        In Cirrus-CI macos12_task, copy capsimage framerwork to
        src/hatari.app/Contents/Frameworks/ before signing the app
        [275cb28f]

2024-05-14 Nicolas Pomarede

        Fix indent in Cirrus-CI macos12_task
        [72ed21ce]

2024-05-14 Nicolas Pomarede

        Add the CapsImage framework to the macOS bundle (if available),
        handle IPF/CTR floppies
        [f8d04fcd]

2024-05-14 Nicolas Pomarede

        Download and install a precompiled capsimage framework for the
        Cirrus-CI macos12_task
        [ddc3144c]

2024-05-11 Eero Tamminen

        More Falcon games work with EmuTOS

        If one selects specific monitor / gfx mode beforehand
        [613e5670]

2024-05-09 Laurent Sallafranque

        Typo fix: remove 2 backline at end of function.
        [cc9fe8f3]

2024-05-09 Laurent Sallafranque

        Add: display the DSP disasm stack.
        [741b8648]

2024-05-08 Eero Tamminen

        Add number bases support to "struct" command
        [e77cda26]

2024-05-05 Eero Tamminen

        Debugger "struct" command for breakpoint output
        [5d61f546]

2024-05-05 Eero Tamminen

        Always align memdump ASCII columns

        Fixes: ea6cbab756
        [b6f8d430]

2024-05-05 Eero Tamminen

        Split memdump code to separate helper functions

        So that they can be used later, in new "struct" command.
        [5112077d]

2024-05-05 Eero Tamminen

        Variable + debug symbol names support for more commands
        [a8d8dc0f]

2024-05-01 Eero Tamminen

        Also Neurobot supports joypad
        [f6c0f1a9]

2024-05-03 Nicolas Pomarede

        Update WinUAE's cpu core version
        [2c62bfed]

2024-05-03 Nicolas Pomarede

        uae_u32 -> uaecptr (patch by Andreas Grabher) (from WinUAE 5.3.0
        beta6 2024/05/02)
        [501f6aca]

2024-05-03 Nicolas Pomarede

        Improve stateload cpu tracer error check (from WinUAE 5.3.0 beta3
        2024/04/04)
        [e6abc754]

2024-05-03 Nicolas Pomarede

        Debugger f <addr> <extra parameters> fixed (not used in Hatari)
        (from WinUAE 5.3.0 beta3 2024/04/03)
        [afac38b6]

2024-05-01 Nicolas Pomarede

        Increase memory snapshot version
        [b3530756]

2024-05-01 Nicolas Pomarede

        Add YM2149_Freq_div_2 to the memory snapshot (patch by Brad Smith)
        [6a91e6fb]

2024-05-01 Eero Tamminen

        Compatibility update for full TC mode support in EmuTOS git

        Name 128/256 byte intros as "bytros".
        [19083537]

2024-05-01 Eero Tamminen

        Fix SCC channel B (non-existing) LAN file handles

        Reported-By: Brad Smith (rainwarrior)
        [582dd8d0]

2024-04-27 Thomas Huth

        Compile with -Wvla if available

        Variable length arrays don't work with VisualStudio, so let's better 
        warn about using them when compiling with GCC/Clang
        [6849a7e9]

2024-04-27 Thomas Huth

        Disable VisualStudio warning about conversion from 'size_t' to 'int'
        [16fcb20c]

2024-04-25 Eero Tamminen

        Use fixed buffer for path instead of VLA

        As MS VS compiler barfs on VLAs.
        [6fed6c95]

2024-04-25 Eero Tamminen

        Update variable type to match fread() return values (size_t)
        [3911bf92]

2024-04-24 Nicolas Pomarede

        Rename alert styles deprecated since macOS 10.13 + drop aliases for
        macOS <10.13 old styles: NSWarningAlertStyle,
        NSInformationalAlertStyle, NSCriticalAlertStyle new styles:
        NSAlertStyleWarning, NSAlertStyleInformational, NSAlertStyleCritical
        [df407dcb]

2024-04-24 Nicolas Pomarede

        When building a	macOS app bundle, remove previous direcories
        Resources, Frameworks and MacOS If not, we get an error when
        compiling a second time because Frameworks/ will contain some links
        that can't be overwritten when using 'cp -R'
        [e07126ef]

2024-04-24 Nicolas Pomarede

        Remove unused variable in macOS GUI
        [347107b2]

2024-04-24 Nicolas Pomarede

        For macOS we target a minimal version of 10.13, not 10.9
        [7083ad92]

2024-04-23 Eero Tamminen

        Fixes for symbols replacement logic

        Re-load TOS symbols if TOS is reloaded and there are no manually 
        loaded symbols. Set symbols as manually loaded only when that 
        loading is actually successful.  Do that only for CPU symbols, and
        rename variable accordingly.
        [6452c41d]

2024-03-22 Eero Tamminen

        Add autoload support also for TOS debug symbols
        [7d2386be]

2024-04-23 Eero Tamminen

        Update m68k-linux issues list
        [ac9c379b]

2024-03-17 Eero Tamminen

        Support CPU cache option also in Python tools
        [36ef27de]

2024-04-22 Eero Tamminen

        Document CPU data cache option
        [c07804cb]

2024-03-16 Eero Tamminen

        Add config & SDL-GUI option for CPU cache emulation
        [b69dff75]

2024-04-23 Eero Tamminen

        HConsole support for new Hatari v2.5 remote API options
        [1377bc43]

2024-04-23 Eero Tamminen

        Give better feedback for remote API usage
        [41429a6b]

2024-04-21 Eero Tamminen

        Add few new ST & STE games to compatibility docs
        [e7c56f1a]

2024-04-21 Eero Tamminen

        GEMDOS HD: fix for Fattrib() call on a directory

        Change only necessary bit(s) of current mode for read-only/writable 
        bit, instead of overwriting all mode bits.

        (Previous code dropped required execute bit from directories.)
        [5c51b21b]

2024-04-21 Eero Tamminen

        Clarify that TYS works correctly with MMU except for Videl
        [e5f48d91]

2024-04-20 Thomas Huth

        Fix some typos (found with 'codespell')
        [34b978d4]

2024-04-20 Thomas Huth

        Update repo-sync to version 4

        This will hopefully avoid the deprecation warning that currently 
        shows up with version 3.
        [f06961e4]

2024-04-19 Nicolas Pomarede

        Also fetch tags in the repo-sync github mirror job Default is false
        for "fetch-tags"
        [adf8e608]


2024-04-18 : *** Version 2.5.0 ***

2024-04-18 Nicolas Pomarede

        New release 2.5.0, update dates in corresponding files
        [09614692]

2024-04-17 Eero Tamminen

        Improve Rainbow 2 description

        Reported-By: Laurent Sallafranque
        [cc9e6e28]

2024-04-16 Nicolas Pomarede

        Remove unneeded entries from macOS localized InfoPlist.strings (as
        suggested by Andreas Grabher)
        - CFBundleShortVersionString because it matches the entry in
        Info-Hatari.plist
         and therefore does not need to be localized
        - CFBundleGetInfoString because it is obsolete since Mac OS X 10.6
         (and SDL2 requires 10.6 or later)
        [26217342]

2024-04-16 Nicolas Pomarede

        Update macOS's InfoPlist.strings (as suggested by Andreas Grabher)
        [5ec83954]

2024-04-15 Eero Tamminen

        Update compatibility doc + release notes
        [a7615126]

2024-04-15 Laurent Sallafranque

        Fix DSP: 2nd patch for dsp effective adress fix. When modifier =
        modulo, effective adress must be increased. This fix Audio Fun
        Machine sound quality when the equalizer is ON.
        [2e0802b0]

2024-04-15 Laurent Sallafranque

        DSP fix : effective adress with modifier = modulo wasn't correctly 
        updated. This fix Audio Fun Machine (AFM) sound when the equalizer
        is on.
        [e718ba34]

2024-04-15 Eero Tamminen

        SCC: change (way) too common debug logs to trace messages

        To make debug logging be useful again.
        [9a136d7e]

2024-04-15 Eero Tamminen

        SCC: trace and debug log output consistency

        Trace calls use "scc " prefix, debug logs "SCC: " one.
        [bdd1d2a6]

2024-04-15 Eero Tamminen

        Release notes: split debugger upates to 3 sub-categories

        To makes changes easier to read.
        [09e7f071]

2024-04-14 Eero Tamminen

        Falcon compatibility: Moongame starts only with Joypad button 3
        [e28cd56b]

2024-04-14 Eero Tamminen

        Compatibility doc: 2.5-dev -> 2.5, typo fix
        [7bb39cf7]

2024-04-14 Eero Tamminen

        Update release notes
        [ad5da09b]

2024-04-14 Eero Tamminen

        Update EmuTOS doc to latest Hatari/EmuTOS state
        [3347a913]

2024-04-14 Eero Tamminen

        Add Psycho Hack 2024 demos to EmuTOS compatibility list

        Going & Old demos have some very nice fullscreen effects:
        https://demozoo.org/parties/4759/
        [18e8469a]

2024-04-13 Nicolas Pomarède

        Prevent defining conflicting enum named 'bits' when including
        readcpu.h outside of cpu/ dir GCC 14 reports a warning when using a
        variable named 'bits', for example :

        src/hatari.git/src/scc.c: In function 'SCC_Update_RR0_Clear': 
        src/hatari.git/src/scc.c:1355:58: warning: declaration of 'bits'
        shadows a previous local [-Wshadow=local]
        1355 | static void     SCC_Update_RR0_Clear ( int Channel , int bits
        )
             |                                                      ~~~~^~~~ 
        In file included from src/hatari.git/src/cpu/newcpu.h:13,
                        from src/hatari.git/src/includes/m68000.h:25,
                        from src/hatari.git/src/scc.c:92: 
        src/hatari.git/src/cpu/readcpu.h:83:5: note: shadowed declaration is
        here
          83 |     bits, bitS, bitd, bitD, bitr, bitR, bitz, bitE, bitp,
        lastbit

        This is because readcpu.h is defining some enum's and one of them is
        'bits' As those enum's are only needed in the cpu core part, we
        disable them when including readcpu.h (through newcpu.h) outside of
        cpu/
        [943006bc]

2024-04-13 Nicolas Pomarède

        Remove commented include
        [f023a931]

2024-04-13 Nicolas Pomarède

        Remove redundant include for newcpu.h (already done in m68000.h)
        [4646c6bc]

2024-04-13 Thomas Huth

        Don't use _FORTIFY_SOURCE by default in debug builds

        Some debug builds are compiled without optimizations, which are then 
        causing lots of warnings when _FORTIFY_SOURCE has been enabled. So
        let's stop enabling it by default and add them to some of our CI 
        pipelines instead.
        [a5b1539c]

2024-04-13 Eero Tamminen

        More logical order for exception lists and their define values

        And release notes update.
        [c15f99b8]

2024-04-13 Thorsten Otto

        Support entering debugger on Line-F and Line-A instructions
        [e6ad1dbc]

2024-04-12 Eero Tamminen

        Update m68k NetBSD information

        For new NetBSD 10.0 release, and for improved Hatari emulation, 
        allowing kernel to work better than earlier:
        * MMU does not cause crashes
        * SCSI does not cause freeze
        * RGB screen works
        [744da26d]

2024-04-12 Thomas Huth

        Avoid crashes when using HD floppy images that are completely empty

        Thanks to Thorsten Otto for the hint: We must avoid that
        SectorsPerTrack gets set to 0, otherwise Hatari crashes with a
        divide-by-zero later.

        According to Wikipedia, there are some computers that use only 5
        sectors per track, so use that as a minimum number for the sanity
        check.
        [b684476b]

2024-04-01 Eero Tamminen

        Update docs in regards to MMU compatibility
        [29cf6b73]

2024-03-30 Thomas Huth

        Create Hatari.icns dynamically during the build
        [c149684a]

2024-03-29 Eero Tamminen

        Update release notes
        [773c90ba]

2024-03-28 Christian Zietz

        GEMDOS HD: Fix Fread/Fwrite combination on Windows

        The C99 standard mandates that a "file positioning function" is
        called when following fread() by fwrite(). To simplify the logic, a
        dummy fseek() is performed before every write operation.
        [1e398be7]

2024-03-27 Eero Tamminen

        Update compatibility doc

        * Command & Conquer (new game ported)
        * Imperfect demo works OK (Fixes: 9873d296f65c)
        * MiNT works better
        [07199fc0]

2024-03-27 Eero Tamminen

        Update EmuTOS compatibility notes: v1.3 -> git

        Git version has preliminary console text output support for TC mode.
        [7cd2b7c3]

2024-03-27 Nicolas Pomarede

        Improve SNDINT/SOUNDINT for Falcon DMA audio (based on measures on a
        real Falcon)
        [76b5de3e]

2024-03-27 Eero Tamminen

        Rate-limit xconout VT52 parser warning messages

        By using Hatari logging functions instead of fprintf().

        (Boot of 2017 MiNT version showed quite a lot of them...)
        [86579f61]

2024-03-24 Eero Tamminen

        Update problematic Falcon programs info in compatibility list

        Some games work now also when MMU is enabled.  Switched ScummVM
        notes to latest upstream release.  Dropped few notes for ancient
        Hatari versions. And updated version for checked items to 2.5-dev.
        [9873d296]

2024-03-25 Nicolas Pomarede

        Update release notes
        [6bf3a727]

2024-03-24 Eero Tamminen

        Update EmuTOS compatibility notes: git -> v1.3
        [f6a3f1be]

2024-03-24 Eero Tamminen

        Add notes about 1024k EmuTOS version to manual
        [98c124b0]

2024-03-24 Eero Tamminen

        Rate-limit DSP error messages output

        By switching from printf() to Log_Printf().

        This also reverts f5c66f710379 (manual rate-limiting for one of the
        messages triggered frequently by "Terrorize your soul") as it's now
        redundant.
        [4da75e6b]

2024-03-24 Thomas Huth

        Clean up code in ScreenSnapShot_SaveNEO()

        Coverity complains about the "if (bpp >= 10)" part being dead code
        here, since bpp >= 10 cannot happen due to the earlier checks.
        That's right, so let's clean up this part, make the code a little
        bit more readable, and while we're at it, also fix some bad
        indentations in this function.
        [4d7bf1f9]

2024-03-24 Thomas Huth

        Avoid strcpy() without length check
        [d56e53e1]

2024-03-24 Eero Tamminen

        m68k-linux: update scripts & docs

        Changes:
        - Enabling CPU cache does not cause init crash any more, after
         updating to latest m68k Debian BusyBox (it still happens with
         BusyBox version from 2019, but let's ignore that)
        - Scripts & docs are updated for Debian /usr merge:
         https://wiki.debian.org/UsrMerge
        - EmuTOS links updated to 1.3 release
        [151c117c]

2024-03-24 Laurent Sallafranque

        Fix typo: parallel and not parallal.
        [e47e060e]

2024-03-24 Laurent Sallafranque

        Format DSP disasm ALU_instruction X_move and Y_move for better 
        readibility.
        [043c6d16]

2024-03-24 Laurent Sallafranque

        Cleaning: remove the spaces at end of line before uploading a patch
        [75b1f16a]

2024-03-23 Nicolas Pomarède

        JMP/JSR bus error fix (from WinUAE 5.3.0 beta1 2024/03/23)
        [dd5d9dd3]

2024-03-21 Eero Tamminen

        Fix: allow any values for absolute / arbitrary symbol types

        They could be e.g. HW register values with upper bits set:
        VID_BASEHI equ $ffff8201

        And 24-bit addressing being in effect should not limit those.

        Reported-By: J. Young.
        [39523d4c]

2024-03-22 Nicolas Pomarède

        Update WinUAE's cpu core version
        [ff108396]

2024-03-22 Nicolas Pomarède

        Add VBL/HBL to crossbar traces
        [1e830514]

2024-03-22 Nicolas Pomarède

        Branch/jump instruction bus error fixes (from WinUAE 5.3.0 beta1
        2024/03/22)
        [62d85cb7]

2024-03-19 Eero Tamminen

        Fix: scrollbar arrows act until mouse button is released

        Regardless of whether mouse remains within the object i.e. all 
        interactive scrollbar elements behave now the same.

        This fixes SDL2 issue of it reporting mouse _state_ coord scaled so 
        that their exact position in the application framebuffer cannot be 
        calculated in letterboxed fullscreen, unlike mouse button _events_ 
        coords can.
        [b8efe3a3]

2024-03-17 Eero Tamminen

        Fix: scale fsel scrollbar mouse coords for scaled SDL2 windows

        Apply same fix also to one missing place in SDLGui_DoDialogExt() 
        object finding.
        [9a63cf44]

2024-03-17 Eero Tamminen

        Fix fileselector SDL GUI code indenting
        [743c88e9]

2024-03-19 Nicolas Pomarede

        Remove old references to src/uae-cpu/ we use src/cpu/
        [8c8d1df5]

2024-03-19 Nicolas Pomarede

        Hatari 2.5 ships with latest EmuTOS 1.3 from 2024/03/17
        [2c6db8a8]

2024-03-17 Eero Tamminen

        Fix: debugger memdump command count argument handling

        * Avoid infinite looping by rejecting negative counts
        * Show only requested number of items, instead of
         rounding number of items to next MEMDUMP_COLS
         (reported by J. Young)
        [ea6cbab7]

2024-03-16 Eero Tamminen

        Python UI: drop Hatari <2.4 (oldUAE) support

        Also improve TT-RAM / 24-bit addressing support slightly and update
        Python UI docs.
        [e1364f72]

2024-03-16 Eero Tamminen

        Python UI: drop Hatari v2.2, and add v2.4 options compatibility

        Additional complication is names for SCC-B config options changes.
        [9e356137]

2024-03-16 Eero Tamminen

        Fix: use more reasonable remote command buffer size

        400 bytes was way too small if e.g. Python UI wanted to pass 
        slightly more options to Hatari.
        [205f662d]

2024-03-15 Eero Tamminen

        m68k-linux: 040/060 work again after interrupt vector fix
        [6e673ef8]

2024-03-15 Nicolas Pomarede

        exception_debug() should use vector_nr not nr (#2)
        [74fc693e]

2024-03-15 Nicolas Pomarede

        exception_debug() should use vector_nr not nr
        [6bebca7f]

2024-03-15 Nicolas Pomarede

        Fix wrong vector number for interrupt in Exception_mmu() for
        68040/60
        [dfb9373c]

2024-03-14 Nicolas Pomarede

        Make currently unusable extra 68020 wait states conditional (from
        WinUAE 5.2.0+ 2024/03/16)
        [a167cb4b]

2024-03-13 Eero Tamminen

        Update release notes

        - list all changed config variables
        - add Chaos A.D. to fixed demos
        - Sort fixed programs by name
        [891f190e]

2024-03-13 Eero Tamminen

        m68k-linux: FPSP060.PRG required on 060
        [71183d25]

2024-03-12 Eero Tamminen

        Update bug information for Linux v6.8 on Hatari v2.5-dev

        All issues from testing v6.4 on v2.4.1 seem to be still there, and 
        there's an additional issue with 060 emulation.
        [91ae4de3]

2024-03-12 Eero Tamminen

        m68k-linux: update build instructions to v6.8

        Because upstream dropped other allocators than SLUB one: 
        https://www.phoronix.com/news/Linux-6.8-SLAB-SLUB-Changes

        I switched config from SLAB to SLUB_TINY.
        [11d3adfe]

2024-03-12 Eero Tamminen

        docs: Chaos A.D. demo is not noisy any more
        [4adbc0a1]

2024-03-12 Eero Tamminen

        Add RTC timer interrupts to todo list
        [a6ecc810]

2024-03-09 Nicolas Pomarède

        Missing update for SNDINT_Signal (fix Falcon DMA audio "end of
        frame" interrupt on GPIP7)
        [b5c4deb1]

2024-03-09 Thomas Huth

        Update the macOS Ventura job to Sonoma
        [3ff847f6]

2024-03-09 Thomas Huth

        Update release notes for the upcoming release
        [8133202a]

2024-03-09 Thomas Huth

        Update Cirrus-CI to FreeBSD 13.3
        [be97baed]

2024-03-08 Eero Tamminen

        Fix SCC config file name checks

        Given variables are pointers to Hatari config string arrays, so 
        variables are always true, but they can be empty.
        [1005bbb4]

2024-03-08 Eero Tamminen

        TOS bootup tester: update SCC-B config option names

        Changed in 6087c3d3344e89, otherwise Falcon tests fail.
        [6ade9318]

2024-03-07 Eero Tamminen

        TOS bootup tester: minor documentation improvements
        [d0b31eab]

2024-03-07 Eero Tamminen

        TOS bootup tester: update test binaries

        For a small code change done in 2022...
        [088b4582]

2024-03-08 Nicolas Pomarede

        Update release notes for Falcon
        [b357167a]

2024-03-04 Eero Tamminen

        Add "echo" command to debugger
        [e3ba7bc6]

2024-03-03 Eero Tamminen

        Breakpoint ":quit" option inhibits extra output also for ":file" one
        [5be5f707]

2024-03-06 Nicolas Pomarede

        Update WinUAE's cpu core version
        [b882497e]

2024-03-06 Nicolas Pomarede

        For Falcon, use ScreenRefreshRate in
        ClocksTimings_GetCyclesPerVBL(), as we now have VIDEL_Get_VFreq()
        instead of fixed 50Hz This fixes DMA sound being too slow when
        ScreenRefreshRate=60 Hz in VGA mode
        [10b9de0c]

2024-03-04 Nicolas Pomarede

        For Falcon DMA sound, SNDINT/SOUNDINT are set to 0/LOW when playing
        and 1/HIGH when idle + fix use of FF8900 This means that Timer A
        Input or GPIP7 can be used on the MFP to detect/count each time a
        new audio frame is starting (this is the opposite of STE/TT) 
        Additionally reg FF8900 can be configured to trigger an interrupt on
        TAI or GPIP7 at the end of each audio frame when playing or
        recording
        [506b673d]

2024-03-04 Nicolas Pomarede

        Remove unused function VIDEL_Get_MonitorType()
        [f285453b]

2024-03-01 Nicolas Pomarede

        In Falcon mode use VFT and VC0 to get the current video vertical
        freq (50, 60, ...)
        [3151d0da]

2024-02-25 Nicolas Pomarede

        Add debug line
        [7f564567]

2024-02-25 Nicolas Pomarede

        In Falcon mode set video refresh rate to 60 Hz if monitor type is
        VGA
        [3a4bbca9]

2024-02-24 Thomas Huth

        ide: Cap LBA28 capacity announcement to 2^28-1

        The LBA28 capacity (at offsets 60/61 of identification) is supposed
        to express the maximum size supported by LBA28 commands. If the
        device is larger than this, we have to cap it to 2^28-1.

        At least NetBSD happens to be using this value to determine whether
        to use LBA28 or LBA48 for its commands, using LBA28 for sectors that
        don't need LBA48. This commit thus fixes NetBSD access to disks
        larger than 128GiB.

        This change is based on Samuel Thibault QEMU commit here: 
        https://gitlab.com/qemu-project/qemu/-/commit/46e018e9b741731842b93ce23a86fad6
        [8e8a911e]

2024-02-24 Thomas Huth

        ide: model HOB correctly

        When writing to the command registers, the old value is shifted into
        a HOB copy of the register and the new value is written into the
        primary register. When reading registers, the value retrieved is
        dependent on the HOB bit in the CONTROL register.

        By setting bit 7 (0x80) in CONTROL, any register read will, if it
        has one, yield the HOB value for that register instead.

        Our code has a problem: We were using bit 7 of the DEVICE register
        to model this. We use bus->cmd roughly as the control register
        already, as it stores the value from ide_ctrl_write.

        Lastly, all command register writes reset the HOB, so fix that, too.

        This change is based on John Snow's QEMU commit here: 
        https://gitlab.com/qemu-project/qemu/-/commit/be8c9423dec7bd0a0af7f57ecbbcb271
        [3c7e987a]

2024-02-24 Thomas Huth

        ide: rename cmd_write to ctrl_write

        It's the Control register, part of the Control block -- Command is 
        misleading here. Rename all related functions and constants.

        This change is based on John Snow's QEMU commit here: 
        https://gitlab.com/qemu-project/qemu/-/commit/98d98912238d9f4f4c41bda0a3d944d0
        [386e4992]

2024-02-24 Thomas Huth

        ide: Add register hints to tracing

        Name the registers for tracing purposes.

        This change is based on John Snow's QEMU commit here: 
        https://gitlab.com/qemu-project/qemu/-/commit/335ca2f2f0f540c2e24fb9d4d5859322
        [455d0e1b]

2024-02-24 Thomas Huth

        ide: don't tamper with the device register

        In real ISA operation, register writes go out to an entire bus
        channel and all listening devices receive the write. The devices do
        not toggle the DEV bit based on their own configuration, nor does
        the HBA intermediate or tamper with that value.

        The reality of the matter is that DEV0/DEV1 accordingly will react
        to command register writes based on whether or not the device was
        selected.

        This does not fix a known bug, but it makes the code slightly
        simpler and more obvious.

        This change is based on John Snow's QEMU commit here: 
        https://gitlab.com/qemu-project/qemu/-/commit/f14bc040b073257f0eb8200042634c0d
        [b334c5f3]

2024-02-24 Thomas Huth

        Silence two compiler warnings by using a proper function declaration
        [94c96a79]

2024-02-20 Nicolas Pomarede

        Add note in DmaSnd_Update_XSINT_Line() about Timer A counting "end
        of frame" events on STE/TT
        [8a7c1428]

2024-02-13 Nicolas Pomarède

        Update WinUAE's version to 5.2.0 beta9 2024/02/12
        [aa25c451]

2024-02-13 Nicolas Pomarède

        Fix 68040 MMU MOVES special case (patch by Andreas Grabher) (from
        WinUAE 5.2.0 beta9 2024/02/12)
        [2a11e29d]

2024-02-13 Nicolas Pomarède

        DraCo misc updates, some Casablanca update (not used in Hatari)
        (from WinUAE 5.2.0 beta5 2024/01/22)
        [37400833]

2024-02-04 Nicolas Pomarede

        Add XIMG screenshot format to release notes
        [ed4c43db]

2024-02-04 Eero Tamminen

        Improve dev version release notes categorization
        [a9c3bcea]

2024-02-04 Eero Tamminen

        Fix script comment typo
        [9d3af443]

2024-02-02 Nicolas Pomarede

        Update release notes
        [93535798]

2024-02-02 Thomas Huth

        Update documentation with regards to joypad support
        [46788d11]

2024-01-31 Nicolas Pomarede

        Fix for bug in caps library that reset FDC's TR and DR on warm reset
        (thanks Ijor) The game 'F29 Retaliator' uses the CPU "reset"
        instruction which wrongly clears
        "r_track" and "r_data" in the caps library instead of keeping their
        values. The loader will then fail and the game won't start, staying
        on track 71 instead of seeking to track 0.
        [97eddba4]

2024-01-29 Eero Tamminen

        Python UI: Add SCC-A support to GUI

        - Add SCC-A enabling options
        - Fix Hatari remote API "sccalan" command name
        - Sort paths dialog entries by label instead of Hatari command name,
         and change path labels so that they start with the device type i.e.
         get ordered nicer in the dialog

        Fixes: 5eff40495db
        [e4f54e41]

2024-01-29 Eero Tamminen

        Python UI: Fix uihelpers function comments
        [d3e9a3a0]

2024-01-28 Thomas Huth

        Add the possibility to configure the extended joypad keys in the SDL
        GUI
        [5b5cd426]

2024-01-28 Thomas Huth

        Add emulation of additional joypad buttons via the keyboard
        [72254a82]

2024-01-28 Thomas Huth

        Rename JOYID_STEPAD* to JOYID_JOYPAD*
        [d2e9772a]

2024-01-27 Thomas Huth

        Mention analog/paddle support in the documentation
        [bea5aaae]

2024-01-27 Thomas Huth

        Fix compilation issue when NDEBUG is enabled
        [21c3bd79]

2024-01-27 Thomas Huth

        Remove unnecessary #ifdef check

        We require at least SDL 2.0.6 nowadays, so we don't nee this check
        anymore.
        [cf031b17]

2024-01-27 Nicolas Pomarede

        "line_size" computation is also common NEO/XIMG code (patch by Brad
        Smith) make flags field for NEO explicit 0 + some NEO header
        comments for clarity
        + remove unused variable "SDL_PixelFormat *fmt"
        [ee524aec]

2024-01-27 Nicolas Pomarede

        hatariui.py : update parameters' name for SCC A / SCC A Lan / SCC B
        in [RS232] config
        [5eff4049]

2024-01-27 Thomas Huth

        Simplify the BytesPerPixel checks

        Since we only support 32 bpp nowadays, there is really no need
        anymore to check BytesPerPixel in each iteration of the loops. Let's
        simply add an assert() statement at the beginning of the functions
        instead that we remember to update this code if we ever support
        anything beside 32 bpp again.
        [4d1818cd]

2024-01-27 Thomas Huth

        Wire up the analog joypad support in Falcon mode, too
        [3c4c5439]

2024-01-26 Nicolas Pomarede

        Update screen dialog documentation and image with new screenshot
        format options (patch by Brad Smith)
        [5fb431df]

2024-01-26 Nicolas Pomarede

        Fix NEO header resolution field (patch by Brad Smith)
        [2d3bfcf1]

2024-01-26 Nicolas Pomarede

        Add XIMG to screenshot GUI (patch by Brad Smith)
        [99a94956]

2024-01-26 Nicolas Pomarede

        Consolidate shared code from SaveNEO/SaveXIMG (patch by Brad Smith)
        [48e9ab27]

2024-01-26 Nicolas Pomarede

        Cleanup of palettized-PNG, NEO and XIMG support (patch by Brad
        Smith) Snapshot functions use stack arrays instead of static, use
        be_swap16 instead of custom StoreU16NEO function, add ximg to
        --screenshot-format formats, document in manual.html
        [d0bf4bf6]

2024-01-26 Nicolas Pomarede

        XIMG screenshot support (patch by Brad Smith) See
        https://freemint.github.io/tos.hyp/en/VDI_fundamentals.html#The_20XIMG_20format_20for_20pixel_20images 
        for a description of the format Notes from Brad Smith
        (https://github.com/hatari/hatari/pull/34 for more details) : XIMG,
        though less popular than NEO, can represent all video modes
        supported by Hatari.
        [d9f957ee]

2024-01-26 Nicolas Pomarede

        NEO screenshot support for more modes still compatible with the
        format (patch by Brad Smith)
        [1c134177]

2024-01-24 Nicolas Pomarede

        Remove old code using 16bpp (not needed since commit 4d78e24 from
        2022/10/02)
        [870f78c3]

2024-01-24 Nicolas Pomarede

        Use new choice of screenshot format immediately when pressing
        'Screenshot' button
        [c6ddae64]

2024-01-23 Nicolas Pomarède

        Add buttons in the 'Hatari Screen' menu to choose the screenshot
        format (png/bmp/neo)
        [14505297]

2024-01-14 Alex Hornby

        add ste pad analog support as used by PP Oids

        PP has an Oids patch that can use the STE controller input analog
        options. See https://www.atari-forum.com/viewtopic.php?t=31796 for
        technical details and https://atari.8bitchip.info/SCRSH/oids.html
        for game download. The OIDSAJ download includes an analog stick test
        program.

        Steem SSE IO handling equivalent is in 
        https://sourceforge.net/p/steemsse/code/HEAD/tree/trunk/steemsse/steem/stjoy.cpp#l633

        Some more docs at:
        https://info-coach.fr/atari/hardware/STE-HW.php#joysticks
        [cf7cd075]

2024-01-21 Nicolas Pomarede

        Update release notes with .NEO screenshot and "--screenshot-format"
        [48bc55ca]

2024-01-21 Nicolas Pomarede

        Add option "--screenshot-format" to choose the file format used when
        taking screenshot (bmp, png or neo) Corresponding option in
        hatari.cfg is Screen.ScreenShotFormat (1=bmp, 2=png, 3=neo) Default
        format is "png" if libpng is available, else it will be "bmp"
        "bmp" or "png" format work for any resolution.
        "neo" format works only for ST/STE resolutions
        [7d95c583]

2024-01-21 Nicolas Pomarede

        Allow .NEO screenshot in TT/Falcon, only if resolution is compatible
        with ST/STE (based on patch by Brad Smith) Original patch by Brad
        Smith allowed saving any resolution in .NEO file but as the result
        would not be readable with Neochrome or Neochrome Master I added
        some check to allow only ST/STE compatible resolutions. Display an
        error message if the current resolution is not compatible with .NEO
        [12a31785]

2024-01-20 Nicolas Pomarede

        Define HAVE_DIRENT_H in WinUAE's sysconfig.h (all recent OSes should
        have dirent) Prevent some conflict with "struct direct *" when
        including stMemory.h in files that already include dirent.h
        [5a946f7a]

2024-01-16 Nicolas Pomarède

        NEO direct video memory dump option for screen snapshot (patch by
        Brad Smith) This needs to be enabled via
        Config.bNEOScreenSnapShot=TRUE (no UI added for it)

        Notes from Brad Smith (https://github.com/hatari/hatari/pull/31 for
        more details) : This creates a NEO file format screenshot, out of
        the data in FrameBuffer (screen.c). This works for ST low, medium,
        and high resolutions. The palette is taken from the centre line of
        the FrameBuffer for Low and Medium resolutions. For High resolution
        don't seem to store per-line palette, but I instead extracted the
        GenConvert palette for it.
        [dd0c3b99]

2024-01-15 Nicolas Pomarede

        Use ST palette for PNG screenshots if possible (patch by Brad Smith) 
        Notes from Brad Smith (https://github.com/hatari/hatari/pull/30) : 
        This allows PNG screenshots to use the ST palette where possible.

        A palettized image has a few advantages. The file size is slightly
        smaller. Any graphics program that can view the palette can now be
        used to see what the ST's 16-colour palette looked like at the time
        of screenshot. It makes palette-based editing of the image easier
        (e.g. changing colours). Conversion into an ST-ready image format is
        also more straightforward.

        This automatically falls back to a full RGB image if the image
        contains any colours outside the current ST palette. This means that
        modes with more colours, or mid-screen palette changes will still
        produce valid screenshots as full RGB.

        This works for low res and med res video modes.

        NOTE 2 : As the Hatari UI also uses its own colors, you need to
        check "Crop Statusbar" in the "Hatari Screen" menu to ensure the
        status bar is not included in the screenshot. If not, it will use
        more colors than the emulated screen and resulting PNG will be saved
        as RGB image and not as palettized image.
        [3f6874f3]

2024-01-14 Thomas Huth

        Add missing #include for Hatari_rand() prototype
        [28e57669]

2024-01-14 Thomas Huth

        Remove old and unused variables from the memory snapshots

        The memory snapshot file format has recently been changed, so it
        should be fine now to remove these old variables now, too.
        [727abe36]

2024-01-14 Nicolas Pomarede

        hmsa tool needs utils.c to compile
        [c10ca6e5]

2024-01-14 Nicolas Pomarede

        Use Hatari_rand() wrapper instead of calling rand() directly (to
        allow customising the random function)
        [61a8744f]

2024-01-14 Nicolas Pomarede

        Add BusCyclePenalty, IoAccessInstrPrevClock and IoAccessInstrCount
        to the memory snapshot (patch by Brad Smith)
        [09595f70]

2024-01-14 Nicolas Pomarede

        Add currcycle and extra_cycle from WinUAE's CPU core to the memory
        snapshot (patch by Brad Smith)
        [6fa3af8d]

2024-01-14 Nicolas Pomarede

        Add more CPU variables from m68000.c to the memory snapshot (patch
        by Brad Smith)
        [d4de5482]

2024-01-14 Nicolas Pomarede

        Add MachineClocks struct, CycInt_From_Opcode and PendingCyclesOver
        variables to the memory snapshot (patch by Brad Smith)
        [e217eada]

2024-01-14 Nicolas Pomarede

        Add VBL_ClockCounter variable to the memory snapshot (patch by Brad
        Smith)
        [4921a109]

2024-01-14 Nicolas Pomarede

        Add more sound variables to the memory snapshot (patch by Brad
        Smith)
        [cf69d5d6]

2024-01-14 Nicolas Pomarede

        Include YM_Buffer_250 to the memory snapshot for seamless audio when
        restoring (patch by Brad Smith) Buffer was previously cleared on
        restore
        [a88b9e4c]

2024-01-14 Nicolas Pomarede

        Add missing blitter's varaibles to the memory snapshot (patch by
        Brad Smith)
        [cb8b61b8]

2024-01-13 Nicolas Pomarède

        Update RS232 part in the manual with a table of all available
        ports/options + fixes some spelling
        [d8d97118]

2024-01-08 Eero Tamminen

        Add Miro's recent programs to compatibility lists
        [a5cd0ca3]

2024-01-11 Nicolas Pomarède

        Update SCC status in doc to "fully working"
        [e74f06cf]

2024-01-11 Nicolas Pomarède

        Add options --scc-a-lan-in and --scc-a-lan-out to the manual
        [5719ba0c]

2024-01-10 Nicolas Pomarède

        Enable Serial or LAN on SCC A depending on bit 7 in reg 14 of the
        YM2149 for MegaSTE and TT (0=Lan, 1=Serial)
        [e1e274a0]

2024-01-10 Nicolas Pomarède

        Add options --scc-a-lan-in and --scc-a-lan-out to configure the LAN
        port on SCC Channel A for MegaSTE and TT
        [05908959]

2024-01-08 Nicolas Pomarède

        SCC : add support for 2 filehandles per channel (serial and lan) On
        MegaSTE and TT, SCC channel A can be connected to the serial port or
        to the lan port using bit 7 in reg 14 of the YM2149 (0=Lan,
        1=Serial)
        [3692376f]

2024-01-07 Nicolas Pomarède

        SCC : use ioctl TIOCSBRK/TIOCCBRK to set/clear BRK on the serial
        line
        [0d2711fb]

2024-01-06 Nicolas Pomarède

        NMI handling fix (patch by Andreas Grabher) (from WinUAE 5.2.0 beta1
        2024/01/06)
        [420e0998]

2024-01-06 Nicolas Pomarède

        Remove --scc-a and --scc-b options to keep consistency with rs232
        options
        [f2958308]

2024-01-06 Thomas Huth

        Fix previous commit (adapt endif() statement, too)
        [e70f6189]

2024-01-06 Thomas Huth

        Do not capitalize 'hatari.exe' on Windows
        [b2f2000d]

2024-01-05 Eero Tamminen

        Make SCC option define names more readable/consistent with others

        As SSCB_IN, it will not be interpreted as SCC_BIN...
        [12c3da06]

2024-01-04 Nicolas Pomarède

        Don't use "speed_t" type when termios.h is not found
        [b848a7bb]

2024-01-04 Nicolas Pomarède

        SCC : remove old code + rename some variables
        [2f3e8999]

2024-01-03 Nicolas Pomarède

        Update SCC options in manual
        [dd5e5b9d]

2024-01-03 Nicolas Pomarède

        Add options --scc-a, --scc-a-in and --scc-a-out + store SCC's
        configuration for channels A/B in an array
        [6087c3d3]

2024-01-02 Nicolas Pomarède

        SCC : Improve TX part (TSR status "full", interrupt on TX)
        [b942d400]

2024-01-02 Nicolas Pomarède

        SCC : improve SCC_Serial_Get_CTS and SCC_Serial_Get_DCD +
        indent/rename
        [270c546e]

2024-01-01 Nicolas Pomarède

        Enable again previously commented options "-scc-b" and "-scc-b-in"
        [ea20f8de]

2023-12-29 Nicolas Pomarède

        When updating intlev / pendingInterrupts, always copy regs.ipl_pin
        to regs.ipl_pin_p If not, some wrong interrupts can trigger, based
        on the previous content of egs.ipl_pin_p This workaround is required
        at the moment because Hatari resets currcycle to count internal
        cycles, which messes with ipl_fetch_next() and gives wrong value for
        regs.ipl_pin_change_evt TODO : we should not reset currcycle and use
        it directly for Hatari's internal cycles counter
        [0584bb6a]

2023-12-13 Nicolas Pomarède

        SCC : improve doc for description and naming of the ports on the
        different machine types
        [bd52871a]

2023-12-11 Nicolas Pomarède

        SCC : reorder some code
        [d8f8acbe]

2023-12-11 Nicolas Pomarède

        SCC : Ext/Status IP in RR3 are set when bits in RR0 are changing,
        not when bit are high
        [6c38d6aa]

2024-01-02 Nicolas Pomarède

        Debugger MMU mode instruction byte read missing masking (from WinUAE
        5.1.0+ 2024/01/01)
        [01d32508]

2024-01-02 Nicolas Pomarède

        Fix 68040/060 bus error RTE + Trace (from WinUAE 5.1.0+ 2024/01/01)
        [4c94e698]

2024-01-02 Nicolas Pomarède

        MMU table dump includes description valid state (from WinUAE 5.1.0+
        2024/01/01)
        [6daea17f]

2024-01-02 Nicolas Pomarède

        Revert part of "Fast 68020+ modes didn't start pending interrupt
        immediately" fix (from WinUAE 5.1.0+ 2023/12/29) only SR
        modifications must check interrupt immediately
        [9dd63033]

2023-12-29 Eero Tamminen

        Support for (missing) "pl" + (new) "ro" EmuTOS language options

        Romania support was recently added to EmuTOS daily snapshots, but
        Poland support has been there since EmuTOS v1.1.1 release
        (= I had missed it in Hatari v2.4.0 release).
        [14bcf9b0]

2023-12-28 Nicolas Pomarede

        68040/060 MMU fault handler bug fix for MOVEM (part 2) +
        regs.spcflags cleanups (from WinUAE 5.1.0+ 2023/12/28)
        [f437b8fd]

2023-12-28 Nicolas Pomarede

        Move SPCFLAG_xxx from custom.h to newcpu.h + change values for
        Hatari's specific flags
        [47f3ebbe]

2023-12-28 Nicolas Pomarede

        68040/060 MMU fault handler bug fix for MOVEM (from WinUAE 5.1.0+
        2023/12/28) If interrupt level increased during 68040/060 MMU fault
        handler execution, interrupt's first instruction was "restarted", if
        both original and exception's instruction were MOVEM, things went
        horribly wrong.
        [c47c3bf4]

2023-12-28 Nicolas Pomarede

        68030 MMU configuration exception was incorrectly followed by f-line
        exception (from WinUAE 5.1.0 beta14+ 2023/12/16)
        [2d172cb0]

2023-12-27 Thomas Huth

        Fix typos (discovered with codespell)
        [fd027acd]

2023-12-22 Thomas Huth

        Use uae types in the CPU code

        Thanks to Andreas for the patch
        [2becd4e5]

2023-12-22 Thomas Huth

        Add portmidi to the macOS CI build
        [e2952e7e]

2023-12-22 Thomas Huth

        Include "savestate.h" in custom.c

        This way we can be sure that the definition of "savestate_fname"
        matches the extern declaration in the header file. While we're at
        it, also remove some other unnecessary #include statements from this
        file.
        [3ca4c5cc]

2023-12-21 Thomas Huth

        Silence compiler warning about comparing signed with unsigned values

        When building for 32-bit targets, the compiler dislikes the new
        comparison in gemdos.c. For both sides to unsigned to fix the
        problem.
        [1ce50778]

2023-12-21 Thomas Huth

        Build via rpmbuild (i.e. via hatari.spec) in the Fedora CI job

        To make sure that the spec-file does not bitrot so easily again, 
        let's use it in the Fedora CI job to build Hatari there.
        [831f6f7b]

2023-12-21 Thomas Huth

        Fix hatari.spec file

        It's apparently been a while since we used the spec file for the
        last time since it does not work out-of-the-box anymore. Fix the
        problematic parts so that it works again with a recent version of
        Fedora.
        [5716056d]

2023-12-21 Thomas Huth

        Fix compiler warning that occurs with link-time optimization

        With LTO enable, the build fails with:

         [100%] Linking C executable hatari
        .../src/cpu/savestate.h:281:14: error: type of 'savestate_fname'
        does not
         match original declaration [-Werror=lto-type-mismatch]
          281 | extern TCHAR savestate_fname[MAX_DPATH];
              |              ^
        .../src/cpu/custom.c:40:8: note:
         'savestate_fname' was previously declared here
           40 | TCHAR *savestate_fname;
              |        ^
        lto1: all warnings being treated as errors

        Declare the array according to the definition in the header file to
        fix it.
        [adccd68b]

2023-12-20 Thomas Huth

        Fix building universal binaries for macOS

        Compiling libpng as universal binary seems to work if we are using
        "arm64;x86_64" instead of "x86_64;arm64", so let's give this a try.
        [ebcb6920]

2023-12-20 Thomas Huth

        Sign png.framework, too
        [7ffa759c]

2023-12-18 Thomas Huth

        Only build for arm64 in the cirrus-CI

        Building an universal binary for both, x86_64 and arm64, does not
        seem to work for the png.framework, so limit the build to arm64 for
        now.
        [322d8b21]

2023-12-18 Thomas Huth

        Make the target name configurable (and use "Hatari" for the macOS
        bundle)

        Thanks to Andreas Grabher for the idea!
        [742a8306]

2023-12-17 Thomas Huth

        Allow the user to override the CMAKE_OSX settings again
        [f896ec61]

2023-12-17 Thomas Huth

        Reduces the differences between Hatari and Previous

        Setting CMAKE_OSX_ARCHITECTURES and CMAKE_OSX_DEPLOYMENT_TARGET must
        be set before the call to project(). Otherwise it won’t be
        recognised. Therefore building Hatari as universal binary was
        broken. Also add automatic addition of SDL2.framework and
        png.framework to the bundle. This way you get a runnable application
        out of the box (else you would have to copy the frameworks to the
        bundle manually before to make it work). This is necessary since
        Xcode 15. Also remove some unused stuff.

        Thanks to Andreas Grabher for the patch!
        [82e55cbb]

2023-12-15 Thomas Huth

        Fix installation of the png.framework if the cache is already
        available
        [4cdfc36a]

2023-12-15 Thomas Huth

        Fix problem reported by 'tidy'
        [01c2bffe]

2023-12-14 Nicolas Pomarede

        DSP cleanup (patch by Andreas Grabher)
        [bb0caf0e]

2023-12-14 Nicolas Pomarede

        Fix swapped FSINCOS destination registers in disasm (from WinUAE
        5.1.0 beta13+ 2023/12/13)
        [f1ad70b6]

2023-12-14 Nicolas Pomarede

        Fix 68060 MMU MOVEM.L (An)+,<regs> if regs contain An. Small cleanup
        (from WinUAE 5.1.0 beta13+ 2023/12/13)
        [258b0cda]

2023-12-14 Nicolas Pomarede

        Debugger and calculator updates (from WinUAE 5.1.0 beta12
        2023/12/10)
        [44ea6dd1]

2023-12-13 Eero Tamminen

        Add table for 060 Falcon games / Falcon games from tSCc
        [862c8a95]

2023-12-11 Eero Tamminen

        Document DSP improvement from Andreas
        [4017c93e]

2023-11-30 Eero Tamminen

        Add notes of 2 programs intended for 060 but working on TT too
        [d960b17e]

2023-12-09 Thomas Huth

        Install libpng in the macOS job

        Thanks to Andreas Grabher for some hints on how to build the
        png.framework.
        [01121b42]

2023-12-09 Thomas Huth

        Removed superfluous #undef NATMEM_OFFSET
        [0afa393a]

2023-12-03 Nicolas Pomarède

        Improve DSP's bootstrap support + add host received data interrupt
        (patches by Andreas Grabher)
        - Add host interface initialisation
        - Add early abort of the hacked bootstrap loader
        - Real bootstrap loader sets R0 to the amount of bytes copied and
        OMR to 2
        - Add host received data interrupt
        [619f71d9]

2023-12-03 Nicolas Pomarède

        In DSP, move the check for program space before the check for
        internal RAM + add space for rom[2] (P ROM) (patch by Andreas
        Grabher)
        [4f6504eb]

2023-12-03 Nicolas Pomarède

        Clean some DSP parts (patch by Andreas Grabher)
        [0047e845]

2023-11-28 Nicolas Pomarède

        Avoid unneeded includes when capstone is not used (by Andreas
        Grabher)
        [20993ca1]

2023-11-28 Nicolas Pomarede

        Randomize seed if hard reset (not used in Hatari) (from WinUAE 5.1.0
        beta8 2023/11/18)
        [328ebb98]

2023-11-28 Nicolas Pomarede

        Update WinUAE's version to 5.1.0 beta9 2023/11/26
        [4836521a]

2023-11-28 Nicolas Pomarede

        DISASM_FLAG_VAL_FORCE disassembler parameter: always show EA, even
        if it is simple (An) (from WinUAE 5.1.0 beta9 2023/11/24) This will
        show EA value for jsr/jmp when used with (An), for example
         00FC007E 4ED0 jmp (a0) == $00000ECC
        [58038b06]

2023-11-27 Nicolas Pomarède

        SCC : improve latching RR0 when interrupts are enabled in WR15 +
        update RR0 before updating RR3
        [fcfbd130]

2023-11-27 Eero Tamminen

        Fix DSP register name lookup table order

        Reported-By: Mariusz Buras <mariusz.buras@gmail.com>
        [eedfc317]

2023-11-19 Thomas Huth

        The content of Videl register FF820A should not depend on the
        monitor type

        Falcon TOS definitely writes bit 1 according to the selection of PAL
        or NTSC in the VSetMode() XBIOS call, and Roger Burrows confirmed
        that the lowest two bit can indeed be changed by writing to the
        register on a real Falcon (thanks a lot to him for testing!), so the
        assumption that bit 1 is a read-only flag for color or mono monitor
        is certainly wrong.
        [96d7e168]

2023-11-17 Eero Tamminen

        Add tool for printing m68k instruction breakpoints
        [16445594]

2023-11-11 Nicolas Pomarède

        Add missing #ifdef DEBUGGER (from WinUAE 5.1.0 beta7 2023/11/04)
        [955a8cb7]

2023-11-11 Thomas Huth

        Ignore symbol table length if it contains a value that is too big

        Original TOS does the same, and there are some programs in the wild 
        that apparently abuse the symbol table size field for other
        purposes, so we should ignore it in Hatari, too, to be able to load
        those baddies.
        [8a0c86bc]

2023-11-09 Nicolas Pomarède

        Typo
        [0828e281]

2023-11-09 Nicolas Pomarède

        Ensure STMemory_Reset() is called early in Reset_ST() (before
        calling memory_init()) Hatari could crash when starting with an
        'invalid' amount of RAM (eg 8 MB for STF, which writes 0xF to MMU
        conf at FF8001) and then switching to <= 4 MB RAM)
        [fe0b2821]

2023-11-07 Eero Tamminen

        Silence GCC 12 warning

        There was no problem, but that GCC version complains if last char
        (which will be overwritten with nil on next line) can be written by
        strncpy().
        [670212c8]

2023-11-06 Thomas Huth

        Silence a compiler warning in the macos12 job
        [4f931ba0]

2023-11-04 Nicolas Pomarede

        Ensure MMU_Bank0_Size has default (reset) value when changing TOS
        implies changing machine's type Fix a crash in the following case
        (thanks to Eero for the example):
          1. Start Hatari with Falcon TOS and >4MB RAM:
             hatari --machine falcon --tos tos404.img -s 8
          2. Switch to 1.x / 2.x TOS + 4MB or less RAM in Hatari setup
        dialog
          3. OK changes, so that emulation gets rebooted TODO : Instead of
        calling Memory_Reset() a safer path would be to call Reset_ST() in
        case changing TOS changes hardware parameters (as in
        Change_DoNeedReset())
        [5be3a68a]

2023-10-31 Thomas Huth

        Fix SyntaxWarning from Python 3.12 about invalid escape sequence
        '\s'
        [69ce0939]

2023-10-31 Thomas Huth

        Mention that --disable-small-mem is deprecated
        [aa1d5882]

2023-10-31 Thomas Huth

        Always enable FORTIFY_SOURCE for debug builds

        This adds some runtime checks that can detect errors, which should 
        be enabled for debugging mode.
        [adc8ae2c]

2023-10-31 Thomas Huth

        Enable -Wshadow=local if available

        Shadowing variables within a function is quite bad style and can 
        confuse the reader of the code or even lead to subtle bugs. Let's 
        try to avoid this by enabling the compiler warnings for this if 
        available.
        [e1ae777c]

2023-10-31 Thomas Huth

        Fix compiler warnings with -Wshadow=local
        [f6e2cfca]

2023-10-22 Nicolas Pomarède

        Fix FPU state if FPU is enabled but is not enabled in loaded
        statefile (from WinUAE 5.1.0 beta5 2023/10/11)
        [5cf9518e]

2023-10-22 Nicolas Pomarède

        Update WinUAE's version to 5.1.0 beta3 2023/10/07
        [35a722ba]

2023-10-10 Nicolas Pomarède

        Blitter SRC/DST addresses should use 32 bits when 32 bit TT RAM is
        used (revert previous change b5b0b1fb)
        [e8317e26]

2023-10-10 Nicolas Pomarede

        Blitter SRC/DST addresses are only 24 bit, even on machines with
        extra 32 bit "TT RAM"
        [b5b0b1fb]

2023-10-05 Nicolas Pomarède

        abs -> fabs (from WinUAE 5.1.0 beta1+ 2023/10/05)
        [0a2589d9]

2023-10-02 Eero Tamminen

        Add Sommarhack 2023 demos + new game to compatibility lists
        [24d4ab13]

2023-10-03 Thomas Huth

        relocflag is uint16_t, so use be_swap16() for this variable
        [0f0a30be]

2023-10-03 Thomas Huth

        Make sure that list->strtab[] is always NUL-terminated

        This (hopefully) fixes a problem that has been discovered with
        Coverity: We are using the data in this buffer as parameter for
        fprintf with "%s"
        (via the "name" pointer), so we should make sure that there is a NUL 
        at the end of the buffer in any case.
        [2ada29ab]

2023-10-01 Thomas Huth

        Fix address register handling in CAS2 disassembly

        This corresponds to WinUAE commit
        a820167aaff9baf8e728ce10ddac803884a0866f
        [9fe4829a]

2023-10-01 Thomas Huth

        Remove unused parameters (there is no "%" in the format string here)

        This corresponds to WinUAE commit
        595454adafb802e055e79a07920723063714e23a
        [6736a5ef]

2023-10-01 Nicolas Pomarède

        Remove old/unused CycInt code that was replaced by faster one in
        Hatari 2.4.0
        [17dcec7b]

2023-10-01 Thomas Huth

        Add a proper wrapper for tmpfile()

        We're using similar code in two places to deal with tmpfile() not
        working right on Windows. Let's move this logic into a proper
        wrapper function, so that we don't have to repeat it everywhere.
        [0232ddfd]

2023-10-01 Thomas Huth

        Check FPU revision on the fly changes

        This corresponds to WinUAE commit
        0d8e68607d958f593b810183c570d6c921ef5f00

        Thanks to Andreas Grabher for the patch!
        [cd851811]

2023-10-01 Thomas Huth

        n cannot get negative in the while loop in CycInt_InsertInt()

        So remove the n >= 0 check from the while-loop condition to silence 
        a warning by Coverity. Use an assert() instead, just to be sure.
        [30c9c562]

2023-09-28 Nicolas Pomarede

        Update fullscreen png used in 'make test' (last line was blanked by
        mistake)
        [18d78330]

2023-09-27 Nicolas Pomarede

        When Vblank signal is set to ON, ensure blanked lines are the
        correct ones (thanks to Anders and Troed for the report) Previously,
        line 307 was blanked on a 50 Hz screen, while it should be line 308
        [61c28c6b]

2023-09-26 Eero Tamminen

        Nicer negative offsets from profile post-processor

        Show negative offsets without adding redundant '+' char.
        [516f44b2]

2023-09-25 Eero Tamminen

        Better logic for replacing C symbols without leading underscore

        ELF toolchain can produce C symbols without leading underscore, so
        need to check both the current and previous name for whether they
        look like C/C++ symbols, like Hatari debugger already does.
        [00408471]

2023-09-17 Eero Tamminen

        Update EmuTOS status

        Roger fixed line-A variables for TC mode.
        [7c846b71]

2023-09-23 Eero Tamminen

        Fix potential stale file pointer use in msg repeat output

        Change here make things more robust in case log init and uninit
        could
        (in future) be called multiple times during Hatari lifetime.

        Otherwise message repeat output could have use stale (cached) file 
        pointer only if log file pointer was changed in Log_Init(), called 
        from Main_Init(), from pointer set in Log_Default(), called from 
        main(), _and_ there were repeated log messages between those during 
        Hatari startup.
        [fea55c60]

2023-09-25 Nicolas Pomarede

        Use ARRAY_SIZE instead of sizeof in SCC_Get_Standard_BaudRate()
        [55b9a481]

2023-09-24 Thomas Huth

        Avoid unbounded strcpy()
        [0497d155]

2023-09-24 Thomas Huth

        Remove superfluous line
        [3ab3c507]

2023-09-24 Thomas Huth

        GemDOS_FileName2HardDriveID() can fail, check return code
        [46b16283]

2023-09-24 Thomas Huth

        Check for file handle != NULL before running fclose() on it
        [be0f7a69]

2023-09-24 Thomas Huth

        Fix 68030 PLOAD disassembly

        Taken from WinUAE commit fe5acda2f61fc22207b88838bc4517e5c12ba8bb
        [0cdd05fa]

2023-09-24 Thomas Huth

        stat() can fail, so check return value
        [07c242b5]

2023-09-24 Thomas Huth

        Do some more sanity checks on boot sector values
        [ba74be10]

2023-09-23 Nicolas Pomarède

        Add missing define 'WITH_SOFTFLOAT' (fix crash when starting with
        'Accurate FPU emulation' enabled)
        [14eec0f5]

2023-09-23 Thomas Huth

        Fix setting of two stop bits
        [079b7a08]

2023-09-23 Thomas Huth

        filesize is unsigned, so not usable for comparison with < 0
        [de25c098]

2023-09-23 Thomas Huth

        Avoid accessing FileHandles[] with negative fh_idx
        [e2249702]

2023-09-23 Thomas Huth

        Check return codes to make static analyzers happy
        [6dd681a2]

2023-09-23 Thomas Huth

        Use abort() in unreachable code to help with static analyzers
        [c0c18f6f]

2023-09-20 Nicolas Pomarède

        softfloat fix (by Andreas Grabher for Previous) (from WinUAE 5.1.0
        beta1+ 2023/09/20)
        [84e86fc0]

2023-09-20 Nicolas Pomarède

        Autovectored interrupts in MMU/generic CPU modes fix (from WinUAE
        5.1.0 beta1+ 2023/09/20)
        [afb831e8]

2023-09-19 Nicolas Pomarède

        MMU/generic CPU mode autovectored interrupt support (from WinUAE
        5.1.0 beta1+ 2023/09/19)
        [eb446763]

2023-09-18 Eero Tamminen

        Change loaded C++ data symbols type based on symbol names

        This is minor performance optimization for profiler, as it can
        greatly reduce number of code symbols for C++ code.

        Toolchain marks symbols as text, based on which section it has added 
        them.  However, from Hatari usage point of view, whether given
        symbol actually represents runnable code, is more relevant.

        So, after symbols have been loaded, and offset based on their
        section, change non-code symbols types to data, to keep code symbol
        lists smaller / faster to binary search.

        This is done only in Hatari debugger, not in gst2ascii, because
        latter could cause symbols to be offset for the wrong program
        section, when they're later loaded to debugger.
        [15e0fea7]

2023-09-17 Nicolas Pomarède

        Update WinUAE's version to 5.1.0 beta1 2023/09/17
        [4bdfde7f]

2023-09-17 Nicolas Pomarède

        Debugger FPU output fix (from WinUAE 5.1.0 beta1 2023/09/17)
        [b561d1bb]

2023-09-17 Nicolas Pomarède

        MMU mode MOVEM.x <regs>,-(An) where <regs> includes target An update
        (from WinUAE 5.1.0 beta1 2023/09/17)
        [4e8f01bd]

2023-09-17 Nicolas Pomarède

        FIx FABS(-0) (from WinUAE 5.0.0+ 2023/07/16)
        [7b292b20]

2023-09-17 Nicolas Pomarède

        Amiga chipset updates, part 1 (not used in Hatari) (from WinUAE
        5.0.0+ 2023/07/16)
        [1e0c87cd]

2023-09-17 Nicolas Pomarède

        m68k RESET instruction activates warp mode reset (not used in
        Hatari) (from WinUAE 5.0.0+ 2023/07/25)
        [b0804deb]

2023-09-17 Nicolas Pomarède

        Added debugger reset commands (not used in Hatari) (from WinUAE
        5.0.0+ 2023/07/24)
        [94a46657]

2023-09-16 Eero Tamminen

        Improve post-processor data symbol ignoring

        Some C++ symbols (of "t" type) may be data, and some other, weak C++
        (of "W" type) may even be in data section.  Neither of them are 
        needed, but latter may also trigger post-processor checks for code 
        addresses outside text section (checks for catching wrong symbol 
        file being used), so they need to be weaned out.
        [9756e36b]

2023-09-13 Nicolas Pomarède

        Return vector=24 if a spurious interrupt happens during the IACK
        sequence
        [cc0df7c9]

2023-09-13 Nicolas Pomarede

        Remove some debug printf's for SCC
        [7a228cba]

2023-09-13 Nicolas Pomarede

        Also add a 5 VBL's delay at the end of mfp and midi serial tests (to
        be safe in the future)
        [de1ae0d2]

2023-09-13 Nicolas Pomarede

        Remove unused function do_specialties_interrupt()
        [6a95a47f]

2023-09-13 Nicolas Pomarede

        When testing transfer over serial with the SCC, wait 5 VBL after the
        last byte before exiting We wait a few VBL's to be sure all the
        bytes were transfered/received, else scc_ser.tos will exit but 2
        bytes can be lost and are never received
        [01b96eef]

2023-09-13 Nicolas Pomarede

        Add missing -iinclude directive in AHCC .prj files
        [56ca1881]

2023-09-12 Nicolas Pomarède

        Always set TBE bit in SCC_Copy_TDR_TSR()
        [eabb3549]

2023-09-12 Nicolas Pomarède

        In case of TX underrun in the SCC, don't send again the previous
        byte but stay in 'stop bit' state
        [a59a8b2e]

2023-09-12 Eero Tamminen

        Add some useful info on running and building tests

        Based on recent mailing list discussions.
        [e086ffdd]

2023-09-12 Nicolas Pomarede

        Update the 'All Sent' bit in SCC's RR[1] when TSR becomes empty/full
        [13a354fc]

2023-09-12 Nicolas Pomarede

        Add support for a VBL counter at $462 in the fake TOS used for "make
        test" This fake TOS will set SR=0x300 when running to allow VBL
        interrupt (instead of SR=0x700 before, which disabled all
        interrupts)
        [678b060d]

2023-09-08 Nicolas Pomarede

        In SCC_WriteDataReg don't clear TBE bit if SCC_Copy_TDR_TSR() was
        called immediately
        [d46cb6fc]

2023-09-08 Nicolas Pomarede

        Ignore old SCC code that used OS's state for RX_CHAR and TBE, this
        conflicts with the new code that handles these internaly The new
        code uses some timers to get accurate timings of when TX/RX states
        are changing giving some cycle accurate TX/RX interrupts from the
        point of view of the emulated machine, which should not depend on
        how the underlying is buffering/sending data over serial lines
        [ad4b64e6]

2023-09-05 Nicolas Pomarède

        Don't call SCC_serial_setData() in case nothing was written to WR[8]
        [9626a2d2]

2023-09-05 Nicolas Pomarède

        Change order of operations in SCC_WriteDataReg : first copy TDR to
        TSR then update flags
        [025e70e1]

2023-09-05 Nicolas Pomarède

        SCC_WriteDataReg should store the byte to WR[8]
        [b458d238]

2023-09-09 Thomas Huth

        Use a different condition for the repo-sync github mirror job

        Using secret variables does not work - let's check the repository 
        location instead to only run the sync for the main repository.

        Thanks to Chris Jenkins for the original version of the patch.
        [0b970a0f]

2023-09-09 Thomas Huth

        include(CheckSymbolExists) for check_symbol_exists() in the main
        CMakeLists.txt

        We are using check_symbol_exists(), so we should include the
        corresponding module in case it does not get loaded indirectly by
        one of the FindXXX files.

        Patch taken from the Gentoo project.
        [69b25960]

2023-09-09 Thomas Huth

        Only run repo-sync.yml if MIRROR_PAT has been set

        Otherwise this github action will fail for repositories where this 
        has not been set.
        [c60d5cf7]

2023-09-07 Eero Tamminen

        EmuTOS TC support update
        [e9c84dbb]

2023-09-03 Eero Tamminen

        Update release notes and debugger & gst2ascii documents
        [1da2ad6b]

2023-09-06 Eero Tamminen

        Add gst2ascii option to filter out address duplicates

        Make it also default, similarly to Hatari debugger.

        symbols_trim_names() needs to moved to common code for this.
        [74ff7b95]

2023-09-03 Eero Tamminen

        Some gst2ascii option handling improvements

        - Enable all reasonable filtering options by default
        - Allow filtered out symbol types to be enabled again
         (in case one wants to see what symbols defaults drop)
        [f03e2355]

2023-09-03 Eero Tamminen

        Improve duplicate symbol check functions

        In both the address and name check functions, list each address and
        name that has duplicates, only once, not per duplicate.
        [a3ef7d49]

2023-09-02 Eero Tamminen

        Change "symbols" command to skip duplicate addresses

        Add it as internal option, which can be later used by gst2ascii.

        Relies on address sorting heuristics added in previous commit.

        With reduction in duplicates, include file name symbols again.
        [8e3ba4de]

2023-09-02 Eero Tamminen

        Sort symbol addresses further based on their names

        With heuristics similar to profiler post-processor.

        Used by next commit.
        [17e6d88d]

2023-09-01 Eero Tamminen

        Move symbol name identification functions earlier

        And split local symbol checking to its own helper.

        This is preparation for using them in address sort function
        (without needing to add separate declarations for them).
        [f40d50bf]

2023-09-06 Eero Tamminen

        Add missing Videl TODO to todo.txt
        [c71c7f41]

2023-09-03 Nicolas Pomarède

        Connect the SCC's IRQ line to the CPU using level 5 interrupt
        [d848b61d]

2023-09-03 Nicolas Pomarède

        Remove some debug printf's
        [a452b475]

2023-09-03 Nicolas Pomarède

        Handle latches when accessing SCC's RRO and when an IP is set in RR3
        + command "Reset Ext/Status Int" in WR0
        [b593eb7b]

2023-09-02 Nicolas Pomarède

        When SCC runs in asynchronous mode, TX_UNDERRUN_EOM bit should be
        set to 1 in RR0
        [60f3a856]

2023-09-02 Nicolas Pomarède

        Add more logs for SCC's WR0 commands
        [08f82d2c]

2023-09-02 Nicolas Pomarède

        Update SCC's RR3 on every source change, not just when bit was set +
        clear ZERO_COUNT source
        [0095e6d3]

2023-09-02 Nicolas Pomarède

        SCC will trigger the TBE int when TX buffer becomes empty, not when
        it is empty This means we need to keep track of writes to data
        register and allow TBE int only if TX_Buffer_Written==true
        [00989206]

2023-08-23 Nicolas Pomarède

        Update RR3 and IRQ state when writing to SCC's WR1 or WR9 or WR15
        [8806a6f3]

2023-08-22 Nicolas Pomarède

        Change SCC_Get_Vector_Status() regarding status high/low bit
        [8f28bd51]

2023-08-22 Nicolas Pomarède

        Remove old/unused IRQ code
        [024a37d7]

2023-08-22 Nicolas Pomarède

        Correctly restore bits 2,3,4 in WR9 after software full reset of the
        SCC
        [c3f74f0f]

2023-08-22 Nicolas Pomarède

        Improve SCC : when BRG reaches zero, do a 0-1-0 transition on the ZC
        bit in RR0 to better match real HW
        [d525fdcd]

2023-08-20 Nicolas Pomarède

        Improve SCC : fix some cases for RR[] content
        [c0579739]

2023-08-20 Nicolas Pomarède

        Remove old/unused IRQ code
        [6bf0e9eb]

2023-08-20 Nicolas Pomarède

        Improve SCC : use IUS for IRQ, add Software/Hardware IACK, improve
        RR2
        [ec8fefb2]

2023-08-18 Nicolas Pomarède

        Remove old code to reset SCC's channels
        [9c551843]

2023-08-18 Nicolas Pomarède

        Improve SCC : add more interrupt sources, improve pending interrupts
        in RR3 and IRQ line's state
        [59b31bb2]

2023-08-15 Nicolas Pomarède

        Improve SCC : rewrite handling of RX data
        [4c0e2bfa]

2023-08-06 Nicolas Pomarède

        Call SCC_WriteDataReg instead of SCC_serial_setData when writing to
        data reg at $FF8C83 or $FF8C87
        [7f1a85dc]

2023-05-11 Nicolas Pomarède

        Improve SCC : add internal timers for TX/RX on channels A/B, number
        of bits for parity/char/stop, TBE bit for TX
        [168c22b2]

2023-04-02 Nicolas Pomarède

        Improve SCC : Active_Reg is common to both channels
        [5528e98e]

2023-04-01 Nicolas Pomarède

        Improve SCC : simplify SCC_handleRead and SCC_handleWrite
        [060226b7]

2023-04-01 Nicolas Pomarède

        Improce SCC : remove hardcoded/limited table of baudrates associated
        to WR12/WR13 and use SCC_Compute_BaudRate instead
        [1be34c63]

2023-04-01 Nicolas Pomarède

        Improve SCC : rename SCC.chn to SCC.Chn, better support for RR0,
        RR2, WR0, WR9 and WR15
        [0bae0705]

2023-03-23 Nicolas Pomarède

        Improve SCC : rewrite the SCC struct to store the 2 channels as well
        as some common variables
        [16eca5a3]

2023-03-22 Nicolas Pomarède

        Improve SCC : replace RR3/RR3M by RR[] and IUS register
        [7e33e65e]

2023-03-20 Nicolas Pomarède

        Improve SCC : add internal timers for the baud rate generator and
        handle zero count interrupt
        [bd7bcdd3]

2023-03-15 Nicolas Pomarède

        Improve SCC : support all clocks/machines type to compute baud rate,
        don't use hardcoded values to get standard baud rates
        [8ff45843]

2023-03-08 Nicolas Pomarede

        Improve SCC : add notes about clocks, add separate read/write
        registers, fix reset commands, preliminary baud rate calculation
        [ecdc1501]

2023-09-01 Eero Tamminen

        Add support Windows file names in breakpoint options

        By requiring that all breakpoint options are prefixed with a space:
        :once :file C:\BT.INI :quiet

        Reported by Tat:
        https://www.atari-forum.com/viewtopic.php?p=450556#p450556
        [c0265b9e]

2023-08-31 Eero Tamminen

        EmuTOS compatiblity doc update

        - >v1.1.1 meant newer snapshots, >=v1.2 means it's in release
        - Separate Hatari specific issues to their own lists
        - Few additional Falcon games work with EmuTOS
        - More info on remaining Falcon issues
        [047d4f29]

2023-08-31 Eero Tamminen

        Add Monism to compatibility lists
        [9c258efc]

2023-08-30 Eero Tamminen

        Silently ignore no-name symbols related to ELF section names

        To lessen debugger messages to users on things known not to be
        issues.

        Contributed by Thorsten Otto.
        [f3699cdd]

2023-08-30 Eero Tamminen

        Update docs for MINT+ELF support
        [df6f7c66]

2023-08-30 Eero Tamminen

        Fix ELF symbol reading crash

        'strtabidx' cannot be compared to -1 unless it's signed, and it
        should be larger than 16-bit when 32-bit value is assigned to it.
        Make also sure that assigned index is within array size, before
        accessing it.
        [a3ea6599]

2023-08-30 Eero Tamminen

        De-duplicate symbol table offset seeking code
        [6fd9d41b]

2023-08-30 Eero Tamminen

        Fix symbols-common.c code formatting

        To be consistent with rest of the code in that file and other symbol 
        handling related code.
        [84b564fe]

2023-08-29 Eero Tamminen

        Debug symbol support for upcoming MINT+ELF program format

        Contributed by Thorsten Otto.
        [83dafe07]

2023-08-25 Eero Tamminen

        EmuTOS Falcon compatibility updates
        [a8942075]

2023-08-27 Eero Tamminen

        Use named argument values for PortMidi helper functions

        To make clearer what their integer & boolean argument values are
        for.
        [68aa7b5f]

2023-08-29 Eero Tamminen

        Fix symbol address sort check

        Address check needs to be after symbol type check, otherwise it can 
        trigger on code->non-code type change, if non-code symbols start
        from lower address than the last code one (e.g. ABS symbols, or if
        compiler puts some data symbols to text section).

        Also improve function name & comments a bit.

        Fixes: e4c8dc742a
        [79d7fdcf]

2023-08-29 Eero Tamminen

        Fix ASCII symbols alloc leakage & free them at exit
        [f294e06a]

2023-08-27 Eero Tamminen

        Fix Midi_Host_GetPortName() crash

        Fix (Mac regression) crash when Midi_Host_GetPortName() is called
        with NULL, and return first port name also when called with empty
        string
        (using positive name offset).

        Reported-by: Chris Jenkins Fixes: 957d7db465970d1e
        [373fb663]

2023-08-27 Thomas Huth

        Add mapping for "(" and ")" in the keypad
        [de0db338]

2023-08-13 Brad Smith

        Fix for `~

        https://github.com/hatari/hatari/pull/26
        [af03fe0e]

2023-08-13 Brad Smith

        Fix keymappings for [{ and ]}

        https://github.com/hatari/hatari/pull/26
        [a253a405]

2023-08-14 Brad Smith

        Fix LED restore logic ("incompatible" was a backwards test)

        From https://github.com/hatari/hatari/pull/27
        [28931d13]

2023-08-24 Eero Tamminen

        Improve profile post-processor symbol selection heuristics

        Prefer function names over files names, and shorter C/C++ names over 
        long ones (C++ names can be long, and aliases add extra underscore 
        prefixes), but for things thought as asm symbols, prefer longer 
        symbols.

        Unlike latest (ELF) g++ version(s), earlier g++ version(s) seem to
        put typeinfo & vtable data objects to code section and annotate them
        as being weak text symbols.  Prune those out when loading symbols.
        [5b7eb9b4]

2023-08-23 Eero Tamminen

        Minor symbol handling improvements

        Use opt & ignore count structs + helpers also for ASCII symbol
        loading.

        Rename count struct 'unwanted' member to 'notypes' for consistency 
        with options struct.

        Split GCC internal symbols option from file/path symbols one:
         gst2ascii -o => gst2ascii -f -g

        Sort options and struct members for readability.
        [d6c12a32]

2023-08-21 Eero Tamminen

        Load weak symbols by default, but allow dropping them

        Add weak symbols as their own symbol type. Load them by default, as 
        C++ template methods seem to be available only as weak symbols.

        (This means there can be a lot more symbol address duplicates, so
        they will need to be handled better.)

        Split different a.out binary weak symbol types to proper categories.
        [e4c8dc74]

2023-08-19 Wayne Conrad

        Add unit test build product to .gitignore
        [4364afd5]

2023-08-22 Thomas Huth

        Silence warnings from CMake 3.27

        CMake 3.27 warns that compatibility with older versions than 3.5
        will be dropped soon, so bump the minimum version to 3.5 now.

        It also complains that FindPythonInterp will soon be going away. For 
        the time being, we can switch off the warning by setting policy 148 
        to "OLD".
        [b509681d]

2023-08-12 Thomas Huth

        Update the FreeBSD CI to v13.2
        [d358048f]

2023-08-07 Eero Tamminen

        Update docs for joystick button handling changes
        [a3e4b6da]

2023-08-07 Eero Tamminen

        Align + pad joy GUI buttons, and get rid of magic values

        String updates need to take into account size of the target
        strings...
        [c128e353]

2023-08-07 Eero Tamminen

        Add joystick button descriptions and generalize mapping code

        By using button mapping array instead of separate variables.

        v2: minor tweaks from Robin.
        [7efa759e]

2023-08-06 Robin Sergeant

        Fix event handling order in joy button remapping GUI

        v2: add another condition to stop ESC key repeats being handled.

        If you hold ESC before opening the dialog SDL keeps generating
        KEYDOWN events.  Nobody would ever actually do that, but only
        handling the first KEYDOWN is logical.
        [3bb814f8]

2023-07-30 Robin Sergeant

        Add SDL GUI for joystick button config
        [b0c15d53]

2023-07-30 Robin Sergeant

        Add joystick button configuration
        [a9b4fd38]

2023-08-07 Eero Tamminen

        Fix GEMDOS HD Frename() handling

        It should fail when target exists: 
        https://www.atari-forum.com/viewtopic.php?t=42581

        Reported-By: TheNameOfTheGame
        [009c4cc5]

2023-08-01 Eero Tamminen

        Document 2 additional GEMDOS HD limitations
        [133176a4]

2023-07-31 Eero Tamminen

        Fix regaddr command buffer sizes

        Buffer sizes were inverted, larger addresses do not fit into 6
        chars.

        Potential fix for: https://www.atari-forum.com/viewtopic.php?t=42939
        [a85b4bd2]

2023-07-31 Eero Tamminen

        Double limit on number of GEMDOS HD file handles

        To support ScummVM "Illusions" game engine, which uses more than 32 
        open file handles supported by GEMDOS HD, double that amount to 64.

        Notes:
        * (Emu)TOS support 75 file handles in addition to the standard 6
        ones
        * Like earlier, GEMDOS HD handles start from index 64, so that first
         64 handles are left for underlying TOS, to be used with other than
         GEMDOS HD drives.

        I.e. in total apps could now use 128 handles, if open files were on 
        different disks, but if more than 64 handles are used on TOS side, 
        things do not work corretly => Document these limits in the manual.
        [2543a0cc]

2023-07-28 Eero Tamminen

        Add missing Fopen() return value trace output

        GEMDOS HD emulation has fewer free handles available than e.g.
        EmuTOS (32 vs 75) so it's important to notify user about that.
        [1b42c9fb]

2023-07-27 Eero Tamminen

        Document joystick button bit defines better
        [33d3b0b4]

2023-07-27 Eero Tamminen

        Use fnmatch for the provided profiler post-processor symbols

        This helps in providing e.g. all functions having specific prefix, 
        or belonging to a specific C++ class, to "--only", "--ignore" and
        "--ignore-from" options.
        [90486140]

2023-07-27 Eero Tamminen

        Improve texts in release notes and group debugger changes
        [b9efe125]

2023-07-19 Nicolas Pomarède

        Merge branch 'master' of https://git.tuxfamily.org/hatari/hatari
        [0bbf5801]

2023-07-19 Eero Tamminen

        Drop patch now that m68k Linux bus error handler is fixed
        [c7196c93]

2023-07-19 Eero Tamminen

        Update Linux kernel config to v6.4

        Added seccomp syscall support, now that m68k supports it.
        [2b1b9a00]

2023-07-16 Eero Tamminen

        Add few demos, game and Falcon app to compat lists

        Replay is really nice demo, but as it's for ST, added it only to 
        EmuTOS compatibility.
        [72332139]

2023-07-17 Nicolas Pomarède

        Check interrupt level immediately always if not JIT (from WinUAE
        5.0.0+ 2023/07/10)
        [b07b08ad]

2023-07-17 Nicolas Pomarède

        Randomize emulator startup state by default (not used in Hatari)
        (from WinUAE 5.0.0+ 2023/07/09)
        [9af67fec]

2023-07-17 Nicolas Pomarède

        IPL low/high delay is optional and off by default (not used in
        Hatari) (from WinUAE 5.0.0 beta15 2023/05/28)
        [9a3aa3e8]

2023-07-15 Nicolas Pomarède

        Misc changes (not used in Hatari) (from WinUAE 5.0.0 beta14
        2023/05/26)
        [559998f8]

2023-07-15 Nicolas Pomarède

        jit_blacklist fix (from WinUAE 5.0.0 beta10 2023/05/16)
        [ccdad168]

2023-07-15 Nicolas Pomarède

        Misc change to debugger (not used in Hatari) (from WinUAE 5.0.0
        beta10 2023/05/14)
        [b7f2f7b7]

2023-07-15 Nicolas Pomarède

        Chained breakpoints, signed/unsigned comparison option (not used in
        Hatari) (from WinUAE 5.0.0 beta8 2023/05/01)
        [01e9baf6]

2023-07-15 Nicolas Pomarède

        Fix FMOVE.L/FMOVEM.L <control registers> register order (from WinUAE
        5.0.0 beta7 2023/04/23)
        [95eb024c]

2023-07-15 Nicolas Pomarède

        Add debugger calculator comparison operators (not used in Hatari)
        (from WinUAE 5.0.0 beta6 2023/04/15)
        [37577fcc]

2023-07-15 Nicolas Pomarède

        State restore cpu trace fix (from WinUAE 4.10.2 beta3 2023/04/011)
        [84f81cd7]

2023-07-15 Nicolas Pomarède

        Debugger register read update (from WinUAE 4.10.2 beta2 2023/03/25)
        [62b9735d]

2023-07-15 Nicolas Pomarède

        Report debugger breakpoint hits also during single step tracing (not
        used in Hatari) (from WinUAE 4.10.2 beta2 2023/03/25)
        [cf050287]

2023-07-01 Eero Tamminen

        Add "cpu_video_cycles" also to Python UI trace dialog
        [ee8137d2]

2023-06-30 Eero Tamminen

        Separate CPU video cycles under its own trace flag

        As requested on: 
        https://www.atari-forum.com/viewtopic.php?p=448383#p448383
        [0e4f1992]

2023-05-04 Eero Tamminen

        Include dir create/removal + file removal to "os_base" traces

        While those are rarer, they are at least as important operations to 
        know as file create / close (and pexec) operations.
        [510557e8]

2023-03-06 Eero Tamminen

        EmuTOS compatibility update

        Donkey includes GFA basic source:
        https://www.atari-forum.com/viewtopic.php?t=42754
        [8e3d315d]

2023-05-09 Eero Tamminen

        Add option to limit listed symbols to ones containing given string

        Most demangled C++ symbol names contain special characters [1] not 
        accepted by debugger commands.  Symbols can be replaced with their 
        addresses, but first one needs to find what address given symbol has
        (as symbol file address offset depends on program load address).

        Substring search for (C++) symbol address list will help with that, 
        along with TAB completion for the "symbols" command completing
        symbol names (when there was no match for a subcommand name).

        [1] Characters like the ':' bactrace option prefix, comparison
           operators, whitespace etc.
        [e8a902a5]

2023-05-01 Thomas Huth

        Add a macOS 12 Cirrus-CI task to build snapshots
        [024cc3f4]

2023-05-01 Thomas Huth

        Add hatari.app.xcent file

        It will be used during the code signing step on macOS. Thanks to
        Troed Sångberg for the file.
        [858fe8c3]

2023-05-01 Thomas Huth

        Improve macOS settings

        Thanks to Andreas Grabher and Troed Sångberg for their input
        [fbadfeba]

2023-04-23 Thomas Huth

        Silence cppcheck warning about shifted value changing its signedness
        [6b23ff07]

2023-04-23 Thomas Huth

        Avoid memory leak in read_pc_debug_names()
        [3354e7d8]

2023-04-17 Thomas Huth

        tcgetattr() can fail - check the return value
        [945d084b]

2023-04-17 Thomas Huth

        Add a wrapper for the calculation of the DMA mask

        ... and apply it to the address calculation when loading snapshots,
        too
        (just in case, to avoid that we access STRam beyond its end here)
        [9a50f6eb]

2023-04-16 Thomas Huth

        Check for availability of -Wimplicit-fallthrough=2 before using it

        Older versions of GCC and Clang do not support this option yet, so 
        we should check first whether we can use it.
        [f079a0f3]

2023-04-16 Thomas Huth

        Compile with -Wimplicit-fallthrough=2

        Warnings about unintended fallthroughs are very useful, so let's
        enable these now. The comments in fdc.c need some adjustments for
        this compiler switch, but fortunately they were already saying that
        the fallthrough is indeed intended here.
        [8dc1fe6c]

2023-03-30 Eero Tamminen

        Show PortMidi device prefix matches also in GUI

        Midi functionality already did prefix matching on devices and opened 
        them, but it did not update the config value to full MIDI device
        name. This was to avoid breaking prefix matching for devices which
        names
        (e.g. port) changes frequently.

        With this change, same matching is done for names shown in GUI, to 
        avoid confusing users.  Downside of this is that visiting devices 
        dialog WILL replace the prefix in config setting with a full device 
        name.  I.e. saving settings afterwards, will override the prefix in
        config file.
        [957d7db4]

2023-03-28 Eero Tamminen

        Shorten further c++ method args for callgraphs

        Although there are no spaces to indicate potentially multiple args
        in a signature, single C++ argument could be a really long, so use 
        shortening match regexp on any symbol that has either space or "::".

        Add also few extra example texts for operators, as those may not be 
        easy enough to differentiate if they are shortened too much.
        [9f78f510]

2023-03-24 Eero Tamminen

        Improve profile post-processor output description
        [4e584982]

2023-03-19 Eero Tamminen

        Apply --compact option also to callgraph edges

        Although parent would call the child node from multiple places, 
        showing just single connection between those two nodes makes
        resulting graph much more readable.
        [5f6d8e6b]

2023-03-19 Eero Tamminen

        Post-processor variable renames for readability

        Upper-case indicates that variable is not intended for modification.

        And few comment changes.
        [c008e3f6]

2023-03-18 Eero Tamminen

        History handling improvement for repeating instructions

        When e.g. program uses "stop" instruction to wait for something, it 
        showed as repeated instructions, that often filled the whole
        history.

        Fixed by ignoring instruction repeats for history. And counting them 
        separately, so that count of (non-zero) repeats for the last 
        instruction can be shown in history list.
        [042121b6]

2023-03-18 Eero Tamminen

        Add profile post-processor updates to release notes

        And update its symbol cleanup test script a bit.
        [d9301ac6]

2023-03-17 Eero Tamminen

        profiler: output only symbol parsing stats not all info

        Otherwise post-processor can output so much symbol resolving
        messages that actual errors are hidden in the noise.

        Verbose option can be used to still see that info.

        Added also TODO for better symbol conflict resolving.
        [38c9b00c]

2023-03-17 Eero Tamminen

        symbols: C++ '/' operator signature is not a file name symbol
        [53a0b2b3]

2023-03-17 Eero Tamminen

        profiler: disassembly addresses can be lower or upper case

        So it it needs to give post-processor a regexp handling both.
        [64be693b]

2023-03-17 Eero Tamminen

        Apply pylint suggestions to profile post-processor
        [c722092b]

2023-03-17 Eero Tamminen

        Shorten C++ symbols by default in callgraphs

        But add "--full-symbols" option to disable that.

        There's also separate script for checking how those regexps work on
        some hairy C++ signatures, which can be used when more symbol
        shortening is needed.

        It can be removed before release.
        [d87cee1b]

2023-03-17 Eero Tamminen

        Add --no-orphans profile post-processor option

        To remove unconnected nodes from callgraphs, regardless of their
        cost.

        While this makes callgraphs done with the --only option much
        clearer, it still does not remove all of them though, did not yet
        find why.
        [8cf6b57b]

2023-03-16 Eero Tamminen

        Fix evaluate command address width modifier check

        No idea how this could have gone through.

        Fixes: f6df3857f5
        [d4a83aa5]

2023-03-16 Thomas Huth

        Update to actions/checkout v3 since v2 stopped working
        [e969aa12]

2023-03-14 Eero Tamminen

        Update "socat" options for MIDI networking

        According to "socat" manual "raw" option is obsolete, and should be 
        replaced either with "rawer" or "cfmakeraw".  Both of them disable 
        echo, so that option can be removed.

        According to:
        https://www.atari-forum.com/viewtopic.php?p=444430#p444430

        MIDI can be networked between Linux and Mac OS when "socat" option
        "rawer" is used.
        [bb9e0d13]

2023-03-14 Nicolas Pomarede

        Update WinUAE's version to 4.10.2 beta2 2023/03/11
        [0dc942be]

2023-03-14 Nicolas Pomarede

        Debugger search commands now optionally support also ROM address
        spaces (not used in Hatari) (from WinUAE 4.10.1+ 2023/03/11)
        [4518b9db]

2023-03-14 Nicolas Pomarede

        Added missing #ifdef statements (from WinUAE 4.10.1+ 2023/03/03)
        [5c9306d0]

2023-03-10 Eero Tamminen

        Profiler post-processor improvements

        * Add "--separator" option that can be used when providing
         list(s) of C++ symbols (that often include commas)
        * Clarify what the shown "max" info lines are
        [b7d7d4aa]

2023-03-09 Eero Tamminen

        Workaround for theoretical button 2 SPACE key emulation issue
        [1bf57692]

2023-03-08 Eero Tamminen

        Make CPU dialog headings consistent with other dialogs

        Left aligned titles end with ':', centered titles do not.

        (And fix title object widths.)
        [f03b4a74]

2023-03-08 Eero Tamminen

        Document joystick support updates
        [00314786]

2023-03-08 Eero Tamminen

        Support joystick button 2 option in SDL GUI
        [fff4aae0]

2023-03-08 Eero Tamminen

        Support joystick button 2 option for all joysticks

        As it is already specified in Hatari configuration.

        Because TOS queries only joystick 1 (and parallel port) constantly, 
        space key emulation works for other joysticks only when game 
        explicitly queries also them.

        In theory it is also possible that button 2 space key emulation may 
        get left in pressed state for joystick 0 and joypads, if game stops 
        querying given joystick completely while user still has button 2
        down.

        For above reasons, and for consistency with earlier behavior, enable
        space key emulation only for joystick 0 by default.
        [ac104a7e]

2023-03-06 Eero Tamminen

        Fix joy button 2 space key emulation

        Earlier it worked in rapid autofire mode making it impossible to use
        for doing just a single space key press:
        https://www.atari-forum.com/viewtopic.php?p=444078

        This commit changes it to work like normal key presses.

        Simulated space key is released when the button is released, which 
        among other things meaning also that key repeat works as expected.
        [818b5a31]

2023-02-24 Eero Tamminen

        Update m68k Linux config + doc to linux v6.2 / EmuTOS v1.2.1
        [092788cf]

2023-03-04 Nicolas Pomarède

        Add 8MHz clock for SCC Z85C30 used in Mega STE/TT/Falcon
        [e8251ec1]

2023-02-27 Nicolas Pomarède

        Sync misc changes (from WinUAE 4.10.2 beta1 2023/02/25)
        [7f3f4dbe]

2023-02-27 Nicolas Pomarède

        On the fly mode change reset fix (from WinUAE 4.10.1+ 2023/02/19)
        [fe94aee2]

2023-02-27 Nicolas Pomarède

        CPU statesave update (not used in Hatari) (from WinUAE 4.10.1+
        2023/02/19)
        [97aef02f]

2023-02-26 Nicolas Pomarède

        Chipset write bufferi with 68020+ apparently does not exist (not
        used in Hatari) (from WinUAE 4.10.1+ 2023/02/10)
        [88655500]

2023-02-26 Nicolas Pomarède

        LPSTOP fix (from WinUAE 4.10.1+ 2023/02/10)
        [8def225f]

2023-02-26 Nicolas Pomarède

        Warp mode boot + Statefile accurate blitter and event support (from
        WinUAE 4.10.1+ 2023/02/10)
        [d0dba8a5]

2023-02-26 Thomas Huth

        Adjust cron schedule to a saner value
        [20308958]

2023-02-26 Thomas Huth

        Ue TABs, not spaces for indentation
        [00e03933]

2023-02-26 Thomas Huth

        Fix typo in file name
        [7923dd00]

2023-02-25 Thomas Huth

        Fix white spaces (use TABs, not spaces for indentation, remove them
        at line ends)
        [4fb10fe4]

2023-02-25 Thomas Huth

        Use Github repo-sync for mirroring to github
        [ac12d777]

2023-02-25 Thomas Huth

        Fix typo
        [111f1fd4]

2023-02-20 Eero Tamminen

        Symbols: update debugger doc + release-notes
        [0780c5cf]

2023-02-19 Eero Tamminen

        Symbols: support for program symbols override file

        If "<name>.sym" exists in addition <name>.<ext> program file itself, 
        first try to read symbols from that file, before falling back to 
        reading program symbol table.

        With this:
        * One can overriding program symbols
        * Instead of needing to provide two binaries, one with debug
         symbols, and one without, (much smaller) symbols file in
         addition to the stripped binary, suffices
        [e1e4a5bb]

2023-02-19 Eero Tamminen

        Symbols: support also demangled C++/a.out symbols

        Which can be *much* longer than DRI/GST symbols, and contain almost
        any ASCII character.

        If those symbols contain spaces (as they often do), breakpoints
        cannot be set on them, as debugger CLI interprets whitespace as
        argument separators.
        [daec3ae0]

2023-02-19 Eero Tamminen

        Profiler: add C++ symbols support note to docs
        [cca52276]

2023-02-18 Eero Tamminen

        Profiler: drop C++ symbol demangling helper script

        Now that post-processor has proper support for demangled input.
        [bc5e3ea4]

2023-02-19 Eero Tamminen

        Profiler: skip mangled C++ symbols for caller info

        This completes profile post-processor support for handling profile 
        data with demangled C++ symbols (in disassembly & symbol files).

        Caller info symbols are used only for (manually) debugging profiler 
        functionality, and need to do that for C++ is very unlikely.
        Dropping them guarantees new data works with older post-processor
        and vice verse, where as changing caller info format to accommodate
        C++ symbol parsing would have broken that.
        [2e40080a]

2023-02-19 Eero Tamminen

        Profiler: accept demangled C++ symbol names

        This assumes both profile data and symbols file have been demangled
        (with "m68k-atari-mint-c++filt") *before* being post-processed.

        Full support for post-processing profiles with demangled C++ symbol 
        names (which can contain almost any characters), requires also 
        additional change in Hatari debugger profiler support (next commit).
        [63a85c14]

2023-02-18 Eero Tamminen

        Profiler: conflict rename for mangled C++ symbols

        Switch to using "<len><str>" [1] or ".<idx>" [2] suffix, depending
        on whether symbol looks like mangled, and which one is less likely
        to break demandling.

        This assumes demangling is done *after* profile is post-processed.

        [1] Shown after demangling looking like "(AA)"

        [2] For some mangled symbols it's interpreted as vendor extension,
           typically shown as "[clone <idx>]"
        [30657a8c]

2023-02-14 Nicolas Pomarède

        Add more detalled traces when accessing SCC registers
        [d5be217c]

2023-02-13 Eero Tamminen

        Deprecate some of the Hatari FIFO / socket shortcut commands

        As debugger commands provide (nowadays) more flexible replacements
        for the listed shortcut commands, deprecate them for eventual
        removal.
        [dd6ba9ff]

2023-02-05 Thomas Huth

        Make floppy.c independent from the SDL headers

        The code looks nicer and more compact this way.
        [a1ac1767]

2022-10-18 Eero Tamminen

        Remove <SDL_endian> usage from lilo.c
        [78d7b27b]

2023-01-31 Eero Tamminen

        Fix: mouse for floppy disk dialog shortcut in fullscreen

        Mouse was not visible in floppy disk selection dialog when it was 
        invoked from a keyboard shortcut in fullscreen mode.

        Bug report and fix suggestion by "jmmparis" at Atari-forum
        (thanks!):
        https://www.atari-forum.com/viewtopic.php?p=442783

        He suggested fixing it in SDLGui_FileSelect(), but as mouse is
        missing only when being invoking from a shortcut, and not from
        Hatari options
        (which already does necessary SDL mouse calls for fullscreen), I 
        thought shortcut.c better place.

        If any other interactive items are later invoked from shortcuts,
        mouse handling for those could then be generalized.

        PS. This is old bug, it was already in the oldest Hatari version I 
        tested, v2.2.1.
        [a36c54b0]

2023-01-25 Nicolas Pomarede

        Sync misc changes (from WinUAE 4.10.1 2023/01/23)
        [9f58fa6a]

2023-01-24 Nicolas Pomarede

        Update notes
        [ca4f2667]

2023-01-24 Nicolas Pomarede

        Add support for 4 pixel hardscroll when stopping shifter When
        writing 3 to $FF8260, GLUE will switch to High res, but shifter will
        go to a 'stopped' state which can be used to create 4 pixel
        hardscroll on STF This was discovered by Troed/Sync and used in his
        "What If" game preview
        [92e6eed7]

2023-01-21 Thomas Huth

        Fix and use emscripten_shell.html
        [72a5e53a]

2023-01-14 Eero Tamminen

        Add profiling helper script to demangle/shorten C++ symbols

        In the .dot call graph files generated by profile data
        post-processor.

        Mangling format is compiler specific. Because GCC format has been 
        stable since v3.x, and nobody uses v2.x on Atari (for C++),
        eventually profile post-processor could have "--demangle" option to
        use "c++filt" directly to demangle (+ shorten) symbols on output.
        This script should be enough for now though.

        If Hatari debugger would also get C++ demangling support [1], that 
        also needs to be done only on output. C++ types are so much
        line-noise that they are better handled in mangled form internally,
        and demangled only on output.

        [1]
        https://gcc.gnu.org/onlinedocs/libstdc++/manual/ext_demangling.html
        [87f27924]

2023-01-14 Eero Tamminen

        Fix: CPU disassembler crashes with longer symbols

        (This is more of a workaround.  I think whole WinUAE CPU core 
        disassembler code would need refactoring to pass around the buffer 
        sizes, and check them.)

        Reported-By: Miro Kropáček Fixes: 62331b8e592c2d8dac8
        [8f8752e2]

2023-01-14 Eero Tamminen

        List removed features separately from improvements
        [d0bf64e0]

2023-01-08 Eero Tamminen

        Fix: use country code setting to set TOS country code

        Fixes: 8d0a7ce74ff5185f1c6f7ffa5fd89454d075ccf8
        [a59995ac]

2023-01-12 Nicolas Pomarede

        Do not reset 68030 MMU state if loading statefile (from WinUAE
        4.10.1 beta3+ 2023/01/11)
        [0741b9ea]

2023-01-12 Nicolas Pomarede

        Fix CALLM disassembly (from WinUAE 4.10.1 beta3+ 2023/01/11)
        [bff58421]

2023-01-12 Nicolas Pomarede

        Update SR before dumping CPU state + reset cpu when reloading
        savestate (from WinUAE 4.10.1 beta3+ 2023/01/11)
        [b50c555e]

2023-01-11 Eero Tamminen

        Update also Hatari UI doc install & run-time paths

        Otherwise "make install" fails.

        Reported-By: Yves Le Berre
        [2915769d]

2023-01-05 Eero Tamminen

        Use common CSS & ToC generator for Hatari UI doc

        Also add doc info & re-order images a bit for better readability.
        [388b1f32]

2023-01-05 Eero Tamminen

        Move Hatari UI HTML documentation under doc/

        So that it gets automatically exported to Hatari site.
        [e1381f17]

2023-01-05 Eero Tamminen

        Minor updates to hatariui script
        [73ff275a]

2023-01-05 Eero Tamminen

        Minor updates to python-ui TODO list
        [f688d44f]

2023-01-03 Nicolas Pomarede

        Sync misc changes (from WinUAE 4.10.1 beta2 2023/01/02)
        [6ce7774d]

2023-01-02 Nicolas Pomarede

        Change wording for disasm options (suggested by Christian Zietz)
        [7c3c359a]

2022-12-31 Thomas Huth

        Make tos.c independent from the SDL library
        [213187b2]

2022-12-30 Eero Tamminen

        Add notes about Monscope fix
        [ac77d90c]

2022-12-30 Thomas Huth

        Convert last sprintf in the DSP code into snprintf

        Thanks to Andreas Grabher for the patch!
        [7301eff3]

2022-12-30 Nicolas Pomarede

        In the case of the TT, DMA sound FIFO should be updated on each HBL
        (same as STE)
        (fix sound in 'Monscape' monochrome demo by Escape)
        [5005f23a]

2022-12-30 Thomas Huth

        Do not include SDL headers in clocks_timings.c (not needed here)
        [9e21fd1e]

2022-12-30 Thomas Huth

        Make msa.c independent from the SDL library

        This hopefully helps to fix a linking problem of the hmsa tool with
        the latest version of MSYS2 on Windows.
        [6f893900]

2022-12-29 Thomas Huth

        Update Info-Hatari.plist

        Add "NSMicrophoneUsageDescription" key - according to Andreas
        Grabher, this is required for microphone access on macOS >= 10.14.

        And while we're at it, bump the minimum system version to 10.9 since 
        this is the minimum version that is supported by Troed's macOS
        builds.
        [c55ad9dc]

2022-12-29 Thomas Huth

        Remove "Info-Hatari Winuae.plist" file

        We do not provide the possibility to compile with different CPU
        cores anymore, so this file should not be required anymore.
        [03b6a5cc]

2022-12-29 Nicolas Pomarede

        Update WinUAE's version used for CPU core
        [9ede5067]

2022-12-29 Nicolas Pomarede

        Add ARM64EC compatible build (from WinUAE 4.10.0+ 2022/12/25)
        [dd1312a0]

2022-12-29 Nicolas Pomarede

        Add SR to debugger register output (from WinUAE 4.10.0+ 2022/12/21)
        [002c808f]

2022-12-29 Nicolas Pomarede

        68040+ cycle count adjustment (from WinUAE 4.9.9 beta11 2022/12/18)
        [63977735]

2022-12-29 Nicolas Pomarede

        Clear nobreak memwatch variable (not used in Hatari) (from WinUAE
        4.9.9 beta10+ 2022/12/14)
        [cf36e178]

2022-12-29 Nicolas Pomarede

        Remaining missing DISASM_FLAG_VAL (from WinUAE 4.9.9 beta8+
        2022/12/10)
        [68f98437]

2022-12-29 Nicolas Pomarede

        Fix 040 instruction mem read (from WinUAE 4.9.9 beta8+ 2022/12/10)
        [b2b5b80d]

2022-12-29 Nicolas Pomarede

        Yet another JIT interrupt handling fix (not used in Hatari) (from
        WinUAE 4.9.9 beta8+ 2022/12/06)
        [ff2b7a9e]

2022-12-29 Nicolas Pomarede

        Remove SMC detector test code, fix special case opcodes (not used in
        Hatari) (from WinUAE 4.9.9 beta8+ 2022/12/06)
        [cfced8c0]

2022-12-29 Nicolas Pomarede

        Optimize smc detector cache flush (not used in Hatari) (from WinUAE
        4.9.9 beta8+ 2022/12/04)
        [1807b412]

2022-12-29 Nicolas Pomarede

        Return error code from debugger string to integer parser (from
        WinUAE 4.9.9 beta8 2022/12/03)
        [cbb0536f]

2022-12-29 Nicolas Pomarede

        JIT interrupt handling reverted to previous version. JIT requires it
        for best performance (not used in Hatari) (from WinUAE 4.9.9 beta7+
        2022/12/03)
        [3d0560c2]

2022-12-29 Nicolas Pomarede

        Approximate 68020+ cycle count adjustments (from WinUAE 4.9.9 beta7+
        2022/12/03)
        [d80c13f3]

2022-12-29 Nicolas Pomarede

        memwatch parameter update (not used in Hatari) (from WinUAE 4.9.9
        beta7+ 2022/12/03)
        [c9a2aaec]

2022-12-29 Nicolas Pomarede

        Removed unneeded function (from WinUAE 4.9.9 beta7+ 2022/11/28)
        [f91aa45b]

2022-12-28 Nicolas Pomarede

        Fix timing for IACK sequence in the case of the HBL/VBL interrupt 
        Similar to commit 2825f992, previous timing was wrong and could
        allow another interrupt to be taken into account even during the
        IACK sequence. Correct version allows another interrupt only during
        the initial 12 cycles and the sync to E-clock
        [cf1de0c8]

2022-12-28 Nicolas Pomarede

        Remove unused commented code
        [3479016d]

2022-12-28 Nicolas Pomarede

        Update release notes
        [8d0572fe]

2022-12-28 Nicolas Pomarede

        Fix timing for IACK sequence in the case of the MFP Previous timing
        was wrong and allowed another higher MFP interrupt to "replace" the
        current one if it happened during the first 24 cycles of processing
        the interrupt's exception. This counted by mistake the IACK sequence
        itself, where vector can't change anymore. Correct timing to allow
        anohter MFP int is 12 cycles. Fix end part of the 'Little -ME- Demo'
        by Overlanders where screen would become black after a few minutes
        [2825f992]

2022-12-27 Nicolas Pomarede

        In monochrome mode, correctly mask the video address to 22 or 24 bit
        space depending on the machine type This was already done in
        Video_CopyScreenLineColor but not in Video_CopyScreenLineMono. Fix a
        crash with the monochrome demo "Time Slice" by "Defence Force" when
        Hatari is compiled with the "small mem" option
        [ea0b6e81]

2022-12-19 Eero Tamminen

        Add compatibility notes for some Xmas + more sv2k22 demos
        [5bbc26b1]

2022-12-07 Eero Tamminen

        Add Falcon Sound CPX + few Falcon demos to compatibility lists
        [a709411c]

2022-12-08 Eero Tamminen

        Fix reverted read-only Fattrib() attribute check

        Fixes: 8fe983f2878f575ae5acf930a310195e82592a94

        Reported-By: Uwe Seimet
        [bac8ef75]

2022-12-07 Thomas Huth

        Fix the CPU frequency setting of the Mega STE

        Thanks to Christian Zietz for checking this on a real machine!
        [090bfcc9]

2022-12-07 Eero Tamminen

        Fix GEMDOS read-only status fix

        Read-only status change should be done for fopen() only when the
        file exits.

        Fixes: 8fe983f2878f575ae5acf930a310195e82592a94

        Reported-By: Uwe Seimet
        [82e12e1f]

2022-12-06 Eero Tamminen

        Add more monochrome demos to compatibility docs
        [60bfa8d5]

2022-12-05 Eero Tamminen

        Update also EmuTOS compatibility

        - Improve section structure
        - Improve STNICC 1990 3.5k demo infos
        - Add top Sommarhack 2022 entries
        - Plus few other updates
        [ebf536b5]

2022-12-05 Eero Tamminen

        Add top STE/TT/Falcon entries from Sommarhack 2022
        [cf7ffd59]

2022-12-03 Eero Tamminen

        Fix GEMDOS HD checks for files writable only by other users

        GEMDOS HD checks for read-only attribute of a file, and when to ask 
        fopen() to open files as read-only, were not working when file was 
        only writable (owned) by another user, but not by Hatari.

        Before this fix, trying to open such a file (e.g. from a shared 
        directory) as writable failed, now Hatari fopen()s it as read-only, 
        same as it does for user's own read-only files.

        Fixes: 799020b84d02

        Note that access() does check using real UID/GID instead of
        effective ones, so there can still be some rare case where this does
        not work optimally. See "access" manual page.
        [8fe983f2]

2022-12-04 Thomas Huth

        Decrease size of arrays again - the enlargement was not necessary
        [3a133cc2]

2022-12-04 Thomas Huth

        Update outdated information in the manual
        [a9b47425]

2022-12-04 Thomas Huth

        Mention the frequency switching on the Mega STE and Falcon
        [074fc13d]

2022-11-27 Eero Tamminen

        Update Hatari sudirectory contents documentation
        [3d4a30c5]

2022-11-29 Eero Tamminen

        Add Geotech Falcon demo
        [7644c934]

2022-11-26 Nicolas Pomarède

        DMA debugger changes for copper/cpu (not used in Hatari) (from
        WinUAE 4.9.9 beta7 2022/11/26)
        [337b85e3]

2022-11-20 Nicolas Pomarède

        Disassembler fix (from WinUAE 4.9.9 beta6+ 2022/11/20)
        [1792933c]

2022-11-19 Nicolas Pomarède

        Update WinUAE's version
        [137998b5]

2022-11-19 Nicolas Pomarède

        68010 DIV overflow undefined flags update (from WinUAE 4.9.9 beta6
        2022/11/19)
        [a93acb6e]

2022-11-19 Nicolas Pomarède

        Reformatting (from WinUAE 4.9.9 beta6 2022/11/19)
        [47e72b98]

2022-11-19 Nicolas Pomarède

        SMCD update (not used in Hatari) (from WinUAE 4.9.9 beta6
        2022/11/19)
        [109c735b]

2022-11-19 Nicolas Pomarède

        Keep CPU stopped when keyboard reset is active (from WinUAE 4.9.9
        beta6 2022/11/19)
        [6743c2f3]

2022-11-19 Nicolas Pomarède

        Fix BKPT stacked PC from (WinUAE 4.9.9 beta6 2022/11/19)
        [9ce4e70f]

2022-11-18 Thomas Huth

        Update the macOS job in the Cirrus-CI to "ventura"

        Cirrus-CI announced that the old x86-based builders will be
        decomissioned at the end of 2022, so we have to switch to the new
        aarch64 builders instead. While we're at it, switch to the latest
        version of macOS and add "capstone" here, too.
        [a3900103]

2022-11-18 Eero Tamminen

        Update m68k NetBSD related documentation
        [a863a01f]

2022-10-20 Eero Tamminen

        Update Linux support info to v6.0
        [daabefdb]

2022-11-18 Eero Tamminen

        Add address width support to expression evaluation

        Syntax is same as with conditional breakpoints: (<addr>).<width>
        [f6df3857]

2022-11-17 Nicolas Pomarède

        Fixed DMA debugger CPU access data value sometimes being in wrong
        cycle (not used in Hatari) (from WinUAE 4.9.9 beta5+ 2022/11/17)
        [3ff1d059]

2022-11-17 Nicolas Pomarède

        68060 FPU exception without FPU (or FPU disabled) corrupted D7 (from
        WinUAE 4.9.9 beta5+ 2022/11/17)
        [bba5bb28]

2022-10-29 Eero Tamminen

        Document msg repeat suppression and its "--msg-repeat" option
        [4b074ef3]

2022-10-30 Eero Tamminen

        Integrate direct trace file output with message suppression

        LOG_TRACE_PRINT was earlier changed to message repeat handling, 
        however that does not work properly for all code in Hatari.

        * Add LOG_TRACE_DIRECT define for multi-line output where
         going through the message repeat handling does not make sense,
         or some part of output does not use tracing infra for output
         (e.g. CPU & DSP disasm & reg tracing)

        * Add LOG_TRACE_DIRECT_LEVEL define for multi-line output in hdc.c
         which does not its output within LOG_TRACE_LEVEL block

        * Add LOG_TRACE_DIRECT_INIT define to flush any pending message
         repeats before doing direct output to trace file

        * To round off the defines, add LOG_TRACE_DIRECT_FLUSH to
         flush trace file after direct output is done
        [f4f50208]

2022-08-28 Eero Tamminen

        Change CPU+DSP symbol tracing to use Log_Trace() function

        So that repeated entries will be compressed on output.
        [85c6f70b]

2022-08-28 Eero Tamminen

        Support for suppressing successive identical log & trace messages

        There are situations (bugs) where specific log or trace messages
        start repeating constantly.  After repeating for a while, rest is
        useless, fills logs quickly and often scrolls the useful info (about
        how that sitation was entered) out of view faster than one can
        react.

        Limit on how often Hatari prints count of repeated messages is
        doubled whenever earlier limit is reached, and drops back to default
        if message changes.

        This commit includes only general log & trace message integration. 
        Later commits add special handling for few places needing extra
        care.

        Repeat suppression is enabled by default and can be toggled with the 
        new "--msg-repeat" option.
        [c7551e09]

2022-11-13 Eero Tamminen

        Update docs for the MFP IRQ handling fix
        [c8c1c593]

2022-11-07 Eero Tamminen

        EmuTOS compatibility update (v1.2.1 status)
        [69bdda5a]

2022-11-12 Nicolas Pomarède

        Cache bit corrections (from WinUAE 4.9.9 beta5 2022/11/11)
        - "cacheholdingdata_valid" sometimes used as iterator; should not be
        init as boolean.
        - Fix 060 "No Allocate Mode" CACR bit to a valid u32 value.
        [116b8a73]

2022-11-11 Nicolas Pomarède

        Fix common IRQ value on MFP's GPIP4 for IKBD and MIDI ACIAs Both
        ACIA's IRQ lines (active low) are connected to MFP's GPIP4. This
        means GPIP4 should be 0/low if any of the 2 ACIAs has its IRQ line
        set to 0/low. And GPIP4 should be 1/high only if both ACIAs have IRQ
        line set to 1/high
        [a8736c13]

2022-11-06 Nicolas Pomarède

        Reduce unnecessary do_specialties() calls (from WinUAE 4.9.9 beta5
        2022/11/06)
        [61331838]

2022-11-05 Thomas Huth

        Fix crash that happened during shutdown when GEMDOS HD had been
        ejected before

        Uwe Seimet reported a possible crash:

        "After ejecting all GEMDOS drives (I have mapped a folder containing
        several
        drives), resetting Hatari and then quitting with F12 or Ctrl-C there
        is a
        segfault in GemDOS_UnInitDrives()."

        After InternalDTAs has been set to NULL, DTACount has to be set to
        0, too, otherwise the code might still try to access InternalDTAs
        later.
        [a7365d05]

2022-11-05 Thomas Huth

        Convert sprintf() calls into snprintf() calls in the DSP
        disassembler

        sprintf() is marked as deprecated in recent versions of macOS and
        using it generates a lot of compiler warnings. Let's use snprintf()
        instead. Thank a lot to Andreas Grabher for the patch!
        [85929b92]

2022-11-05 Thomas Huth

        gitlab-ci: Merge more CI jobs

        A CI run currently still costs a lot precious CI minutes (ca. 32
        minutes), and since the CI minutes are now limited to 400 minutes
        per months, let's try to be more efficient by merging the jobs even
        further. Also remove the python packages from the mingw job since
        they are not really useful there.
        [f09c428e]

2022-11-05 Thomas Huth

        Allow to use --enable-werror and --disable-tracing at the same time
        [4ca0a225]

2022-11-03 Thomas Huth

        Remove str.h from ide.c - it is not needed here anymore
        [cdac2ae0]

2022-10-31 Nicolas Pomarède

        68000 IPL fix (from WinUAE 4.9.9 beta4 2022/10/30)
        [69cd7200]

2022-10-31 Nicolas Pomarède

        f breakpoint hit count support (not used in Hatari) (from WinUAE
        4.9.9 beta4 2022/10/30)
        [6259d1ee]

2022-10-27 Eero Tamminen

        Avoid stale GEMDOS HD read-only status

        And resulting spurious Fwrite() warnings with FDs created either
        with Fcreate(), or state restore.

        Reported-By: Uwe Seimet

        Fixes: 799020b84d02

        Also:
        * Correct virtual INF file Fopen() mode in GEMDOS trace
        * Update warning msg now that it's also about files that are
         not supposed to be written, not just ones Fopen()ed read-only
        * Show FD read-only status also with "info gemdos"
        [68a9cc99]

2022-10-26 Nicolas Pomarède

        Update physical addresses and timing w/cache burst (from WinUAE
        4.9.2 beta3+ 2022/10/25)
        [d669d9f4]

2022-10-26 Nicolas Pomarede

        Don't use adjust_cycles() for CPU emulation, we keep the number of
        cycles returned by each opcode WinUAE can adjust the number of
        cycles of each opcode by a percentage to simulate a different CPU
        clock. We don't use this for Hatari, we always keep the value
        returned by each opcode.
        [d8bafdb4]

2022-10-25 Nicolas Pomarede

        Don't output multiple disasm lines every 4 cycles when STOP is
        running Since commit ad403487 from 2022/08/27 CPU core handles
        correctly STOP as an instruction that "loops" by not prefetching
        another opcode until exit condition is reached. When using trace
        "cpu_disasm" this gave multiple lines in the disasm output every 4
        cycles instead of one single line as before. To fix this we don't
        output anything once regs.stopped is set.
        [f71c37d2]

2022-10-24 Nicolas Pomarède

        IPL wait state fix (from WinUAE 4.9.2 beta3 2022/10/23)
        [1cd9e747]

2022-10-24 Nicolas Pomarède

        Larger DMA debugger (not used in Hatari) (from WinUAE 4.9.2 beta3
        2022/10/23)
        [7e5cb341]

2022-10-24 Nicolas Pomarède

        Warning fixes (from WinUAE 4.9.2 beta3 2022/10/23)
        [3219dbcb]

2022-10-24 Nicolas Pomarède

        68000 IPL updates (from WinUAE 4.9.2 beta2+ 2022/10/21)
        [ebc82b42]

2022-10-24 Nicolas Pomarède

        Trace does not wake up STOP if STOP enables trace and trace was not
        already enabled (from WinUAE 4.9.2 beta2+ 2022/10/21)
        [8e6d88da]

2022-10-24 Nicolas Pomarède

        Fix non-interrupt exception timing (from WinUAE 4.9.2 beta2+
        2022/10/21) NOTE : this is in fact wrong, there's no need for 4
        extra cycles, so this change is commented in Hatari
        [597d1797]

2022-10-24 Nicolas Pomarède

        Fix debugger W command hang and sp swapped sprite planes (not used
        in Hatari) (from WinUAE 4.9.2 beta2+ 2022/10/19)
        [a2874665]

2022-10-24 Nicolas Pomarède

        68000 accurate IPL timing emulation (from WinUAE 4.9.2 beta2+
        2022/10/19)
        [1f71f4c4]

2022-10-23 Thomas Huth

        Use "emcmake" when configuring the build for Emscripten

        By using "emccmake" instead of "emmake", the detection for zlib now
        works right.
        [050500b6]

2022-10-23 Thomas Huth

        Fine-tuning in CMakeLists.txt for Emscripten

        We should not try to build and run the tests if cross-compiling.
        [003b0098]

2022-10-22 Thomas Huth

        Remove createBlankImage.h inclusion from file.c

        It's not necessary here. Thanks to Andreas for the hint!
        [a670b413]

2022-10-22 Thomas Huth

        Add some unit tests for file.c

        As the problem with File_MakeValidPathName() recently revealed, it 
        might be good to have some more test coverage for the functions
        here.
        [4f3646ab]

2022-10-22 Thomas Huth

        Avoid Log_Printf() in WinTmpFile()

        file.c generally does not use the Log_Printf() stuff, so avoid it in
        WinTmpFile(), too. This will make it easier to link the file to the
        upcoming unit test in the next patch.
        [9fc1800f]

2022-10-07 Eero Tamminen

        Improve init and output options for disassembly

        * Support lower case options also with CPU core disassembly
        * Add UAE disassembly option for showing EA/CC info
        * Add UAE disassembly option for hex address case
        * Add option for skipping showing of 16-bit words at address
         - To manage that better, offsets come now from positions array
         - Add const correctness to column removal function
         - Remove " :" after ext assembler address, to make output
           more consistent between dissassembler and because it
           looked odd whent 16-bit words were missing
        * Convert Disasm_SetCPUType() to Disasm_Init() function
         that handles intialization for both disassemblers
        * Show flag values as hex in help, now that there are more of them
        [b7bbcd4f]

2022-10-19 Eero Tamminen

        SdlGui_DirConfSelect -> SDLGui_DirConfSelect

        For consistency with other SDL GUI functions.
        [e5af5c53]

2022-10-19 Thomas Huth

        Fix File_MakeValidPathName() for inputs that point to a place in the
        root dir

        Thanks to Andreas Grabher for the hint!
        [08f10f4e]

2022-10-18 Eero Tamminen

        Improve SdlGui_DirSelect()

        Apply changes proposed by Andreas Grabher:
        - Rename for consistency with SdlGui_FileConfSelect()
        - Use Hatari helper function to make sure path is valid
        - Use Str_Copy() to limit copying to (assumed) confname size
        [8ae54c45]

2022-10-16 Thomas Huth

        Replace some strncpy() calls with Str_Copy()
        [d487c2da]

2022-10-16 Thomas Huth

        Do not return success for invalid files in SDLGui_FileConfSelect()

        These functions also returned true, if a non-existent file or
        directory is selected. That does not make very much sense.

        Thanks to Andreas Grabher for the hint!
        [e61e6cd0]

2022-10-15 Thomas Huth

        Add a test for DMA sound playback after RAM end
        [00e3767c]

2022-10-15 Thomas Huth

        Replace SDL types in remaining files that don't use any SDL
        functions
        [fd9d8ad0]

2022-10-12 Eero Tamminen

        Move duplicate SDL GUI dir selection to a shared function
        [899c41ac]

2022-10-12 Eero Tamminen

        Add / use File_Basename() convenience function
        [a06f9e9e]

2022-10-11 Eero Tamminen

        GEMDOS HD: allow writes to files opened as read-only

        See: https://www.atari-forum.com/viewtopic.php?p=438987
        [799020b8]

2022-10-12 Nicolas Pomarede

        Fix change ce962026 from 2022/10/07 which didn't work for 68040 with
        prefetch mode 68040 in prefetch mode uses in fact the same cputbl as
        68040 in CE mode, so we must use a new variable CpuRunFuncNoret
        instead of relying on CpuRunCycleExact
        [8dcc45f0]

2022-08-28 Eero Tamminen

        Add JagPad / Power Pad info to compatibility list

        Info provided by Ispettor Flanella.

        (Falcon compatible Reservoir Gods' "Superfly" game was not added to
        list as it's ST game.)
        [01a0f94e]

2022-09-26 Eero Tamminen

        Add Falcon MegaPlayer and more info on file selector issue
        [342b67f6]

2022-09-25 Eero Tamminen

        Add more programs to EmuTOS compatibility list
        [99e1d09b]

2022-07-25 Thorsten Otto

        Move symbol_t struct to symbols.h

        Besides allowing removal of duplicate enums, this will also help in
        later symbol exporting functionality.
        [69573971]

2022-10-08 Thomas Huth

        Remove unused definition of M_PI
        [07b03a90]

2022-10-07 Thomas Huth

        Revert "Cycle exact mode does not work with emscripten yet"

        This reverts commit 70609e308598f157690241deedd6cd9c5c8f02a7.

        Cycle exact mode should now work with emscripten, too.
        [5cdb9f56]

2022-10-07 Nicolas Pomarède

        Separated two types of CPU emulation functions (returns
        value/returns void) (from WinUAE 4.9.2 beta1 2022/10/06) This should
        fix some conflicts reported when compiling Hatari with emscripten
        [ce962026]

2022-10-06 Eero Tamminen

        Provide GEMDOS write error reason in warning

        Like in GEMDOS read.
        [454b7d49]

2022-10-04 Nicolas Pomarede

        Fix typos and compiler warning (from WinUAE 4.9.2 beta1 2022/10/04)
        [a72c58ba]

2022-10-03 Thomas Huth

        gitlab-ci: Remove the "build-normal" job

        gitlab.com recently introduced limits for the monthly CI minutes, so
        we have to be more conscious about the jobs that we are running. 
        Almost everything that is handled by the "build-normal" job is 
        already tested in other pipelines, so we can certainly drop this job
        to save some CI minutes. While we're at it, turn "build-alt" into a
        job that really tests for a minimalist configuration instead.
        [8b065695]

2022-10-02 Eero Tamminen

        Use bool as return type for dialog alert functions

        As they return only true/false.
        [724ce14a]

2022-10-02 Thomas Huth

        Add some more words about emscripten to the readme.txt
        [9d0d4ffc]

2022-10-02 Thomas Huth

        Cycle exact mode does not work with emscripten yet
        [70609e30]

2022-09-02 tIn

        Additional emscripten changes
        [dbac8617]

2022-09-01 tIn

        Add emscripten shell
        [bd9a8bd2]

2022-10-02 Nicolas Pomarède

        Accurate 68000 IPL emulation updates + STOP update (from WinUAE
        4.9.2 beta1 2022/10/01) This completes commit 2fd4f228 from
        2022/08/27 and gives the correct number of 8 cycles when STOP is
        used with an already pending interrupt
        [65099c47]

2022-10-02 Nicolas Pomarède

        Debugger 's' and 'W' command improved quoting support (not used in
        Hatari) (from WinUAE 4.9.2 beta1 2022/10/01)
        [10efbdaf]

2022-10-02 Thomas Huth

        Remove unused variable lineno
        [f38252cc]

2022-10-02 Thomas Huth

        Rename SDL_UpdateRect() into Screen_UpdateRect()

        The SDL_UpdateRect() function was a hack that we introduced when
        adding support for the SDL 2.0. Since we dropped support for SDL 1.2
        a while ago, keeping the old name is not required anymore.
        Additionally, the SDL_UpdateRect() prototype also conflicts with
        some compatibility functions from Emscripten, so let's use a better
        name for this function now instead.
        [b2d0c4e0]

2022-10-02 Thomas Huth

        Remove the 16-bpp screen conversion functions

        All recent hardware supports 32 bits-per-pixels these days, so the
        16-bpp rendering functions are pretty much dead code now and just
        cause double maintainence if there is something to change in the
        screen rendering functions. Let's avoid this double maintainence and
        drop the old rendering functions.
        [4d78e24d]

2022-08-20 Thomas Huth

        Remove the --bpp CLI option / the nForceBpp config switch
        [93a5dfa7]

2022-10-01 Thomas Huth

        dmaSnd.c still needs SDL_stdinc.h for the M_PI constant
        [db9b4b23]

2022-10-01 Thomas Huth

        Make gst2ascii and tests/debugger independent from the SDL headers
        [f53d13d3]

2022-10-01 Thomas Huth

        Fix new code in maccess.h for big endian hosts
        [11a076c8]

2022-10-01 Thomas Huth

        Drop redundant #include <SDL_types.h> statements
        [947b381a]

2022-10-01 Thomas Huth

        Replace SDL types in midi.c
        [854db1ba]

2022-10-01 Thomas Huth

        Make hmsa independent from the SDL headers
        [decd82e9]

2022-10-01 Thomas Huth

        Make main.h independent from the SDL headers

        Thanks to the previous clean-ups, we can finally get rid of this
        dependency to the SDL_types.h header.
        [cc7de619]

2022-10-01 Thomas Huth

        Use __APPLE__ instead of __MACOSX__ to test for macOS

        __MACOSX__ is a macro that is provided by the SDL library, so we
        must not use this in files that should work without the SDL headers.
        Use the more common __APPLE__ macro instead.
        [a80539f0]

2022-10-01 Thomas Huth

        Replace strlcpy() with a better implementation

        strlcpy() has issues with untrusted source strings, since it is
        always trying to find out the length of source strings. So for
        emulators like Hatari this could be dangerous when being used on
        strings that originate from the Atari program side. Let's use a
        better string copy function instead, similar to strscpy() in the
        Linux kernel (see following URL for details: 
        https://lkml.org/lkml/2022/8/21/271 ). This also decreases our
        dependency on the SDL headers since we were using SDL_strlcpy() on
        systems that do not have a strlcpy() function in their libc.
        [63153932]

2022-10-01 Thomas Huth

        Reduce our dependencies to screen.h

        screen.h requires the SDL headers, so it's bad to include it in code
        that does not really depend on the SDL library, thus drop the
        inclusion of screen.h wherever it is possible. However, video.h
        currently depends on screen.h due to the HBL_PALETTE_LINES and
        HBL_PALETTE_MASKS macros. Fix this dependency by moving the
        HBLPalettes[] and HBLPaletteMasks[] arrays from video.c to screen.c
        instead.
        [861af72c]

2022-10-01 Thomas Huth

        Use the bswap functions from sysdeps.h in maccess.h

        This way maccess.h gets independent from the SDL_endian.h header.
        [d8f1b56d]

2022-10-01 Thomas Huth

        Convert even more files from the SDL types to stdint types

        These are required for the upcoming changes with regards to 
        maccess.h and the SDL-header related cleanups
        [55b5b9e3]

2022-10-01 Thomas Huth

        Remove unused file md-fpp.h

        Unused since commit 7f19b20775f051ac214d (from WinUAE 4.4.0+
        2020/07/27)
        [34297254]

2022-09-30 Chris Jenkins

        Handle MacOS versions >= 11
        [f5b5d3b4]

2022-09-30 Thomas Huth

        Use standard types in the hmsa tool, too
        [26b5e9d8]

2022-09-29 Thomas Huth

        SDL2_INCLUDE_DIR has been renamed to SDL2_INCLUDE_DIRS
        [6ac59c63]

2022-09-28 Thomas Huth

        Remove HAVE_SDL_CONFIG_H

        The SDL_config.h header is available since SDL 2.0.4. Since we
        require at least SDL 2.0.6 now to compile Hatari, we can remove the
        checks.
        [a1d5ebbf]

2022-09-29 Eero Tamminen

        Get rid of SDL types in tools

        Other than HMSA tool were already clean.
        [597f6058]

2022-09-29 Eero Tamminen

        Complete earlier SDL_types.h independence commit

        Earlier commits missed some of the SDL types in the files.

        Remaining ones were converted with:
         for x in 8 16 32 64; do
           sed -i \
             -e "s/\bUint${x}\b/uint${x}_t/g" \
             -e "s/\bSint${x}\b/int${x}_t/g" \
             <files>;
         done

        Fixes: 887c862e446 Fixes: 842d4bb32a8 Fixes: b29bcad91c4
        [73cddffc]

2022-09-29 Nicolas Pomarède

        Convert more files to use types from stdint.h instead of SDL_types.h
        [c1224f46]

2022-09-25 Thomas Huth

        Make more files independent from SDL_types.h, use types from
        stdint.h instead
        [887c862e]

2022-09-25 Thomas Huth

        Remove the unused hd6301 sources

        They are completely unused since years, only impact is a small slow
        down to our compilation process, so let's finally remove them. If we
        ever want to have another try to fully emulate the IKBD processor,
        we can resurrect these sources from the older Hatari versions.
        [0f5ddb88]

2022-09-25 Thomas Huth

        Convert files in src/debug/ from SDL_types.h to stdint.h
        [e1bcf014]

2022-09-19 Chris Jenkins

        Don't unpause if emulation was already paused
        [0cc06105]

2022-09-25 Thomas Huth

        Remove SDL types from the debug tests and related files
        [b29bcad9]

2022-09-25 Thomas Huth

        Get rid of SDL types in gemdos.c and cycles.c
        [842d4bb3]

2022-09-25 Thomas Huth

        Make DSP code independent from SDL_types.h

        Let's switch to the stdint.h types here to decrease our dependencies 
        to the SDL headers.
        [c3ac11f8]

2022-09-24 Nicolas Pomarède

        Hard reset CPU startup was not identical to initial power up (from
        WinUAE 4.9.1+ 2022/09/23)
        [3c34ac7c]

2022-09-24 Nicolas Pomarède

        DMA debugger initial start support (not used in Hatari) (from WinUAE
        4.9.1+ 2022/09/23)
        [61dc66e9]

2022-09-24 Nicolas Pomarède

        Fixed minor bugs, memleaks and strlen optimize (from WinUAE 4.9.1+
        2022/09/23)
        [996cede0]

2022-09-24 Thomas Huth

        Always add Cocoa on macOS

        Seems like this is necessary for the bundled build, too.
        [c816fa82]

2022-09-24 Thomas Huth

        The "Floppy" target needs a target_link_library(), too

        Thanks to Andreas Grabher for the hint!
        [a6c5400d]

2022-09-24 Thomas Huth

        Link explicitly against the Cocoa framework

        The "-framework Cocoa" used to be added by our FindSDL2.cmake
        module, but now that this is gone, it seems like we have to add this
        manually again. This fixes the broken macOS job in the Cirrus CI.
        [ffb249e1]

2022-09-24 Thomas Huth

        Fix compilation on macOS with the latest version of SDL2

        We've got to use target_link_libraries() here to get the compilation 
        with the latest version of the SDL2 framework working again on
        macOS. Thanks to Andreas Grabher for the hint!
        [271734e7]

2022-09-18 Thomas Huth

        Switch to the official SDL2 CMake config and drop our FindSDL2.cmake
        file

        Recent versions of SDL2 ship with a SDL2Config.cmake file, so we do
        not need to supply our own FindSDL2.cmake anymore.
        [79ed0ebc]

2022-09-18 Eero Tamminen

        Update / improve release notes
        [bd5ba4ae]

2022-09-17 Nicolas Pomarede

        Use Uint64 instead of Uint32 in ClocksTimings_ConvertCycles
        (reported by Ian Ray)
        [82b32a17]

2022-09-17 Eero Tamminen

        Fix troff warnings for Hatari manual page

        And add note to release checklist for testing these.

        Unfortunately troff (or "man --warnings") does not return an error 
        code so that this check could be trivially automated with CTest.
        [1679a031]

2022-09-17 Eero Tamminen

        Fix groff warning in hatari_profile.1

        A period at the beginning of a line starts a command for groff.

        Reported by Teemu Hukkanen.
        [cd7e8d67]

2022-09-15 Eero Tamminen

        Fix freeing of unallocated, non-NULL symbol name pointers

        When symbol_list_alloc() used malloc, the returned name list content 
        was uninitialized, and potentially non-zero (when memory was
        reused). symbols_load_gnu() does not explicitly set
        ".name_allocated" symbol members to false.  As result,
        symbol_list_free() tried to free
        (non-NULL) symbol ".name" pointers.

        Fixes: e5b672b74f1c

        Code formatting is also made more consistent.
        [5e19519f]

2022-09-15 Eero Tamminen

        Free profiler data buffers before exit

        Listed by Valgrind with --leak-check=full --show-reachable=yes.
        [c3cbabfe]

2022-08-25 Chris Jenkins

        Allow all filetypes in Mac GUI

        Previously, when selecting files (hard disk images, midi output
        etc...), only certain filetypes were allowed. The Mac fileselector
        that we use, NSOpenPanel, has actually deprecated the
        allowedFileTypes property and certainly doesn't show the user any
        indication of the set of types that are permitted.

        Longer term, it might make sense to revamp this code.
        [36fc885c]

2022-09-12 Eero Tamminen

        Fix disassembly matching when capstone is not enabled

        Instead of adding CAPSTONE ifdef for the case when:

        * User's Hatari config specifies the external disassembler
         (= old default), but

        * Hatari does not support that because capstone devel files
         were not present at built time

        just specify regexp that will match output from both disassemblers.

        Fixes: d2d51974ef
        [2d10f7aa]

2022-09-12 Eero Tamminen

        Remove redundant defines & tabs from ext disassembler

        Fixes worst looking TAB usage with the default 8-space TAB settings.
        [bcdbe8ca]

2022-09-12 Nicolas Pomarède

        Ignore byte accesses to blitter's registers defined as word only
        [273e8b07]

2022-09-12 Eero Tamminen

        And increase the devel version too

        Sigh. Apparently I'm aiming for the "buggiest trivial commit"
        record.
        [229c4a6e]

2022-09-12 Eero Tamminen

        Fix typos in previous commit
        [dbecb9b5]

2022-09-12 Eero Tamminen

        Update release checklist + switch Hatari version back to devel
        [fcd891cd]

2022-09-03 Nicolas Pomarède

        Display the accurate value of E clock jitter when logging HBL and
        VBL exceptions Jitter was previously logged from video.c, which was
        not correct, it should be logged from the IACK part of the CPU core
        [4a4c2f17]

2022-08-27 Thomas Huth

        Add Line-A comments in disassembly
        [2063a37a]

2022-08-27 Thomas Huth

        Use capitalization option for unknown opcodes, too
        [dea1c2da]

2022-08-27 Nicolas Pomarède

        Disassembler full format extension upper/lower case fixes (from
        WinUAE 4.9.1+ 2022/08/25)
        [bf28b4ba]

2022-08-27 Nicolas Pomarède

        Warning fixes, preparing for future ARM64 build (from WinUAE 4.9.1+
        2022/08/21)
        [c5f37c14]

2022-08-27 Nicolas Pomarède

        Scanrate fix for visual debugger (not used in Hatari) (from WinUAE
        4.9.1+ 2022/08/22)
        [f6a32c24]

2022-08-27 Nicolas Pomarède

        INTENA/INTREQ timing update. IPL state included in DMA debugger
        (from WinUAE 4.9.1+ 2022/08/18)
        [08958234]

2022-08-27 Nicolas Pomarède

        Optional short absolute disassembly (-$xxxx.w/$FFFFxxx.w) (from
        WinUAE 4.9.1+ 2022/08/18) This display short address with 8 chars
        instead of 4 adding ".w" to the address eg : "1038 8260" will now
        display "move.b $ffff8260.w,d0" instead of "move.b $8260,d0" before
        [880cef08]

2022-08-27 Nicolas Pomarède

        Simplified JIT direct exception handler (not used in Hatari) (from
        WinUAE 4.9.1+ 2022/08/07)
        [d36e6e54]

2022-08-27 Nicolas Pomarède

        Interrupt handling timing update, separate Paula internal INTREQ
        changes vs INTREQ CPU/Copper writes (from WinUAE 4.9.1+ 2022/08/07) 
        NOTE : there' no more 4 extra cycles for STOP with this version,as
        it moves the INTREQ timing into the Amiga part instead of counting
        it into the CPU part. STOP with already pending interrupt not
        correct yet, takes 4 cycles instead of 8 cycles
        [2fd4f228]

2022-08-24 Nicolas Pomarede

        Make sure hardware emulated RTG boards don't have barrier at the
        start of VRAM space to fully support JIT direct (not used in Hatari)
        (from WinUAE 4.9.1+ 2022/08/07)
        [7389ebdf]

2022-08-24 Nicolas Pomarede

        Fix console DMA debugger output (not used in Hatari) (from WinUAE
        4.9.1+ 2022/08/07)
        [015a3fcc]

2022-08-24 Nicolas Pomarede

        DMA debugger variable number of line lengths and scanlines supported
        (not used in Hatari) (from WinUAE 4.9.1+ 2022/08/02)
        [f0ce1f3a]

2022-08-24 Nicolas Pomarede

        Restored DMA debugger update (not used in Hatari) (from WinUAE
        4.9.1+ 2022/07/23)
        [14abad4f]

2022-08-23 Nicolas Pomarede

        STOP timing fix from WinUAE 4.9.1+ 2022/07/20) NOTE : just merging
        code from WinUAE for now, STOP timings will be wrong under Hatari
        [b1fe1bbe]

2022-08-23 Nicolas Pomarede

        Yet another STOP emulation rewrite. Not yet fully cputester
        validated (from WinUAE 4.9.1+ 2022/07/11) NOTE : just merging code
        from WinUAE for now, STOP timings will be wrong under Hatari
        [ad403487]

2022-08-26 Eero Tamminen

        Fix use-after-free in external disassembler

        Reported by AddressSanitizer.

        Fixes: d2d51974e
        [e6d7e245]

2022-08-23 Nicolas Pomarede

        Minor debugger fixes #2 (not used in Hatari) (from WinUAE 4.9.1+
        2022/07/11)
        [397ee77f]

2022-08-23 Nicolas Pomarede

        Minor debugger fixes (not used in Hatari) (from WinUAE 4.9.1+
        2022/06/27)
        [91e19563]

2022-08-23 Nicolas Pomarède

        STOP cycle-accuracy fix (from WinUAE 4.9.1+ 2022/06/06) NOTE : this
        still doesn't cover the case where interrupt is already pending
        before STOP
        [7c244f20]

2022-08-21 Nicolas Pomarède

        STOP state/wakeup added to DMA debugger (not used in Hatari) (from
        WinUAE 4.9.1+ 2022/06/06)
        [e81c9add]

2022-08-21 Nicolas Pomarède

        STOP update (from WinUAE 4.9.1+ 2022/05/12) NOTE : this still
        doesn't cover all cases as measured on a real STF / STE
        [45cc990d]

2022-08-21 Thomas Huth

        Re-activate the option to use 'SP' instead of 'A7' in the
        disassembly
        [b688c09a]

2022-08-21 Thomas Huth

        Add option to remove space after comma in disassembly
        [27997bfa]

2022-08-19 Nicolas Pomarède

        Clear SMC detector state if CPU cache cleared (not used in Hatari)
        (from WinUAE 4.9.1+ 2022/05/28)
        [a4b6203e]

2022-08-19 Nicolas Pomarède

        CIA emulation rewrite (not used in Hatari) (from WinUAE 4.9.1+
        2022/05/24)
        [f1a35102]

2022-08-19 Nicolas Pomarède

        Typo / indent (from WinUAE 4.9.1+ 2022/05/24)
        [7d2a8fd1]

2022-08-19 Nicolas Pomarède

        Force config changes (CPU speed) into effect on hard reset (from
        WinUAE 4.9.1+ 2022/05/24)
        [6538b1b6]

2022-08-19 Nicolas Pomarède

        Include also possible remaining cycles when doing 68000/010 to
        chipsey sync (not used in Hatari) (from WinUAE 4.9.1+ 2022/05/24)
        [72804f63]

2022-08-19 Nicolas Pomarède

        memwatch bank crossing fix (from WinUAE 4.9.1+ 2022/05/06)
        [f14da93c]

2022-08-19 Nicolas Pomarède

        Warning fixes for _tcslen / strlen ((rom WinUAE 4.9.1+ 2022/04/29)
        [dade66b6]

2022-08-18 Nicolas Pomarède

        JIT warning fixes (from WinUAE 4.9.1+ 2022/04/28)
        [5c60d8e1]

2022-08-18 Nicolas Pomarède

        Warning fixes, use 'size_t' instead of 'int' (from WinUAE 4.9.1+
        2022/04/29)
        [4760fbd6]

2022-08-18 Nicolas Pomarède

        Cycle counting is now 64-bit (from WinUAE 4.9.1+ 2022/04/28)
        [a112b8d1]

2022-08-16 Nicolas Pomarède

        Warning fixes (from WinUAE 4.9.1+ 2022/04/28)
        [4ff27e80]

2022-08-16 Nicolas Pomarède

        SR modifying instruction IPL check update (from WinUAE 4.9.1+
        2022/04/17)
        [1e68b96e]

2022-08-15 Nicolas Pomarède

        68000 IPL detection timing fixes - part 2 (from WinUAE 4.9.1+
        2022/04/17) + STOP changes from WinUAE 2021/09/27 (with patch) As
        measured on real STF/STE, adding 4 cycles before do_interrupt()
        gives wrong results for STOP under emulation. So we disable these 4
        cycles for now.
        [80f26900]

2022-08-15 Nicolas Pomarède

        68000 IPL detection timing fixes - part 1 (from WinUAE 4.9.1+
        2022/04/17)
        [a2f8c7bb]

2022-08-14 Nicolas Pomarède

        Update some files to match WinUAE's sources from 25/04/2022 (no
        change for Hatari)
        [217f0ab6]

2022-08-20 Thomas Huth

        Need at least capstone 4.0 for m68k support
        [4f9359a2]

2022-08-20 Thomas Huth

        Use Capstone in the CI, too
        [84cf01d7]

2022-08-20 Thomas Huth

        Update the documentation with regards to the new Capstone support
        [3b497135]

2022-07-15 Thomas Huth

        Use Capstone for "external" disassembling

        The "external" disassembler code in 68kDisass.c was sometimes very
        cumber- some to maintain in the past years, and since there is
        already a disassembler engine in the WinUAE core, having a second
        disassembler code in Hatari just feels wrong. Additionally, most
        modern OS distributions already feature the
        "Capstone" disassembler nowadays which supports the m68k
        architecture, too, so let's use that instead of spending our time to
        maintain two disassembler engines within Hatari.
        [d2d51974]

2022-06-18 Thomas Huth

        Add Capstone to the CFLAGS and linker flags
        [75ed9cd4]

2022-06-18 Thomas Huth

        Add a FindCapstone CMake module
        [e5422016]

2022-08-20 Eero Tamminen

        Take RTC year option into account also for NVRAM RTC

        Reported by Uwe Seimet.

        Fixes: ae45605248
        [172ed18d]

2022-08-19 Eero Tamminen

        Fix RTC option define ID in error message

        Reported by Uwe Seimet.

        Fixes: ae45605248
        [baaa4ac8]

2021-09-21 Eero Tamminen

        Use history for determining suitable disassembly default address

        If disassembly starts from program counter (PC), user lacks context
        on how the code ended in current position.  With this, when history
        is enabled in debugger, disassembly is started from suitable address
        (slightly) before PC.

        Because trying to disassemble instructions from "random" address 
        before PC will often output incorrect disassembly, this scans 
        execution history for a valid instruction address that's close
        enough to PC.

        History addresses are valid until overwritten with differently
        aligned instructions, which is extremely unlike to happen, so this
        should be robust enough to be used always when history is enabled.
        [dd1c6ed5]

2022-08-01 Eero Tamminen

        Clear DTA cache on GEMDOS HD changes, and free it on exit
        [a10573d2]

2022-08-01 Eero Tamminen

        Free debugger allocations at Hatari exit

        Helps with memory debugging.
        [08bc257a]

2022-08-18 Eero Tamminen

        Add --rtc-year option / config option

        There can be old Atari programs that use dates, but do not handle 
        e.g. Y2K gracefully.  This workaround can be used with them.

        Notes:

        * Suitable year offset is calculated at start, instead of on every
         query, to handle gracefully new year transition (avoid clock going
         backwards on year change).

        * This means that RTC year cannot be overridden afterwards, from
         Hatari debugger, or through its remote API.
        [ae456052]

2022-08-18 Eero Tamminen

        Add helper for common RTC code
        [f05a68a3]

2022-08-15 Eero Tamminen

        Add TODO item about setting time on RTC machines

        Reported / requested by Uwe.
        [a73aee7c]

2022-08-03 : *** Version 2.4.1 ***

2022-08-03 Nicolas Pomarède

        New release 2.4.1, update dates in corresponding files
        [4371dcd6]

2022-08-01 Eero Tamminen

        Minor release documentation updates

        Update link, add note about logging, move VDI note to better place
        [c63abca1]

2022-08-01 Eero Tamminen

        Update EmuTOS notes in docs and tools comments

        In latest EmuTOS release 512k variant is language specific, so the
        given file names are wrong for it => use 1024k one instead to avoid
        that.
        [409391e3]

2022-08-01 Eero Tamminen

        Update EmuTOS version info in TOS boot tester

        And update version control ignore files also otherwise.
        [83987df1]

2022-08-01 Eero Tamminen

        Do debugger symbol testing with up to date data

        Replace obsolete EmuTOS symbols with ones from v1.1.1 one coming
        with Hatari binary releases, which use different, 0x prefixed
        address format.
        [73441e40]

2022-08-01 Thomas Huth

        Fix detection of Python Gtk in case Python 3 is not found
        [231a79ea]

2022-08-01 Thomas Huth

        Move the VDI mode crash to the 'Emulator' section
        [3d9e859b]

2022-07-31 Thomas Huth

        Check for the availability of Python Gtk before using the python-ui
        [7464d784]

2022-07-31 Thomas Huth

        Mention valgrind and ASAN_OPTIONS
        [a9c98fdf]

2022-08-01 Eero Tamminen

        Avoid invalid SDLGUI element accesses

        SDLGui_DoDialogExt() can return SDLGUI_UNKNOWNEVENT or
        SDLGUI_NOTFOUND value and get called again with such value in
        'current_object' by file selector, as those values do not terminate
        file selection.

        Invalid access reported by Nicolas / AddressSanitizer.
        [be58723f]

2022-07-30 Thomas Huth

        Fix possible crash in VDI mode when the ST program sets a bad video
        base

        The ST program might change the screen address between the point in
        time where we set the VideoBase variable and the point in time we're
        doing the conversion in screenConvert.c, so the code in that file
        must not use Video_GetScreenBaseAddr() to get the base address, but
        has to use the address that we recorded earlier. This fixes a
        possible crash in VDI mode with the tests/mem_end/scr_end.prg test
        program.
        [830f1049]

2022-07-29 Eero Tamminen

        Update release checklist
        [2234bb82]

2022-07-29 Eero Tamminen

        Test timeouts were too tight, increase them to pass tests

        Increase TT times a bit to avoid timeout fails with ASAN.

        MMU and IDE wait impact both startup and total test time.
        [3c4def86]

2022-07-29 Eero Tamminen

        Avoid ioctl using uninitialized data in scc.c

        According to Valgrind. Fix is same as what the RS-232 code does.
        [3934c4ae]

2022-07-29 Eero Tamminen

        Fix memory leak in PNG save code

        Gets FIFO and fullscreen tests to pass with AddressSanitizer.
        [4d164bdb]

2022-07-29 Eero Tamminen

        Fix config memory leak when HATARI_TEST is used

        To be able to use AddressSanitizer furter with HATARI_TEST.
        [489e27f4]

2022-07-29 Eero Tamminen

        Remove old (only) OSX GUI debug print

        It does not even say what it's for, so it would be a mystery to
        users.
        [81009c72]

2022-07-29 Eero Tamminen

        Output profiler prints to stderr, like rest of debugger

        Not to stdout.
        [dd3a6a55]

2022-07-29 Eero Tamminen

        Output config option handling issues with correct log functions

        As they are non-fatal, their output should be controllable, like
        rest of the log messages.
        [a47e17bc]

2022-07-29 Eero Tamminen

        Fix: use correct logging macros for IDE tracing

        Fixes: 5f8e24bb6
        [0840878b]

2022-07-29 Eero Tamminen

        Minor documentation updates
        [366143b5]

2022-07-28 Nicolas Pomarède

        Replace printf with Log_Printf when loading IPF/CTR floppy images
        [49e634f6]

2022-07-28 Eero Tamminen

        Document Hatari output options in debugger manual

        And update debugger config options defaults.
        [29fc553c]

2022-07-28 Eero Tamminen

        State explicitly what output "logfile" command controls
        [46d8a5cc]

2022-07-27 Eero Tamminen

        Fix memory leaks on GEMDOS HD program loading

        Reported by AddressSanitizer.

        Fixes: 1915c2a0e6
        [512fd72c]

2022-07-27 Eero Tamminen

        Improve bDspEnabled option handling change description

        DSP_Run() emulated DSP only on Falcon machines, as dsp_core.running 
        gets set only after specific DSP IO register write.  Avoiding 
        unnecessary calls to Dsp_Run() completely on non-Falcon machines
        with bDspEnabled still helps.
        [010b7b6d]

2022-07-27 Nicolas Pomarede

        Update release-notes.txt
        [166a6ae5]

2022-07-27 Nicolas Pomarede

        DSP_Enable() should set bDspEnabled=true only if the machine is a
        Falcon If not, DSP_Run() can be called when using >= 68030 CPU (eg
        in TT mode) if DSP was enabled using options or global configuration
        file, which would unnecessary slow down emulation as only Falcon has
        the corresponding IO memory to access the DSP
        [e0bacb31]

2022-07-25 Thorsten Otto

        Fix duplicate symbol name handling

        When checking for duplicate symbol names, the last symbol was always 
        removed with other duplicates.
        [aded099e]

2022-07-26 Eero Tamminen

        Show "Linux" in statusbar for lilo

        Reported by Thorsten Otto with example patch.
        [c8fbc913]

2022-07-26 Eero Tamminen

        Fix AddressSanitizer warning in HD emulation code

        About read extending to neighbouring variable.

        (Every warning aborts Hatari, so all of them need to be fixed to
        find potential later ones.)
        [ac9f432a]

2022-07-26 Nicolas Pomarede

        Fix bus error when enabling debug functions to validate consistency
        of 68030 data cache The functions to check the data cache will use
        get_long/_word/_byte which could cause a bus error when accessing
        RAM 0-$7FF and not in supervisor mode. Add BUS_MODE_DEBUGGER to
        access such RAM without doing a bus error.
        [ab9342e4]

2022-07-25 Eero Tamminen

        Correct EmuTOS variant info for v2.4.0 release
        [3e01f447]

2022-07-20 Eero Tamminen

        Add more info on Midi Maze connection issues

        Based on: https://www.atari-forum.com/viewtopic.php?p=433900#p433900
        [f1f32d3d]

2022-07-24 Nicolas Pomarède

        Much more precise function to convert CPU clocks to YM2149 clock,
        fix some STE sound glitches Previous method using floating point was
        not always accurate in STE mode and accumulated too much error after
        a while. This new method will cover both STF and STE/TT/Falcon 
        clocks' conversion using only integer operation and no rounding
        spreading over time
        [f91714f2]

2022-07-23 Nicolas Pomarède

        Improve TT mode video counter at $FF8205/07/09 by taking nHBL into
        account
        [8bb87e4d]

2022-07-23 Thomas Huth

        Move deprecation section to the top
        [0c3a00e9]

2022-07-23 Thomas Huth

        Make sure to update video counter in TT mode
        [1519ca08]

2022-07-15 Eero Tamminen

        Update documentation for VDI min alignment fix
        [10df923c]

2022-07-14 Thomas Huth

        Screen width must be a multiple of 16 in VDI resolution modes

        Bitplanes are interleaved in chunks of 16 pixels, so it does not
        make sense to allow alignments less than 16 here. This fixes a bug
        reported by GoKMasE here:
        https://www.atari-forum.com/viewtopic.php?p=435522#p435522 where the
        right 8 pixels of the screen are not right when running Hatari with:

         hatari --machine tt --vdi on --vdi-width 1280 --vdi-height 960
        --vdi-planes 4

        Hatari wrongly sets the screen size to 904x672 in this case - and
        904 is not divisable by 16, so the final pixels of each line get
        messed up.

        Fixes: 918580938908 ("Allow VDI mode to emulate devices with smaller
        screens")
        [508c4cd3]

2022-06-18 Thomas Huth

        Use the internal (WinUAE) disassembler in Disasm_GetNextPC()

        This way we can be sure that the next PC value really really matches 
        the CPU emulation, and we make this function independent from the
        "external" disassembler (which we want to get rid of / replace).
        [00a841d9]

2022-07-10 Thomas Huth

        Remove the hack of undefining REG_A0 by avoiding to include signal.h

        signal.h pulls in sys/ucontext.h which defines REG_A0 again on
        RISC-V. To avoid that we run into similar problems again in the
        future, we should rather avoid including signal.h and m68000.h in
        the same files. Currently, this only happens in src/cpu/debug.c, and
        we don't even need the stuff from signal.h there, thus let's simply
        drop the inclusion of signal.h there, then we can remove the REG_A0
        hack from m68000.h again.
        [b13a6f18]

2022-07-10 Eero Tamminen

        Add more info on Hatari freeze with ETOS v1.1 / XaAES
        [0e4ae9a8]

2022-07-09 : *** Version 2.4.0 ***

2022-07-09 Nicolas Pomarede

        New release 2.4.0, update dates in corresponding files
        [26c353ed]

2022-07-09 Nicolas Pomarede

        Remove wrong 'if' block for CPU's data cache (was a bad merge with
        WinUAE's sources)
        [ef494ab3]

2022-07-03 Thomas Huth

        Update broken/obsolete hyperlinks
        [787c04ac]

2022-07-03 Thomas Huth

        Fix typos
        [120c62a5]

2022-07-01 Nicolas Pomarede

        Fix a case in CE mode when reading timer b counter at the same time
        counter is changing This special overlapping case is not needed
        anymore in CE mode as we now call MFP_UpdateTimers() just before
        reading the content of $fffa21, which means
        MFP_TimerB_EventCount_Interrupt() will also be called if needed and
        TB counter should already be correct
        (really fix flickering bottom overscan in the menu of the 'Union
        Demo')
        [1eef08ac]

2022-07-01 Nicolas Pomarede

        Fix wrong timer B position in CE mode when changing video freq and
        using new cycInt code Video_AddInterrupt() needs to call
        Video_GetPosition_CE() to take into account how many cycles were
        already processed in the current opcode to start the next timer B at
        the correct position
        (fix flickering bottom border during 'Screen 1' in the 'B.I.G. Demo'
        by TEX)
        [1900f630]

2022-06-30 Nicolas Pomarede

        Reset Video_GetPosition_ForceInc at the end of
        Video_InterruptHandler_EndLine()
        [cc678e35]

2022-06-29 Nicolas Pomarede

        Add a special case for CYCLES_COUNTER_VIDEO when Timer B handler is
        called from MFP_UpdateTimers() This is similar to the change
        ed1dafc5 from 2022/05/21 for HBL interrupt This case should be
        removed later when we replace CYCLES_COUNTER_VIDEO with
        CyclesGlobalClockCounter
        (fix flickering bottom overscan in the menu of the 'Union Demo'
        [a24e1477]

2022-06-27 Nicolas Pomarède

        Fix building on RISC-V (patch Tien Hock Loh) REG_A0 is already
        defined in RISC-V's header, which conflicts with our enum type
        [952c5292]

2022-06-25 Eero Tamminen

        Log byte writes in addition to reads for "midi" trace
        [47459bca]

2022-06-19 Eero Tamminen

        Fix MIDI read error logging

        It turned out I had misunderstood badly worded Glibc fgetc() manual 
        page.  Thomas pointed out much more precise POSIX text, which 
        explicitly states fgetc() returning only EOF on errors.

        => Change error logging to use errno, and call clearerr()
          only when EOF is due to operations on that stream

        Fixes: 1c415e4c4b
        [8783363a]

2022-06-25 Eero Tamminen

        Correct build issue with ifdeffed out lilo code
        [a9a7771f]

2022-06-25 Eero Tamminen

        Add kernel patch to avoid misleading backtraces

        And update backtraces in the m68k-linux doc accordingly.
        [c8f63462]

2022-06-25 Eero Tamminen

        Update m68k-linux config + doc to v5.18

        Debian links are updated to currently existing files, but steps for
        building m68k Debian rootfs were not tested this time.

        Also change "it's" -> "it is" etc for consistency with other docs.
        [c2f92914]

2022-06-25 Eero Tamminen

        Minor improvements to Linux MIDI doc
        [870ea291]

2022-06-25 Eero Tamminen

        Update Calamus compatibility info

        Christian Zietz bisected EmuTOS and found things breaking when
        EmuTOS added similar GDOS stubs as what real TOS versions provide,
        and Calamus working with GDOS present.  Thanks!

        Checked that Calamus worked with previous Hatari release + added dl 
        links.
        [986e9c92]

2022-06-24 Eero Tamminen

        Update EmuTOS compatibility notes

        Add debuggers, MIDI programs and large resolution GEM programs.
        [374b718b]

2022-06-25 Eero Tamminen

        Update MIDI, Calamus and MiNT compatibility notes
        [3c9ba538]

2022-06-24 Eero Tamminen

        Update information on EmuTOS variants and versions

        * Add info about new 1024k version
        * Use "variant" term for different sizes, "version" for versions
        * Use variant size suffix consistently (...k, not .../...K/...KB)
        * Simply info about needed min versions
        [213d9cc1]

2022-06-24 Eero Tamminen

        Update compatibility info for programs with MMU notes

        Several of the programs tested long time ago to work only with MMU, 
        do not need that any more (even wit 2.3.1).
        [bc1a5f84]

2022-06-24 Eero Tamminen

        Also MMU emulation uses more host CPU
        [00f5a568]

2022-06-21 Eero Tamminen

        Add X-perience Falcon demo to compatibility lists

        Issue reported by Laurent.
        [74cc3105]

2022-06-17 Eero Tamminen

        Fix handling of unterminated NF strings

        Fixes: b2a81850 (introduced in 2.3.0)

        Thanks to Thorsten Otto for noticing this from the sources!
        [605f2152]

2022-05-12 Eero Tamminen

        Add "--country" option for NVRAM-less machines with EmuTOS

        Added also option helper function for country codes now that there
        are 3 options needing it, and split TOS_ShowCountryCodes() off from 
        TOS_ParseCountryCode() for better option error reporting.

        Noted in NVRAM layout option what are potential issues when either 
        that, or this new option changes TOS keyboard layout.
        [8d0a7ce7]

2022-06-15 Eero Tamminen

        Fine-tune SDL GUI CPU dialog texts and keyboard shortcuts

        Be more explicit that options increase *host* CPU usage, to avoid 
        users thinking them making emulated system slower instead of faster. 
        And remove confusing "slower" note from manual on these options.

        Changed also keyboard shortcuts to be on first letters of (first) 
        words when possible, and removed extra space from the boxes to make 
        them better balanced visually & more consistent with System dialog.
        [b9af9b58]

2022-06-18 Eero Tamminen

        EmuTOS compatibility updates
        [ce8058b9]

2022-06-18 Eero Tamminen

        Compatibility list updates

        Tron2001 demo works nowadays without IDE being enabled. FlaySID has
        regressed significantly.
        [36276d2b]

2022-06-17 Eero Tamminen

        MIDI error handling and logging improvements

        * Reads can get also other errors than EOF
        * Skip read error messsages on EOF. Successful reads are already
         traced so it's enough for EOF to be just lack of output
         (instead of constant stream of read error messages)
        * Tell whether file access is buffered or not
        [1c415e4c]

2022-05-12 Eero Tamminen

        Take NVRAM language default from the LANG environment variable
        [6a3705d1]

2022-06-17 Eero Tamminen

        Support more Hatari options in Python UI machine dialog

        Add support for setting CPU compatibility + cycle-accuracy,
        +  FPU type + accuracy, MMU and ST blitter options.

        For now this still takes into account whether underlying Hatari 
        version uses WinUAE core or not.  That will be removed for next 
        release.
        [6b22537a]

2022-06-17 Nicolas Pomarede

        Fix Falcon sound quality in crossbar's emulation when mixing the
        input sources This part used a wrog value for Falcon cpu's freq
        which gave very bad result now that we use the recent cycle accurate
        YM2149 emulation A small drift remains that could alter sound after
        approx 2 hours of playing
        [b70e6935]

2022-06-17 Eero Tamminen

        Fix freeze with empty NatFeats NF_STDERR("") string

        Fixes: b2a81850 (introduced in 2.3.0)

        Thanks to Matthias Arndt for reporting the issue, and Christian
        Zietz for debugging the cause for it!
        [272b40ab]

2022-06-16 Nicolas Pomarede

        Use 50.053 VBL/sec for Falcon instead of 50 VBL/sec (same as
        STF/STE, required for accurate YM2149 emulation) For now we assume
        all Falcon video modes are based on the same number of cycles per
        VBL as an STF/STE at 50 Hz PAL, taking nCpuFreqShift into account, 
        which gives 50.053 VBL/sec for PAL This should be changed when Videl
        emulation gets improved
        [db4df0a1]

2022-06-16 Thomas Huth

        Fix the checks for the end of the video RAM

        fvram_line does not necessarily point into the STRam[] area, e.g.
        when rendering monochrome mode on ST/STE (it points to the
        FrameBuffer.pSTScreen copy there instead), so we have to look at the
        video base address instead and count whether we've hit STRamEnd
        during the rendering.

        Thanks to Christian Zietz for spotting and analyzing the problem!
        [e471a2d1]

2022-06-16 Thomas Huth

        Add a generic function to get the video base address
        [2380cd50]

2022-06-11 Thomas Huth

        Fix issues reported by shellcheck
        [d0ef984a]

2022-06-11 Thomas Huth

        Merge github pull request #20 from chainq/master

        fix using block and character devices as hardfiles on
        macOS[e66dba96]

2022-06-07 Nicolas Pomarède

        Update docs for Falcon's clocks : CLK2 (YM2149) and FCCLK (FDC) are
        coming from DSP 32MHz clock
        [5a1b80b3]

2022-06-06 Nicolas Pomarede

        Allow compilation when using old CycInt code
        [85d8ca63]

2022-06-06 Nicolas Pomarede

        When running CPU in CE mode currcycle should be reset in main run
        loop before calling CycInt_Process() If not, currcycle was wrongly
        counted twice when using Cycles_GetClockCounterImmediate() which
        gave wrong timings when adding internal CycInt timers This partially
        restores Falcon's sound quality that was bad since using new CycInt 
        and new cycle accurate YM2149
        [f94be3e2]

2022-06-05 Eero Tamminen

        Update Falcon demo compatibility info

        * Added "Mars DSP"
        * Enraged has improved (already in 2.3.1)
        * Sonoluminenz has regressed since 2.3.1
        * Updated demos having major issues to being tested with 2.4
        * Updated descriptions for some of the demos
        * "2.4-dev" -> "2.4"
        [a72ea2d6]

2022-06-05 Eero Tamminen

        Update EmuTOS Falcon compatibility info

        * Add 4orce & django1 demos + chorensa DSP version
        * Move items for EmuTOS version under which they appear to work
        fully

        For now, I retained info on whether programs work partially under 
        older EmuTOS version, but eventually that will be removed.
        [f4d22bbb]

2022-06-04 Eero Tamminen

        Fix "--fpu" option regression

        Fixes: 0fb6eaf0d
        [9fd76dd1]

2022-06-04 Eero Tamminen

        Update Falcon Addsub game and applications compatibility

        Laurent noticed that Addsub actually works, its input is just very
        restricted.  It has probably been working for a long time, but at
        least since 2.3.

        Add more info for some of the problematic Falcon applications.
        [c046297f]

2022-06-04 Eero Tamminen

        Update compatibility info on rest of problematic ST/STE demos

        According to Nicolas, Extreme Rage should have been fixed in 2.0, 
        and rest are still buggy.
        [e9d2180d]

2022-06-04 Nicolas Pomarede

        Update TT demos list
        [a5ac6636]

2022-06-04 Eero Tamminen

        Compatibility list updates

        ST demos:
        * Pandenomium works. According to Nicolas, at least since 2.3
        * Setting 3 demos to 2.4 that Nicolas indicated to be still broken

        STE games:
        * Only Dynabusters+ seems to have issue remaining

        STE demos:
        * Setting 3 demos to 2.4 that I tested and were still broken

        TT apps/demos:
        * Checked / updated everything having issues earlier

        Other:
        * Sync Hextracker entries between different machines
        [264d8e79]

2022-06-04 Eero Tamminen

        Update EmuTOS Falcon games info

        Some of the new working games actually work already with v1.1.1,
        maybe due to fixes on Hatari side?  Tested also all broken Falcon
        games for whether they would work by allowing 16-bit mode in EmuTOS
        (without there being any VDI/Line-A 16-bit support).

        And 1 STE demo update.
        [0b320c88]

2022-06-03 Karoly Balogh

        fix using block and character devices as hardfiles on macOS
        [efa220ed]

2022-06-02 Thomas Huth

        Fix location of hatari.cfg on macOS in the cmdfifo test
        [e6c2c9a5]

2022-06-02 Eero Tamminen

        Support "off" as alias to "none" for CLI options

        Got tired of typing "--dsp off" and only then remembering that 
        opposite of "--dsp" multi-select option "emu" value is "none".
        [0fb6eaf0]

2022-06-01 Eero Tamminen

        Update compatibility status for problematic Falcon games

        Slippery Sam does not need "dummy" DSP mode any more, it works fine 
        with and without DSP now.  Other problematic Falcon games did not
        show improvements, so only tested Hatari version and some of their
        info is updated for those.
        [ae520bf5]

2022-06-01 Eero Tamminen

        Update to latest EmuTOS snapshot Falcon demo/game/app status

        4 Falcon games that did not work with EmuTOS at all, work now fine, 
        one still broken game gets further, and two extra games may work,
        but Hatari Videl emulation issues prevent verifying that.
        [fb534076]

2022-06-01 Eero Tamminen

        Show Hatari output also when cmdfifo test appears to succeed

        Normally CTest hides test output. This allows debugging whether 
        cmdfile test actually works as intended, for FIFO commands that it 
        does not explicitly check, by adding "-V" (verbose) option for
        CTest.
        [59fb7403]

2022-05-31 Nicolas Pomarede

        When using 68030+MMU cycles were not correctly counted during STOP
        state, use CpuRunCycleExact
        [487f65d4]

2022-05-31 Eero Tamminen

        Update Hatari UI release notes
        [a20d55cc]

2022-05-31 Eero Tamminen

        Hatari UI display dialog layout change: VBox -> Table

        Table layout is more readable and consistent with other dialogs. 
        Dialog value getting and setting are also split to their own
        methods.
        [dcdbedde]

2022-05-31 Eero Tamminen

        Hatari UI sound dialog layout change: VBox -> Table

        Table layout is more readable and consistent with other dialogs. 
        Dialog value getting and setting are also split to their own
        methods.
        [fc4a3d5a]

2022-05-31 Eero Tamminen

        Misc Hatari UI dialog code improvements

        * Put successive checkboxes in a table into VBox
        * Drop tables column counts to 2 (rest were unused)
        * Improve label /tooltip texts and comments
        * Drop plurals from class member names
        [6e3c0d93]

2022-05-30 Eero Tamminen

        Update Hatari UI release notes
        [528a5a87]

2022-05-30 Eero Tamminen

        Improve Hatari UI machine dialog

        Using combo boxes instead of radio buttons makes the dialog clearer.
        [a0cb9ce5]

2022-05-30 Eero Tamminen

        Add Hatari UI dialog table combo box helper and use it
        [fda57212]

2022-05-30 Eero Tamminen

        Add missing "scc" trace option to Hatari UI
        [045b9015]

2022-05-30 Eero Tamminen

        Fix: Hatari UI dialog exceptions under Wayland

        Max window size needs to be determined and cached even when Hatari 
        window is not embedded.

        Gdk does not provide primary monitor info under Wayland and whole 
        method is deprecated, so just use first monitor info:
        https://gitlab.gnome.org/GNOME/gtk/-/issues/1028
        [87265acd]

2022-05-30 Eero Tamminen

        Fix: Handle UAE disassembly + symbols output in Hatari UI debug UI
        [272ec548]

2022-05-29 Eero Tamminen

        Update SCSI + EmuTOS info in manual HW table for next release

        Next release will include EmuTOS v1.1 which provides DSP support.
        [e1a2c16c]

2022-05-29 Eero Tamminen

        Fix shellcheck warnings for debugger test script
        [83de5052]

2022-05-29 Eero Tamminen

        Fix shellcheck warnings for TOS tester screenshot-report

        "ls" is still used because that handles case of no matches
        (and "nullglob" setting is no-go as it's Bash specific).
        [1dc8f7d5]

2022-05-29 Eero Tamminen

        Fix test script name to enable cmdfifo testing

        Fixes: 1954c98fc3
        [73d9be6f]

2022-05-29 Eero Tamminen

        Apply shellcheck recommendations to top level test scripts

        And check for checkbashisms existency before trying calling it many 
        times.
        [54a936d6]

2022-05-29 Eero Tamminen

        Apply shellcheck suggestions to symbol scripts
        [bf4dc9c6]

2022-05-29 Eero Tamminen

        Apply shellcheck suggestions to symlink-busybox
        [238de945]

2022-05-29 Eero Tamminen

        Fix shellsheck warnings for atari-hd-image

        No real issues, but cleans the code a bit.
        [c3faffbd]

2022-05-29 Eero Tamminen

        Fix somewhat relevant shellcheck warnings for ring scripts

        Pids given to kill command need to be separate for things to work,
        but quoting Hatari args separately can be handled by using "$@"
        instead of
        "$args" (and "$*" in iecho to avoid another shellcheck warning).
        [44fb784d]

2022-05-29 Eero Tamminen

        Fix shellcheck warnings for zip2st
        [08eb8343]

2022-05-29 Eero Tamminen

        Fix shellcheck warnings for hatari-prg-args

        Space separated arguments are not going to do any good even when
        they are correctly forwareded, but at least this silences shellcheck 
        checks.
        [6a2643ef]

2022-05-29 Eero Tamminen

        Fix somewhat relevant shellcheck warnings for midi ring script

        Args given to Hatari and pids given to kill command need to be 
        separate for things to work though, so they cannot be quoted 
        regardless of how much ShellCheck insists on that.
        [cefbfdfd]

2022-05-29 Eero Tamminen

        Fix tester onscreen message to match its MIDI output
        [3d668159]

2022-05-29 Eero Tamminen

        Fix TOS-boot tester test program building

        Layout setting change how keys injected by hconsole scripts are 
        interpreted by TOS => enforce compatible English layout
        [dcad385f]

2022-05-29 Eero Tamminen

        List current OS specific issues in bugs.txt
        [ee3d8f44]

2022-05-27 Chris Jenkins

        Fix crash on Mac by setting size of buffer correctly

        Also switch from using strncpy to strlcpy, which should ensure that 
        the string is always null terminated.

        Fixes: b8b80c4d6b (by improving 27ec2eb04e)
        [7fa9874a]

2022-05-28 Eero Tamminen

        Fix tidy notes for Hatari UI documentation

        And improve descriptions for screenshot sections
        [5f8c22e5]

2022-05-28 Thomas Huth

        Fix some typos (discovered with codespell)
        [90706e1c]

2022-05-28 Thomas Huth

        Update docs with regards to the RS232 thread removal
        [7d5aecec]

2022-05-27 Thomas Huth

        Make sure to have python3 in some CI pipelines
        [981ead4d]

2022-05-27 Thomas Huth

        Check tidy on Fedora, too
        [e7ec0528]

2022-05-27 Thomas Huth

        Get rid of the thread in the rs232 code, use polling instead

        The thread in the rs232 could cause deadlocks since we switched to
        SDL2 that does not have the SDL_KillThread() function anymore. Thus
        let's get rid of the thread code here now and use polling instead
        (like we do it in the midi code already).
        [4802502e]

2022-05-24 Eero Tamminen

        Install Python UI documentation to DOCDIR

        Update Python UI code document links accordingly, and add menu item
        for Hatari bugs list.
        [ac00bf2a]

2022-05-24 Eero Tamminen

        Add Hatari Python UI documentation

        eerott.mbnet.fi site is going away after next release (in fall), so
        documentation needs to be updated before release.  By adding 
        relevant pieces to Hatari repo.
        [07436c1b]

2022-05-24 Eero Tamminen

        Move hconsole doc to DOCDIR

        And comment why Debian's patch for example.py stuff is incorrect.
        [b3e87541]

2022-05-24 Eero Tamminen

        Install more of the Hatari documentatation

        Stuff that were added / split to separate files long time ago...
        [569c8703]

2022-05-22 Eero Tamminen

        Add debug symbols to WinUAE CPU core disassembly

        WinUAE CPU core appends provided symbol name (associated to given 
        instruction memory address) to its disassembly output.
        [62331b8e]

2022-05-23 Nicolas Pomarède

        Update authors.txt
        [2e479f70]

2022-05-23 Nicolas Pomarède

        Allow compiling macOS version if PortMidi is not available (patch by
        Chris Jenkins)
        [33312a16]

2022-05-22 Eero Tamminen

        Fix profile data saving for WinAUE CPU code debugger output

        It's Hatari debugger's role to tell post-processing tools how to
        parse given disassembly output, what regexp to use to get profiling
        data and its memory address from the disassembly.
        [9d1a5075]

2022-05-22 Eero Tamminen

        Fix SDL GUI MIDI port name setting

        According to Atari-forum post, it can crash on Mac:
         https://www.atari-forum.com/viewtopic.php?p=427678#p427678

        Remove obsolete asserts and use strlcpy() to make sure setting
        buffers are not overflown.

        Note: I have no idea how the overflow crash could have happened as 
        FILENAME_MAX is supposed to be something like 1KiB on Mac and so 
        having PortMidi names longer than that sounds very unlikely.

        PS. I also changed port name buffer sizes to something more
        reasonable than FILENAME_MAX, as prefix match is enough for current
        code, if there's no exact full mach.
        [b8b80c4d]

2022-05-22 Eero Tamminen

        Document Federico's earlier contribution
        [e68c1cd1]

2022-05-21 Nicolas Pomarède

        Add a special case for CYCLES_COUNTER_VIDEO when HBL handler is
        called from MFP_UpdateTimers() This is a sde effect of the new
        possibility to call CycInt_Process when accessing MFP register ; if
        the internal HBL timer expires at the same time, the value for
        CYCLES_COUNTER_VIDEO will not be updated yet and this could lead to
        wrong timings for the next HBL timer This case should be removed
        later when we replace CYCLES_COUNTER_VIDEO with
        CyclesGlobalClockCounter
        (fix flickering fullscreen end part in 'Little -ME- Demo' by
        Overlanders when running in STE mode)
        [ed1dafc5]

2022-05-20 Nicolas Pomarede

        Improve YM2149_UpdateClock_250() in the case where CPU's clock and
        YM2149's clock are different (eg STE) This fixes audio sync issues
        that could happen when playing DMA sound in STE mode
        (fix "The (fucking) (complex) Art of Profanity" by SMFX / DHS)
        [1f37d386]

2022-05-19 Nicolas Pomarede

        Really fix wrong counting of remainder cycles in
        YM2149_UpdateClock_250() (previous commit 9a842cd4 had fix disabled)
        [062f1ce9]

2022-05-19 Nicolas Pomarede

        Fix YM2149_UpdateClock_250(), some remainder cycles were wrongly
        counted, altering the generated samples freq With a chosen audio
        ouput of 44100 Hz, this generated a wrong samples freq of approx
        44093 Hz. This gave hearable video/sound synchro problems when
        recording an AVI file after 5 minutes or more Thanks to Evil/DHS for
        pointing this bug
        [9a842cd4]

2022-05-19 Nicolas Pomarede

        Merge branch 'master' of https://git.tuxfamily.org/hatari/hatari
        [dfd9a232]

2022-05-19 Nicolas Pomarede

        Add some stats to measure the accuracy of the emulated sound +
        update some comments When Sound_Stats_Show() is enabled, it will
        display the emulated sound frequency on every VBL, compared to the
        chosen audio output freq (eq 44.1 kHz). The emulated freq should be
        as close as possible to the audio output freq and should not deviate
        over time
        [387a412f]

2022-05-18 Nicolas Pomarede

        When using --avi-fps we must take into account the emulated number
        of VBL per sec For example --avi-fps 50 should write a value of
        50.053 fps in the avi file for an STF running in PAL mode
        [cf797066]

2022-05-07 Thomas Huth

        Fix some typos (discovered with codespell)
        [842fbe19]

2022-05-07 Thomas Huth

        Mention the DMA sector count and GCopy in the TODO list
        [c2cd8a86]

2022-05-05 Nicolas Pomarede

        Update release notes
        [698e8400]

2021-02-11 Eero Tamminen

        Allow GEMDOS tasks to use other tasks' file handles

        When GEMDOS tasks are identified by their basepage address.

        Fixes Fseek() issues in We Were @ demo HD version under GEMDOS HD 
        emulation.
        [252d08f0]

2021-09-08 Eero Tamminen

        Add "PConSymbol" debugger variable

        To trigger breakpoint on each symbols (e.g. ones that have been
        loaded for that particular purpose).
        [51c76cc0]

2022-04-25 Nicolas Pomarède

        Simplify cc replacement in disasm (from WinUAE 2022/04/25)
        [ed7e92c3]

2022-04-25 Eero Tamminen

        Tell in which phase of parsing profile post-processing is
        [f97cee9d]

2022-04-25 Eero Tamminen

        Improve debugger manual program breakpoints description

        To better clarify: https://www.atari-forum.com/viewtopic.php?t=41804
        [dc0dccd6]

2022-04-22 Nicolas Pomarede

        Increase szTracks to silence gcc warnings We only use 3 chars as
        nTracks can't go behind 85, but this gives some warnings :
          sprintf(szTracks, "%i", nTracks); gui-sdl/dlgNewDisk.c:136:44:
        warning: '%i' directive writing between 1 and 11 bytes into a region
        of size 3 [-Wformat-overflow=] gui-sdl/dlgNewDisk.c:136:43: note:
        directive argument in the range [-2147483647, 2147483647]
        [6fe43df9]

2022-04-22 Nicolas Pomarede

        Use snprintf instead of _tcsncpy to remove a gcc warning about null
        terminated string
        [7d5d536f]

2022-04-22 Eero Tamminen

        Fix illogical variable usage

        If it's named as MBs, it should contain MB value. Changed also
        variable name to match one used in the opposite function.
        [ca614079]

2022-04-22 Eero Tamminen

        Remove explicit WinUAE core mentions from debugger manual

        Now that OldUAE core is dropped, distiction is not relevant.
        [5425a5aa]

2022-04-22 Eero Tamminen

        Update 1024 MiB TT-RAM limit to documentation

        Also change all MB mentions to MiB for consistency.
        [66f52358]

2022-04-22 Eero Tamminen

        Increase max TT-RAM amount to 1024 MiB

        As requested in in atari-forum thread, pointing out HW modification
        allowing this amount of TT-RAM: 
        https://www.atari-forum.com/viewtopic.php?t=41770
        [8302d8e3]

2022-04-18 Nicolas Pomarède

        C TRY/STOPTRY fix (from WinUAE 4.9.1+ 2022/04/15)
        [7c8ed67c]

2022-04-18 Nicolas Pomarède

        Update debug/disasm (from WinUAE 4.9.1+ 2022/04/14)
        [0aa76c1b]

2022-04-18 Thomas Huth

        The 'Strange screen size' message is not really critical, decrease
        level to INFO
        [8298cb73]

2022-04-17 Thomas Huth

        Relax the check for TOS versions a little bit

        There are apparently ROM images of MagiC available which use version 
        6.20 in the ROM header. Relax the TOS version check a little bit so 
        that these could be used, too.
        [17e2ac50]

2022-04-08 Nicolas Pomarède

        B230400 is not defined on all systems, ensure compilation works
        anyway
        [3b2ebaed]

2022-04-08 Nicolas Pomarède

        Fix MFP timings when MegaSTE runs at 8 MHz instead of 16 MHz Fix
        fullscreen end part in 'Little -ME- Demo' by Overlanders when
        running in MegaSTE mode
        [87877c9c]

2022-04-08 Nicolas Pomarede

        Add missing include for PRIx64 macro
        [27ad9aa9]

2022-04-08 Nicolas Pomarede

        Improve YM2149 250 kHz clock when CPU freq is changed on the fly 
        Previous method to compute YM2149_Clock_250 was not correct, it made
        the sound silent for several seconds when CPU freq was increased. 
        This fixes 'Little -ME- Demo' by Overlanders when running in MegaSTE
        mode and CPU goes from 8 to 16 MHz during the 3D part.
        [ad1687ff]

2022-04-03 Eero Tamminen

        Update release notes

        * Uwe's SCSI improvements
        * "info mmu" support
        * fine-tuning
        [ae713e90]

2022-02-12 Eero Tamminen

        More info on demos broken with EmuTOS

        Plus some reformatting for consistency.
        [68be1d53]

2022-04-03 Thomas Huth

        Add an 'info mmu' debugger command
        [14013d46]

2022-03-26 Thomas Huth

        Update .gitignore file

        Remove the old uae-cpu files and add entries that should be ignored 
        when building with the Eclipse IDE.
        [6a86f054]

2022-03-26 Thomas Huth

        Silence static analyzer warning about a suspicious semicolon
        [76a1c59e]

2022-03-26 Thomas Huth

        Fix endlessly growing try/catch stack when returning from run-loop

        STOPTRY has to be used before returning from within a TRY-CATCH
        block. Based on a patch by Andreas Grabher for the Previous
        emulator.
        [0dd726b0]

2022-03-25 Nicolas Pomarede

        Use M68000_AddCycles_CE instead of M68000_WaitState when counting
        cycles during FDC's DMA transfer
        [627e5447]

2022-03-21 Nicolas Pomarede

        More fix for detecting when VBLANK should be disabled in 50 and 60
        Hz This fixes the menu part in 'Hackabonds Demo' where vblank going
        off was not correctly detected, giving only a purple screen instead
        of the main menu. Thanks to Troed and Ijor for their input on these
        values
        [75c13ec7]

2022-03-20 Thomas Huth

        Fix coding style (indent with tabs, and put curly braces on new
        lines)
        [52daeeaf]

2022-03-17 Uwe Seimet

        Fix HD_REPORT_LUNS handling

        Replaces magic constants (opcodes) by existing definitions. Add
        missing check for HD_REPORT_LUNS in HDC_WriteCommandPacket().

        [Modified by Thomas : Cut the patch out of a bigger patch by Uwe,
        and adjusted the commit message]

        Fixes: dbc4ae4abf58 ("Add support for the 'REPORT LUNS' command")
        [a0917fec]

2022-03-17 Uwe Seimet

        Added header to mode pages

        The mode pages were missing the header required by the SCSI
        specification.
        [0d3939f2]

2022-03-19 Thomas Huth

        Fix more broken links in the documentation
        [0304b8a9]

2022-03-19 Thomas Huth

        Fix broken links to http://atari-ste.anvil-soft.com/
        [64db45e9]

2022-03-18 Nicolas Pomarède

        Fix bad offset in CycInt_AddRelativeInterruptWithOffset (fix commit
        d5a2aacab6 from 2022/03/09)
        [beb6df00]

2022-03-18 Nicolas Pomarede

        Update comment for video timings
        [4170f64d]

2022-03-18 Nicolas Pomarede

        Fixes new version of CycInt_ModifyInterrupt for updating the VBL
        timer This fixes the main menu in 'Hackabonds Demo' where internal
        VBL timer was not correctly updated
        [c50c87bb]

2022-03-14 Nicolas Pomarède

        Add missing parameter when compiling with old cycInt code
        [c895a8b5]

2022-03-14 Nicolas Pomarede

        Update mode page 0x3f to return all available pages in the order
        requested by the SCSI specification (patch by Uwe Seimet) Note from
        Uwe : This patch updates mode page 0x3f to return all available
        pages in the order requested by the SCSI specification (i.e. page 0
        last).

        IMO the implementation of mode page 0x04 is wrong. It is definitely
        incomplete because it ignores some CDB data. In particular it does
        not check the DBD bit:

        A disable block descriptors (DBD) bit of zero indicates that the
        target may return zero or more block descriptors in the returned
        MODE SENSE data
        (see 8.3.3), at the target's discretion.  A DBD bit of one specifies
        that the target shall not return any block descriptors in the
        returned MODE SENSE data.
        [097d4418]

2022-03-14 Nicolas Pomarede

        Add an hexa dump when logging the CDB fields (patch by Uwe Seimet)
        [5e0da3c1]

2022-03-14 Nicolas Pomarede

        Fix position for detecting when VBLANK should be disabled in 50 Hz 
        This fixes the intro part in 'Hackabonds Demo' where some frames
        displayed only a black screen
        [9c89406f]

2022-03-09 Nicolas Pomarède

        Improve 'MODE SENSE' command (patch Uwe Seimet) This improves MODE
        SENSE a bit, by at least returning one page instead of none when all
        are requested
        [53d9351a]

2022-03-09 Nicolas Pomarède

        Add support for the 'REPORT LUNS' command (patch by Uwe Seimet)
        [dbc4ae4a]

2022-03-09 Nicolas Pomarede

        For STE DMA sound, use STMemory_DMA_ReadByte() instead of accessing
        STRam[] directly
        [2a66d183]

2022-03-09 Nicolas Pomarede

        Use Cycles_GetClockCounterImmediate() when calling
        MFP_UpdateTimers()
        [1d539196]

2022-03-09 Nicolas Pomarede

        Remove internal cycles adjustment in MFP timer since it's now
        handled by Cycles_GetClockCounterImmediate() in CycInt functions
        [d5a2aaca]

2022-03-09 Nicolas Pomarede

        Rename CycInt_FindCyclesPassed() to CycInt_FindCyclesRemaining()
        [0da39a43]

2022-03-09 Nicolas Pomarede

        Remove AddCpuCurCycles param from CycInt_FindCyclesPassed() as we
        now use Cycles_GetClockCounterImmediate()
        [ed76b27e]

2022-03-09 Nicolas Pomarede

        Use Cycles_GetClockCounterImmediate() instead of
        CyclesGlobalClockCounter to handle MFP updates This will take into
        account the current cycles already processed when MFP is updated 
        during the processing of an instruction in Cycle Exact mode
        [650979aa]

2022-03-06 Thomas Huth

        Indent with TABs instead of spaces
        [7ea2b3f9]

2022-03-02 Nicolas Pomarède

        Revert WinUAE change for 68000 IPL timing from 2021-09-27 as it
        breaks cycle accuracy for the 'STOP' instruction The 'STOP'
        instruction took 4 extra cycles since 2021-09-27, which could break
        several demos relying on cycle accurate 'STOP'
        [f95b4fbc]

2022-02-25 Thomas Huth

        Silence some "unused-but-set-variable" warnings from Clang 13
        [0ef2a576]

2022-02-22 Nicolas Pomarede

        When running in TT mode with MMU, m68k_run_mmu030 can run in CE or
        not, so update CpuRunCycleExact accordingly
        [c4ade5e5]

2022-02-20 Thomas Huth

        Allocate enough memory for runaway DMA accesses

        Instead of cluttering and slowing the video rendering code with 
        sanity checks for the end of the RAM, let's rather always allocate 
        enough memory to allow accesses beyond the end of the ST RAM.
        [5316b408]

2022-02-20 Thomas Huth

        Replace spaces with tabs in memory.c

        WinUAE switched to tabs in this file a long time ago already. So do
        the same in Hatari now.
        [dcf2e88c]

2022-02-19 Thomas Huth

        Add test that sets screen base to the end of the RAM
        [c63cbed0]

2022-02-19 Thomas Huth

        Don't crop the window to desktop resolution when running without SDL
        renderer

        Otherwise the screen surface is too small for our convertion
        functions.
        [868a4de0]

2022-02-16 Christian Zietz

        Add "Frontier: Elite 2" to compatibility list
        [e2c9e277]

2022-02-13 Thomas Huth

        Still update pSTScreen pointer in case we hit the end of the RAM
        [a2bcbcee]

2022-02-15 Nicolas Pomarede

        Use CpuRunCycleExact to access currcycle when CPU is really in CE
        mode
        [463fb625]

2022-02-12 Thomas Huth

        Sanity check for mono mode
        [0b353ce1]

2022-02-12 Thomas Huth

        Add sanity check for ST screen rendering, too
        [f83087a4]

2022-02-12 Thomas Huth

        Add sanity checks to avoid accesses beyond the end of the ST-RAM

        Otherwise Hatari could crash if the screen was going beyond the end
        of the ST-RAM.
        [c3875fc8]

2022-02-12 Thomas Huth

        Remove superfluous variable fvram_line
        [0f76e8ff]

2022-02-10 Eero Tamminen

        Update ST demos EmuTOS compatibility notes

        * Yanartas ST demo works only on STE
        * Few demos do not crash towards the end any more
        * SoWatt demo had stopped working in EmuTOS v0.9.10
        * More consistent way of listing the demo issues
        [924733b7]

2022-02-09 Nicolas Pomarede

        Fix wrong cycles count in CycInt_ModifyInterrupt()
        [2ff151e8]

2022-02-08 Nicolas Pomarede

        Update WinUAE CPU to 4.9.1 final from 2022/02/03 (no change for
        Hatari)
        [28a0c11b]

2022-02-08 Nicolas Pomarede

        Fix reported break point number (from WinUAE 4.9.0 beta9 2022/02/01)
        [2b2cc8df]

2022-02-08 Nicolas Pomarede

        Reverted 490b25 MMU CE mode cycle count update (from WinUAE 4.9.0
        beta8 2022/01/29)
        [7915944d]

2022-02-08 Nicolas Pomarede

        68020/030 CE delayed interrupt fix (from WinUAE 4.9.0 beta7
        2022/01/24)
        [78cbd437]

2022-02-08 Nicolas Pomarede

        JIT indirect/safe mode MOVEM.W bug fix (from WinUAE 4.9.0 beta1
        2021/12/18)
        [0fb219e0]

2022-02-08 Nicolas Pomarede

        Small fixes (from WinUAE 4.9.0+ 2021/12/16)
        [5bb1374c]

2022-02-05 Eero Tamminen

        Add Quaderno ST and Falcon versions to compat lists
        [62915bd2]

2022-02-06 Nicolas Pomarède

        Fix timings when restarting an MFP timer that just expired
        [e4060747]

2022-02-05 Eero Tamminen

        Add more MIDI programs to EmuTOS compat list
        [2a7775e4]

2022-01-23 Eero Tamminen

        EmuTOS compat update
        [175b878a]

2022-02-04 Eero Tamminen

        Update doc + config to m68k Linux v5.16
        [54578d49]

2022-02-04 Eero Tamminen

        Fix: LILO code ROM setup with SMALL_MEM config option
        [b96bc5a6]

2022-01-29 Nicolas Pomarède

        Fix PendingInterruptCount in CycInt_CallActiveHandler As
        CycInt_Process_Clock() can now be called by MFP_UpdateTimers(), the
        clock value when the interrupt happens is not always
        CyclesGlobalClockCounter which could give a wrong value for
        PendingInterruptCount Fix Hatari doing endless cycint loops for
        crossbar ints in Falcon mode since 2022/01/27
        [527b68f6]

2022-01-29 Thomas Huth

        Drop portaudio from the CI files, too

        And while we're at it, update the Fedora image in the gitlab CI
        [08bc35c6]

2022-01-28 Nicolas Pomarède

        When computing value of GPIP7, use Crossbar_Get_SNDINT_Line()
        instead of accessing crossbar's variables
        [2bd0ec87]

2022-01-28 Nicolas Pomarède

        For Falcon DMA sound, split SNDINT into SOUNDINT and SNDINT (as seen
        in schematics) SNDINT is connected to MFP GPIP7 and SOUNDINT is
        connected to MFP Timer A input
        [32529834]

2022-01-28 Nicolas Pomarede

        Use CpuRunCycleExact instead of currprefs.cpu_cycle_exact when we
        want to check if the CPU is running in CE mode Although
        currprefs.cpu_cycle_exact can be true when Hatari starts, it might
        be ignored when emulating specific CPU combination (for example
        68040 with MMU) but it will remains true. This could confuse
        Cycles_GetInternalCycleOnReadAccess / WriteAccess who rely on this 
        value and mistakenly used 'currcycle' when it was not available. 
        Instead, CpuRunCycleExact is only set to true when the CPU core
        really runs in cycle exact mode.
        [340fd8c1]

2022-01-27 Nicolas Pomarede

        Print the value of CyclesGlobalClockCounter when using '--trace
        cpu_disasm'
        [b0b6876b]

2022-01-27 Nicolas Pomarede

        Call MFP_UpdateTimers / CycInt_Process before accessing any MFP
        registers This ensures MFP timers are updated in chronological order
        and not after executing the current opcode (fix the game Super Hang
        On, where 'bclr #0,$fffffa0f' to clear Timer B ISR sometimes happens
        at the same time that Timer C expires, which used the wrong ISR
        value and gave flickering raster colors)
        [375360e9]

2022-01-17 Nicolas Pomarede

        Fix printf in Microwire's infos
        [5bb8c1a7]

2022-01-16 Nicolas Pomarède

        Microwire's registers should be words, not bytes, in the debugger's
        output (patch by Ben/OVR)
        [50e219ed]

2022-01-15 Thomas Huth

        Make ENABLE_SMALL_MEM the default

        We're currently considering to get rid of the ENABLE_SMALL_MEM
        switch, with a preference to have it enabled by default. Thus let's
        turn it on by default now to get some more test coverage for this.
        [3122c569]

2022-01-08 Thomas Huth

        Replace PortAudio microphone code with SDL2 audio input

        SDL2 supports microphones / audio input, too. Since we've got rid of 
        SDL1.2 recently, we don't need the PortAudio code anymore and simply 
        can use SDL2 instead.
        [38accc16]

2022-01-07 Nicolas Pomarede

        Remove unused CycInt_ResumeStoppedInterrupt() and the related
        variables in the MFP
        [64a553f1]

2022-01-07 Nicolas Pomarede

        Improve accuracy when reading MFP's Timer Data reg and don't use
        CycInt_ResumeStoppedInterrupt() anymore This correctly fixes ST
        Connexion MFP saving routine used in Punish Your Machine (which does
        some very fast start/stop on each MFP timer until it detects the
        data reg has been reloaded) by taking into account the internal
        cycles count when the CPU made the read in the MFP's registers The
        call to CycInt_ResumeStoppedInterrupt() should be removed as there's
        no "resume" inside the real MFP, it's only stop/start and enough
        emulation's accuracy to compute the correct data reg value
        [53bd1a54]

2022-01-06 Eero Tamminen

        Remove Hatari v1.x config examples for constrained devices

        These devices are over decade old now and do not support SDL2 
        required by Hatari now.
        [066efd4f]

2022-01-06 Thomas Huth

        Remove support for Windows CE

        Windows CE is dead since years, and used SDL 1.2 which we now don't
        support anymore, so it does not make sense to keep this code in our
        sources.
        [304cc293]

2021-12-12 Eero Tamminen

        Fix: avoid key release event from SDL GUI closing leaking to
        emulation

        Return and Escape keys do not need to repeat on SDL GUI
        interactions, so acting only on their release is fine.

        If Space key not repeating any more turns out too annoying, we can 
        revert that part and just tell people to use mouse, joystick, or 
        Return / Escape key, instead of selecting the highlighted OK /
        Cancel button with Space key, to exit SDL GUI...
        [6468198d]

2021-12-15 Eero Tamminen

        Fix obvious typos in previous commit shown by troed's builder
        [697f0b04]

2021-12-13 Eero Tamminen

        Mac GUI code update for Midi_Host_GetPortName() change

        TODO: somebody with a Mac needs to verify that this works.
        [42e27d45]

2021-12-14 Eero Tamminen

        Improve code for PortMidi devices handling

        Get rid of several PortMidi related global variables by rewriting 
        related SDL GUI code, to query device file names from PortMidi on
        each device change.

        Unfortunately this does not help Hatari being able to use MIDI
        devices added while it is running, because getting current PortMidi
        to rescan devices would require calling Pm_Terminate() and
        Pm_Initialize().

        However, that would mess current MIDI connection state, so Hatari
        will do that only on startup.  I.e. seeing new MIDI device still
        needs Hatari restart.

        PortMidi promises not to change device indeces after PmInitialize(), 
        but if a future version could append new devices after existing
        ones, new devices would now show up in Hatari without need for
        re-start.
        [eb4722a5]

2021-12-12 Eero Tamminen

        Re-order code to reduce indentation in Midi_BuildEvent()
        [7fd4e221]

2021-12-14 Eero Tamminen

        Use prefix match for MIDI device name if there's no exact match

        Device names for e.g. software synthetizer applications, can include 
        app instance specific part in it, such as port or process ID, which 
        changes between app invocations. That makes device name saved to 
        configuration file earlier, less likely to work later on.

        This patch works on assumption that these instance IDs are appended
        to the end of the device name, and changes code to do prefix match
        if there's no exact device name match.  This works nicely e.g. with
        Linux Qsynth.
        [17751eca]

2021-12-14 Eero Tamminen

        MIDI: minor updates to documentation
        [9c61bd4e]

2021-12-14 Eero Tamminen

        MIDI: log PortMidi host error details / improve trace info

        And update bugs.txt with the findings.
        [af315d62]

2021-12-14 Eero Tamminen

        hconsole: accept non-integer values for sleep command
        [3937bfe2]

2021-12-12 Eero Tamminen

        Fix: MIDI IRQ needs to be re-enabled on re-init

        Midi_UnInit() removes the IRQ, but Midi_Init() does not set it, only
        Midi_Reset() does, which was called only on emulation resets.

        Midi_Reset() cannot be called from Midi_Init() itself because that 
        gets called also before emulation and interrupts are running, so it 
        needs to be called in addition to Midi_Init() when there's no 
        associated reset.

        From Nicolas: Variables reset in Midi_Reset() in addition to
        starting the timer is same as reseting any bytes that were currently
        in transit
        (ie we didn't receive all 8 bits yet), which should be acceptable
        when midi device is changed on the fly.

        (Add also few TODOs for PortMidi related variables that would be
        good to reset on MIDI device change.)
        [ef2540b2]

2021-12-13 Eero Tamminen

        Improve MIDI tracing

        - Move MIDI IRQ & register read/write trace output to separate
         "midi_raw" option, as that output being triggered just by moving
         mouse messes up debugging rest of MIDI funcionality
        - Log PortMidi device open failures
        [61634f20]

2021-12-11 Eero Tamminen

